#define START_MISION_DEBUG 0



/*
tipos de misiones/acciones/desarrollo:  
1 ir a un lugar andando (tx, ty)							gtaMisionCheckWalkPosition   (comprueba que el prota se encuentra en ese tile)
2 ir a un lugar en coche (tx, ty)							gtaMisionCheckDriverPosition   (comprueba que el prota se encuentra en ese tile pero llevando un coche)
3 crear personaje en mapa (tx, ty, idperCoche)				gtaMisionCreateNPC          (crea el NPC indicado en la posicion indicada, tambien se puede usar para crear un coche)
4 quitar un personaje de la lista de objetos (idper)		gtaMisionDestroyNPC         (busca si existe el NPC indicado y se lo peta)
5 personaje va andando a un punto del escenario (tx,ty,idper)  gtaMisionNPCWalkPoint    (busca el NPC indicado y le ajusta la velocidad hacia el tile indicado hasta que llegue)
6 personaje te sigue andando (idper)						gtaMisionNPCFollowPlayerWalk    (el NPC empieza a seguirte hasta que se indique un gtaMisionNPCWalkPoint sobre el mismo)
7 personaje se sube en tu coche, si no tienes coche te sigue andando (idper)	gtaMisionNPCFollowPlayerCar   (el NPC te sigue y si estás en un coche y esta cerca se sube al coche)
8 personaje se baja de tu coche (idper)						gtaMisionNPCLeftCar			(si el NPC está en un coche, se baja de él)
9 bloquear movimiento jugador								gtaMisionLockPlayer        (activa algun flag para que el jugador no se pueda mover)
10 desbloquear movimiento jugador							gtaMisionUnlockPlayer        (desactiva el flag anterior para que el jugador pueda volver a moverse)
11 ir a asesinar a un personaje (idPerCoche)                gtaMisionTarget             (rellena las variables misionTargetObjNPC para saber a quien hay que matar y espera hasta que te lo cargues)
12 carrera checkpoints (coche1, coche2, tx1, ty1, ...., txN, tyN)           gtaMisionRace          (prepara los coches de la carrera y crea el objeto que organiza la carrera)
13 setear temporizador (ticks low,ticks high) la mision se debe acabar antes de que llegue a 0      gtaMisionCreateTempo    (setea el temporizador 2 bytes que ira bajando en el gamecontroller, si llega a cero y aun no se ha acabado la mision actual te matan)
14 quitar temporizador, cuando se acaba la mision           gtaMisionDestroyTempo       (quita el temporizador cuando ya no hace falta)
15 robar o coger algo (tx, ty,  tipo item)                  gtaMisionCreateItem         (crea un objeto item en el lugar indicado y espera a que el jugador llegue a cogerlo)
16 dar esquinazo al enemigo (idcoche)                       gtaMisionEscape             (comprueba si estamos lo suficientemente lejos del idcoche como para considerar que le hemos dado esquinazo)
17 conversacion con personaje (idper1,frptr1,....,idperN,frptrN,0)      gtaMisionConversation  (va generando una conversación)
18 esperar al temporizador                                  gtaMisionWaitTempo          (espera a que el temporizador llegue a 1, y en ese momento lo desactiva y continua con la mision sin que te maten)
19 hacer que un personaje te ataque (idPer/idCar)           gtaMisionAttackMe           (hace que el id de personaje te ataque ya sea andando o en coche)
20 hacer que un personaje huya (idPer/idCar)                gtaMisionEscapeMe           (hace que el personaje huya de ti)
21 generar un poli para que te siga                         gtaMisionPoliceToMe         (crea un coche de poli cerca y hace que te siga)
22 prota tiene que subirse en un coche (idPerCoche)			gtaMisionGetCar				(el prota tiene que pillar ese coche, si id es cero, el prota puede pillar cualquier coche)
23 cambiar estado cabreo grupo (idGrupoNPC, nuevoEstado)    gtaHateMeGroup              (cambia el cabreo de un grupo de NPC, por ejemplo cabrear a los polis)
24 cambiar estado de un item de arma (idItem, nuevoEstado)  gtaWeaponItemState          (cambia el estado de un item de arma para que se pueda pillar de nuevo o no)
25 ir a un lugar andando o en coche                         gtaMisionCheckPosition      (comprueba que el prota este en un lugar concreto, da igual como)
26 crear un NPC coche y ponerle conductor                   gtaMisionCreateNPCanddriver (igual que gtaMisionCreateNPC pero antes de seguir le pone conductor al coche)
253 habilitar una mision (idMision)                         gtaMisionEnable             (cambia el estado de una mision a enabled)
254 finalizar la mision y empezar una nueva (idMision)      gtaMisionNext               (finaliza mision actual y va a la siguiente)
255 finalizar mision (la hemos hecho)                       gtaMisionEnd                (da por finalizada la mision actual)
255 finalizar la partida                     				gtaMisionEndGame                (da por finalizada la partida porque te hayas muerto o porke te lo hayas pasao)
*/



//por simplificar no podremos hacer dos misiones al mismo tiempo, y si no estamos haciendo ninguna mision tendremos misionActual a 255 y misionActualPtr a 0
//una vez habilitada una mision (misionState[X]==1) entonces tendremos que ir al objeto misionStartPoint concreto y se activará la mision (si no esta habilitada no pasara nada)
//tambien una mision puede activar e incluso dar comienzo a otra al acabar
/*
cocineros: todo blanco, sombrero de cocinero, furgona con la bandera de italia
aliens: ropa random pero la cabeza tocha de un alien, los coches pueden ser sedan con alas a modo de nave espacial?
polis: todo azul, gorro de poli y placa porra, usan sus coches
burguers: todo vestido rojo, con un sombrero hamburguesa y sus coches son suv con una burguer en el techo
agentes de la SEA todo negro con sobrero negro y suvs/furgonetas negras
*/
//configuraciones de personajes especiales de los NPCs concretos
#define NPC_POLICE 1
#define NPC_ARCADE 2
#define NPC_DON_LUCA 3
#define NPC_BURGUER 4
#define NPC_ALIEN 5
#define NPC_SEA 6


#define NPC_MUM 9
#define NPC_BRO 10
#define NPC_BRO_FRIEND 11
#define NPC_RACE_ORGANIZER 12
#define NPC_RACER_DRIVER 13
#define NPC_MASTER 14
#define NPC_BOSS_DON_LUCA 15
#define NPC_LAST_BOSS 16


#define CAR_POLICE 17
#define CAR_ARCADE 18
#define CAR_DON_LUCA 19
#define CAR_BURGUER 20
#define CAR_ALIEN 21
#define CAR_SEA 22

#define CAR_FAMILY 23

#define CAR_RACE_1 24
#define CAR_RACE_2 25

//no es un NPC pero bueno, es para indicar que es la prota el que habla
#define NPC_PROTA 255


//ojo que esta esta definida en el main tambien
#define CAR_START_LIFE_MISION 120
#define PERSON_START_LIFE_MISION 40

//el numero de frames que vamos a bloquear el scroll tras una conversacion para que la camara no se vuelva loca mientras estamos hablando
#define NUMERO_FRAMES_SCROLL_BLOQUEADO_TRAS_CONVERSACION 10

#define WEAPON_PUNO 0
#define WEAPON_NAVAJA 1
#define WEAPON_BATE 2
#define WEAPON_NUNCHUCK 3
#define WEAPON_KATANA 4
#define WEAPON_PISTOLA 5
#define WEAPON_SHOTGUN 6
#define WEAPON_GRANADA 7
#define WEAPON_BAZOKA 8
#define ITEM_BOX 16
#define ITEM_TNT 17

void gtaSetAnimWalkIX();
void gtaSetAnimFallIX();

//si esta variable esta a 1, se deja de sacar NPCs para que no se acumulen, es simplemente un truco para las misiones donde hay mucha tralla de enemigos que no se acumulen demasiados
u8 relaxNPCs;

//configuraciones de que coche es cada NPC de coches (osea los NPC del 17 en adelante)
const u8 configCarsType[]={
2,  	 	//CAR POLICE  
6,			//CAR ARCADE	viper
4,			//CAR DON LUCA  furgona
1,				//CAR BURGUER sedan warro
1,				//CAR ALIEN  sedan warro
5,				//CAR SEA  suv pepino
1,				//CAR FAMILY  sedan warro
6,              //CAR RACE 1  viper
6               //CAR RACE 2  viper
};   

const u8 configNPCCustomColor1[]={
CUSTOM_A_PAL_12|CUSTOM_B_PAL_4,     //POLICE
CUSTOM_A_PAL_9|CUSTOM_B_PAL_15,      //ARCADE BOY
CUSTOM_A_PAL_15|CUSTOM_B_PAL_15,    //DON LUCA BOY
CUSTOM_A_PAL_11|CUSTOM_B_PAL_9,     //BURGUER BOY
CUSTOM_A_PAL_8|CUSTOM_B_PAL_8,      //CINEMA BOY (alien)
CUSTOM_A_PAL_0|CUSTOM_B_PAL_0,      //SEA AGENT
0,                                  //7
0,                                  //8
CUSTOM_A_PAL_5|CUSTOM_B_PAL_13,		//MUM
CUSTOM_A_PAL_0|CUSTOM_B_PAL_9,		//BRO
CUSTOM_A_PAL_0|CUSTOM_B_PAL_11,		//BRO_FRIEND
CUSTOM_A_PAL_0|CUSTOM_B_PAL_0,		//RACE_ORGANIZER
CUSTOM_A_PAL_0|CUSTOM_B_PAL_0,		//RACE_DRIVER
CUSTOM_A_PAL_6|CUSTOM_B_PAL_6,		//MASTER    (super cauldron)
CUSTOM_A_PAL_0|CUSTOM_B_PAL_0,		//BOSS_DON_LUCA
CUSTOM_A_PAL_0|CUSTOM_B_PAL_0,		//LAST_BOSS


CUSTOM_A_PAL_0|CUSTOM_B_PAL_15,		//CAR POLICE
CUSTOM_A_PAL_5|CUSTOM_B_PAL_0,		//CAR ARCADE RACER
CUSTOM_A_PAL_12|CUSTOM_B_PAL_4,	     //CAR DON LUCA
CUSTOM_A_PAL_11|CUSTOM_B_PAL_9,		//CAR BURGUER
CUSTOM_A_PAL_4|CUSTOM_B_PAL_0,		//CAR ALIEN
CUSTOM_A_PAL_0|CUSTOM_B_PAL_0,		//CAR SEA
CUSTOM_A_PAL_13|CUSTOM_B_PAL_5,		//CAR FAMILY

CUSTOM_A_PAL_14|CUSTOM_B_PAL_15,		//CAR RACE 1
CUSTOM_A_PAL_9|CUSTOM_B_PAL_0		//CAR RACE 2
};

const u8 configNPCType[]={
TYPE_CITIZEN|TYPE_MAN,      //POLICE
TYPE_CITIZEN|TYPE_MAN,      //ARCADE BOY
TYPE_CITIZEN|TYPE_MAN,      //DON LUCA BOY
TYPE_CITIZEN|TYPE_MAN,      //BURGUER BOY
TYPE_CITIZEN|TYPE_MAN,      //CINEMA BOY
TYPE_CITIZEN|TYPE_MAN,      //SEA AGENTE
0,                          //7
0,                          //8
TYPE_CITIZEN,				//MUM
TYPE_CITIZEN|TYPE_MAN,      //BRO
TYPE_CITIZEN|TYPE_MAN,      //BRO_FRIEND
TYPE_CITIZEN,               //RACE_ORGANIZER
TYPE_CITIZEN|TYPE_MAN,      //RACE_DRIVER
TYPE_CITIZEN|TYPE_MAN,	    //MASTER
TYPE_CITIZEN|TYPE_MAN,      //BOSS_DON_LUCA
TYPE_CITIZEN|TYPE_MAN,      //LAST_BOSS

TYPE_CAR,				//CAR POLICE
TYPE_CAR,				//CAR ARCADE
TYPE_CAR,				//CAR DON LUCA
TYPE_CAR,				//CAR BURGUER
TYPE_CAR,				//CAR ALIEN
TYPE_CAR,				//CAR SEA
TYPE_CAR,				//CAR FAMILY
TYPE_CAR,				//CAR RACE 1
TYPE_CAR				//CAR RACE 2
};        //puede ser un coche TYPE_CAR o un ciudadano TYPE_CITIZEN y se le puede agregar TYPE_MAN








//la anim del pelo en caso de un NPC, o la superposicion de un coche en caso de tenerla, 0 si no queremos nada ahi (calvo o sin pegatina de coche)
u8* const configNPCAnimation2[]={
(u8*)animHairWalkPoli,          //POLICE
(u8*)animHairWalkGorra,         //ARCADE BOY
(u8*)animHairWalkCocinero,      //DON LUCA BOY
(u8*)animHairWalkBurguer,       //BURGUER BOY
(u8*)animHairWalkAlien,         //CINEMA BOY alien
(u8*)animHairWalkSombrero,      //SEA AGENT
0,                              //7
0,                              //8
(u8*)animHairWalkLargo,         //MUM
(u8*)animHairWalkSimple,        //BRO
(u8*)animHairWalkAfro,          //BRO FRIEND
(u8*)animHairWalkAfro,          //RACE ORGANIZER
(u8*)animHairWalkPunk,          //RACE DRIVER
(u8*)animHairWalkAfro,              //MASTER   (super cauldron)
//(u8*)animHairWalkGorroMaster,     //MASTER   (super cauldron)
(u8*)0,                         //BOSS DON LUCA
(u8*)animHairWalkLargo,         //LAST BOSS

(u8*)0,				//COCHES  police
(u8*)animArcadeViper,             //arcade
(u8*)animDonLucaFurgo,                 //don luca
(u8*)animBurguerSedan,                                 //burguer
(u8*)animAlienSedan,                                 //alien
(u8*)animSEAsuv,                        //SEA
(u8*)0,
(u8*)0,         //RACE 1
(u8*)0          //RACE 2
};

const u8 configNPCCustomColor2[]={
0,                                  //POLICE
0,                                  //ARCADE BOY
0,                                  //DON LUCA BOY
0,                                  //BURGUER BOY
0,                                  //CINEMA BOY alien
0,                                  //SEA AGENT
0,                                  //7
0,                                  //8
CUSTOM_A_PAL_8|CUSTOM_B_PAL_8,      //MUM
CUSTOM_A_PAL_11|CUSTOM_B_PAL_11,    //BRO
CUSTOM_A_PAL_9|CUSTOM_B_PAL_9,      //BRO FRIEND
CUSTOM_A_PAL_0|CUSTOM_B_PAL_0,      //RACE ORGANIZER
CUSTOM_A_PAL_10|CUSTOM_B_PAL_10,    //RACE DRIVER
CUSTOM_A_PAL_9|CUSTOM_B_PAL_9,    //MASTER
0,                                  //BOSS DON LUCA
CUSTOM_A_PAL_4|CUSTOM_B_PAL_4,      //LAST BOSS

0,									//COCHES
0,
0,
0,
0,
0,
0,
0,
0
};



const u8 configNPCweaponSelected[]={
WEAPON_PISTOLA,          //POLICE
WEAPON_KATANA,         //ARCADE BOY
WEAPON_NAVAJA,      //DON LUCA BOY
WEAPON_BATE,       //BURGUER BOY
WEAPON_PUNO,         //CINEMA BOY alien
WEAPON_SHOTGUN,      //SEA AGENT
0,                              //7
0,                              //8
WEAPON_PISTOLA,         //MUM
WEAPON_PISTOLA,        //BRO
WEAPON_KATANA,          //BRO FRIEND
WEAPON_BATE,          //RACE ORGANIZER
WEAPON_PUNO,          //RACE DRIVER
WEAPON_PUNO,     //MASTER   (super cauldron)
WEAPON_GRANADA,                         //BOSS DON LUCA
WEAPON_BAZOKA         //LAST BOSS
};




#define mCheckWalkPosition 0
#define mCheckDriverPosition 1
#define mCreateNPC 2
#define mDestroyNPC 3
#define mNPCWalkPoint 4
#define mNPCFollowPlayerWalk 5
#define mNPCFollowPlayerCar 6
#define mNPCLeftCar 7
#define mLockPlayer 8
#define mUnlockPlayer 9
#define mTarget 10
#define mRace 11
#define mCreateTempo 12
#define mDestroyTempo 13
#define mCreateItem 14
#define mEscape 15
#define mConversation 16
#define mWaitTempo 17
//#define mAttackMe 18
//#define mEscapeMe 19
#define mStopRelaxNPCs 18
#define mRelaxNPCs 19
#define mGetCar 20
#define mHateMeGroup 21
#define mWeaponItemState 22
#define mCheckPosition 23
#define mCreateNPCanddriver 24
#define mIdle5 25
#define mEnable 26
#define mNext 27
#define mEnd 28
#define mEndGame 29


//saca la conversacion de estar muerto y acaba el juego
const u8 misionDie[]={
mConversation,NPC_PROTA,20,
mEndGame
};


//tiene lo que se debe hacer en cada mision, 255 es mision finalizada
/* 0- apareces al lado del coche de tu hermano y sale tu hermano al lado tambien. hay una conversación
- (bro) bienvenida a casa hermana.
sale madre de la casa
- (madre) bienvenida hija, acompaña a tu hermano  */

const u8 mision0[]={
mCreateNPC,75,124,CAR_FAMILY,
mCreateNPC,78,122,NPC_BRO,
mConversation,NPC_BRO,17,
mCreateNPC,75,117,NPC_MUM,
mNPCWalkPoint,75,122,NPC_MUM,
mConversation,NPC_MUM,18,
mNPCWalkPoint,75,117,NPC_MUM,
mDestroyNPC,NPC_MUM,
mNext,1}; 



/*
1- madre vuelve a casa, 
- (bro) estoy cansado, ¿Puedes conducir?
prota tiene que ir a coche
bro se monta en coche
prota tiene que ir a casa de amigo

- cuando llega, sale amigo, bro se baja del coche
- (amigo) oye quien es la nueva?
- (bro) no te pases, es mi hermana
- (amigo) ok, aquí tienes el paquete
- (prota) que es eso?
- (bro) blanca, en polvo y muy adictiva, azucar. 
- (bro) azucar es lo más importante en la ciudad
prota se monta en coche, bro se monta en el coche, tiramos pa casa, todos se bajan del coche
- (bro) este es el negocio familiar, tendrás que ayudarnos*/

const u8 mision1[]={
mConversation,NPC_BRO,19,
mNPCFollowPlayerCar,NPC_BRO,
mGetCar,CAR_FAMILY,
mCheckDriverPosition,180,188,
mCheckWalkPosition,180,185,
mCreateTempo,25,0,         //lowhigh tempo
mWaitTempo,
mCreateNPC,180,181,NPC_BRO_FRIEND,
mNPCWalkPoint,180,184,NPC_BRO_FRIEND,
mConversation,NPC_BRO_FRIEND,25,
mConversation,NPC_BRO,26,
mConversation,NPC_BRO_FRIEND,27,
mConversation,NPC_PROTA,28,
mConversation,NPC_BRO_FRIEND,29,
mConversation,NPC_BRO,30,
mConversation,NPC_BRO,31,
mNPCWalkPoint,180,180,NPC_BRO_FRIEND,
mDestroyNPC,NPC_BRO_FRIEND,
mGetCar,CAR_FAMILY,
mCheckDriverPosition,76,123,
mNPCLeftCar,NPC_BRO,
mNPCWalkPoint,75,117,NPC_BRO,
mConversation,NPC_BRO,32,
mDestroyNPC,NPC_BRO,
mNext,2}; 







/*2- (amigo) PHONE: hola Sarah, tu hermano me dijo que contase contigo, 
- (amigo) me puedes llevar al parque?
- (prota) ok, no hay problema

-llegas a la casa de amigo, se sube al coche
lo llevas al parque y el amigo se baja
- (amigo) gracias, sugar city es un poco peligrosa
- (amigo) hay bandas que quieren conseguir todo el azucar
- (amigo) y son muy violentos, ten cuidado
*/

const u8 mision2[]={
    mWeaponItemState,WEAPON_NAVAJA,0,
    mWeaponItemState,WEAPON_BATE,0,
    mWeaponItemState,WEAPON_NUNCHUCK,0,
    mCreateTempo,0,3,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,180,181,NPC_BRO_FRIEND,
    mConversation,NPC_BRO_FRIEND,33,
    mConversation,NPC_BRO_FRIEND,34,
    mCheckPosition,180,187,
    mNPCFollowPlayerCar,NPC_BRO_FRIEND,
    mCheckDriverPosition,46,162,
    mNPCLeftCar,NPC_BRO_FRIEND,
    mConversation,NPC_BRO_FRIEND,35,
    mConversation,NPC_BRO_FRIEND,36,
    mConversation,NPC_BRO_FRIEND,37,
    mNPCWalkPoint,60,162,NPC_BRO_FRIEND,
    mDestroyNPC,NPC_BRO_FRIEND,
mNext,3};




/*
3- (mum) PHONE: ven a casa,tenemos trabajo
tienes que pillar un coche
ir a casa
(mum) a don luca le ha llegado un cargamento
(mum) lo vamos a interceptar, vamos
se monta la madre
creas item de caja al lado de un restaurante
vas a alguno de los don luca
recoges la caja
(mum) rapido, vamonos
aparecen varios de don luca cabreados
y tienes que salir por patas
llegas a casa 
(mum) puff estuvo cerca  */

const u8 mision3[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,75,117,NPC_MUM,
    mConversation,NPC_MUM,38,
    mGetCar,0,
    mCheckDriverPosition,76,123,
    mNPCWalkPoint,75,120,NPC_MUM,
    mConversation,NPC_MUM,39,
    mCreateItem,124,184,ITEM_BOX,
    mNPCFollowPlayerCar,NPC_MUM,
    mRelaxNPCs,
    mCheckDriverPosition,124,188,
    mCheckWalkPosition,124,184,
    mHateMeGroup,NPC_DON_LUCA,2,
    mCreateNPCanddriver,113,196,CAR_DON_LUCA,
    mCreateNPCanddriver,153,200,CAR_DON_LUCA,
    mConversation,NPC_MUM,40,
    mEscape,CAR_DON_LUCA,
    mGetCar,0,
    mDestroyNPC,CAR_DON_LUCA,
    mDestroyNPC,CAR_DON_LUCA,
    mStopRelaxNPCs,
    mCheckDriverPosition,76,123,
    mNPCLeftCar,NPC_MUM,
    mNPCWalkPoint,75,117,NPC_MUM,
    mConversation,NPC_MUM,41,
    mDestroyNPC,NPC_MUM,
    mWeaponItemState,WEAPON_KATANA,0,
    mWeaponItemState,WEAPON_PISTOLA,0,
    
    mNext,4}; 






/*

4- (amigo) un amigo necesita un coche burguer
creamos un coche burguer en algun sitio y vamos hacia alli
lo robamos
(amigo) perfecto, vamos
cabreamos a los burguers
y aparecen 2 burguers cerca andando a pegarnos
(amigo) perfecto, aparca aqui
*/

const u8 mision4[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,180,181,NPC_BRO_FRIEND,
    mConversation,NPC_BRO_FRIEND,43,
    mCheckDriverPosition,180,186,
    mCreateNPC,195,44,CAR_BURGUER,
    mNPCFollowPlayerCar,NPC_BRO_FRIEND,
    mCheckPosition,195,49,
    mGetCar,CAR_BURGUER,
    mConversation,NPC_BRO_FRIEND,44,
    mHateMeGroup,NPC_BURGUER,2,
    mCreateNPCanddriver,196,60,CAR_BURGUER,
    mEscape,CAR_BURGUER,
    mCheckDriverPosition,35,219,
    mNPCLeftCar,NPC_BRO_FRIEND,
    mConversation,NPC_BRO_FRIEND,45,
    mCheckWalkPosition,39,219,
    mNPCWalkPoint,53,222,NPC_BRO_FRIEND,
    mDestroyNPC,NPC_BURGUER,
    mDestroyNPC,NPC_BURGUER,
    mDestroyNPC,NPC_BRO_FRIEND,
    mWeaponItemState,WEAPON_SHOTGUN,0,
    mNext,5
};




/* 5- (bro) PHONE: ven al centro comercial
vas a recogerlo
- (bro) tengo las palomitas, rapido vamonos
cabreas los frikis
lo llevas a su casa*/


const u8 mision5[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,128,216,NPC_BRO,
    mConversation,NPC_BRO,46,
    mCheckDriverPosition,128,219,
    mConversation,NPC_BRO,47,
    mHateMeGroup,NPC_ALIEN,2,
    mCreateNPC,115,219,NPC_ALIEN,
    mCreateNPC,140,219,NPC_ALIEN,
    mNPCFollowPlayerCar,NPC_BRO,
    mCheckDriverPosition,76,122,
    mNPCLeftCar,NPC_BRO,
    mNPCWalkPoint,75,117,NPC_BRO,
    mDestroyNPC,NPC_BRO,
    mDestroyNPC,NPC_ALIEN,
    mDestroyNPC,NPC_ALIEN,
    mWeaponItemState,WEAPON_GRANADA,0,
    mNext,6
};





/*
6- (amigo) PHONE: he visto que conduces bien
vas a recoger al amigo
(amigo) si ganamos hoy podremos hacer negocios
vas al sitio de la carrera
(amigo) solo hay una regla, gana la carrera
empieza la carrera, el primero que llega gana
(amigo) estupendo, sabia que ganarias
cabreas a los arcades
*/

const u8 mision6[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,180,181,NPC_BRO_FRIEND,
    mConversation,NPC_BRO_FRIEND,48,
    mCheckDriverPosition,180,186,
    mConversation,NPC_BRO_FRIEND,49,
    mNPCFollowPlayerCar,NPC_BRO_FRIEND,
    mCheckDriverPosition,36,56,
    mConversation,NPC_BRO_FRIEND,50,

    mRace,CAR_RACE_1, CAR_RACE_2, 86,55,   88,26,   154,26,   220,26,   219,52,   156,59,    147,124,  28,123,  24,92,  0,

    mConversation,NPC_BRO_FRIEND,51,
    mNPCLeftCar,NPC_BRO_FRIEND,
    mDestroyNPC,NPC_BRO_FRIEND,
    mDestroyNPC,CAR_RACE_1,
    mDestroyNPC,CAR_RACE_2,
    mNext,7
};

/*
7- 
(bro) hay un cargamento en el puerto
vas a recojer a bro
creamos item box en el puerto
vas al puerto al punto concreto
cabreas a los agentes de la SEA
y aparecen muchos agente de la SEA
(bro) rapido, agentes de la SEA
vuelves a casa
*/

const u8 mision7[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,75,28,NPC_BRO,
    mConversation,NPC_BRO,52,
    mCheckDriverPosition,85,28,
    mNPCFollowPlayerCar,NPC_BRO,
    mCreateItem,180,244,ITEM_BOX,
    mCheckDriverPosition,172,244,
    mCheckWalkPosition,180,244,
    mConversation,NPC_BRO,53,
    mHateMeGroup,NPC_SEA,2,
    mCreateNPCanddriver,80,236,CAR_SEA,
    mEscape,CAR_SEA,
    mDestroyNPC,CAR_SEA,
    mCheckDriverPosition,83,30,
    mNPCLeftCar,NPC_BRO,
    mNPCWalkPoint,75,24,NPC_BRO,
    mDestroyNPC,NPC_BRO,
    mNext,8
};

/*
8- (mum) PHONE: ve a por el caldero
vamos a ver al mago 
(sarah) que hace un mago como tu aqui?
(mago) reglas de la CPCRETRODEV
(sarah) cada año piden cosas más raras
ir a casa
(mum) cocinare la bomba para don luca

*/

const u8 mision8[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,75,117,NPC_MUM,
    mConversation,NPC_MUM,54,
    mCheckDriverPosition,108,57,
    mCreateNPC,97,52,NPC_MASTER,
    mNPCWalkPoint,102,56,NPC_MASTER,
    mConversation,NPC_PROTA,55,
    mConversation,NPC_MASTER,56,
    mConversation,NPC_PROTA,57,
    mCheckDriverPosition,75,121,
    mDestroyNPC,NPC_MASTER,
    mConversation,NPC_MUM,58,
    mDestroyNPC,NPC_MUM,
    mNext,9
};

/*
9- (bro) VAMOS A MANDAR UN MENSAJE A SEA
ve a por el bazoka
vas a la sede de la SEA
revienta coche de la SEA en la sede
salen SEA por todos lados, huye
*/

const u8 mision9[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mWeaponItemState,WEAPON_BAZOKA,0,
    mCreateNPC,234,35,NPC_BRO,
    mConversation,NPC_BRO,59,
    mDestroyNPC,NPC_BRO,
    mCheckPosition,196,105,
    mCreateNPC,75,230,CAR_SEA,
    mCheckPosition,76,220,
    mTarget,CAR_SEA,
    mCreateNPCanddriver,140,236,CAR_SEA,
    mEscape,CAR_SEA,
    mDestroyNPC,CAR_SEA,
    mNext,10
};

 
/*
10- (mum) ok llego la hora
(mum) lleva la bomba a don luca
(mum) cuidado a la vuelta
ve en la lancha a la casa de don luca
instala la bomba en la puerta
se enciende el crono
vuelve a casa
*/

const u8 mision10[]={
    mCreateTempo,0,1,         //lowhigh tempo
    mWaitTempo,
    mCreateNPC,75,122,NPC_MUM,
    mConversation,NPC_MUM,60,
    mCreateItem,18,244,ITEM_TNT,
    mCheckPosition,18,244,
    mConversation,NPC_MUM,61,
    mDestroyNPC,NPC_MUM,
    mCheckPosition,180,113,
    mCreateItem,180,109,ITEM_TNT,
    mCreateNPCanddriver,156,123,CAR_SEA,
    mCreateNPCanddriver,173,123,CAR_POLICE,
    mCreateNPCanddriver,184,123,CAR_ARCADE,
    mCreateNPCanddriver,200,123,CAR_BURGUER,
    mCreateTempo,0,4,         //lowhigh tempo
    mWaitTempo,
    mEndGame
};






//el hateLevel[0] se queda en reserva para otros menesteres
//el hateLevel[1] es el nivel de busqueda de la policia en funcion de cuanto la estes liando (si dejas de liarla baja un poco)
//el resto 1-x es el nivel de cabreo de cada NPC (hateLevel[1] poli, hateLevel[2] arcade, hateLevel[3] don luca,etc... )
// si es 0 pasarán de ti como si no existieras
// si es 1 y empujas a uno o le pegas ira a por ti directamente
// si es 2 (o más) conforme aparezca ira a por ti sin pensarselo
//se puede cambiar con gtaHateMeGroup
const u8 hateLevel[8];


//este array indica si el item de esa arma ya la hemos recogido o no
//en caso de haberla recogido, se desactiva la colision y el draw para que ni se vea ni se pueda coger
//pero no se elimina el objeto, de esta forma no se vuelve a crear otra vez
//const u8 itemYaRecogido[]={0,0,0,0,0,0,0,0,0,0};  
//BC40+16 del restauraluces  (coje 16 bytes)
#define ITEM_YA_RECOGIDO 0xBC50


#define MAX_MISIONES 10





//u8* misionTargetObjNPC;		//puntero al objeto del NPC que hay que liquidar 
//u8* misionTargetObjCar;		//puntero al coche del NPC que hay que destruir
u8 misionTargetTileX;       //al tile X al que deberia ir el prota   (si tenemos que matar a alguien o seguir a algun coche tambien se rellenarán estas variables de forma dinamica)
u8 misionTargetTileY;       //al tile Y al que deberia ir el prota

u8 misionActual;			//esto tendrá 0,1,2 etc para situarse en misionList cuando se acabe una mision  (si es 255 no hay ninguna mision activa)
u8* misionActualPtr;		//esto tendrá el puntero de misionX por donde vamos ejecutando esa mision, si nos matan durante la mision se debe volver al principio de la mision
u16 misionTemporizador;         //aqui tendremos el temporizador, que si es mayor que cero ira bajando, si llega a 0 hemos fracasado en la mision


//tiene los punteros a las misiones concretas
u8* const misionList[]={(u8*)mision0,(u8*)mision1,(u8*)mision2,(u8*)mision3,(u8*)mision4,
            (u8*)mision5,(u8*)mision6,(u8*)mision7,(u8*)mision8,(u8*)mision9,(u8*)mision10};

//tiene el estado de cada mision (0- mision deshabilitada (aun no se puede hacer), 1- mision habilitada (si se va al punto de comienzo de la mision y la misionActual=255 entonces empieza la mision), 2- mision ya realizada (ya la hemos hecho))
//u8 misionState[MAX_MISIONES];


//un array con todas las funciones posibles a usar en las misiones, el numero al que apunte misionActualPtr se correspondera con una posicion de este array,
//el juego llamará a esa función, y dentro de esa funcion se leerán los parametros (si es que los necesita) usando el misionActualPtr y avanzandolo hasta la
//siguiente acción (si es que se cumple el objetivo) o dejando el puntero en el mismo sitio de entrada (si no se cumple el objetivo)
void* const misionFuncs[]={
gtaMisionCheckWalkPosition,             //0
gtaMisionCheckDriverPosition,
gtaMisionCreateNPC,
gtaMisionDestroyNPC,
gtaMisionNPCWalkPoint,
gtaMisionNPCFollowPlayerWalk,
gtaMisionNPCFollowPlayerCar,
gtaMisionNPCLeftCar,
gtaMisionLockPlayer,
gtaMisionUnlockPlayer,
gtaMisionTarget,                        //10
gtaMisionRace,
gtaMisionCreateTempo,
gtaMisionDestroyTempo,
gtaMisionCreateItem,
gtaMisionEscape,
gtaMisionConversation,
gtaMisionWaitTempo,
//gtaMisionAttackMe,
//gtaMisionEscapeMe,
gtaMisionStopRelaxNPCs,
gtaMisionRelaxNPCs,
gtaMisionGetCar,                          //20
gtaHateMeGroup,
gtaWeaponItemState,                     //22
gtaMisionCheckPosition,
gtaMisionCreateNPCanddriver,            //24
gtaMisionIdle,
gtaMisionEnable,
gtaMisionNext,
gtaMisionEnd,                            //28
gtaMisionEndGame						//29
};



void gtaMisionResetAll() __naked {
    __asm
        xor a
        ld (#_misionTargetTileX),a

        ld hl,#ITEM_YA_RECOGIDO
        ld b,#16     
        ld a,#1
    gtaMisionResetAllBucITEM:
        ld (hl),a
        inc hl
        djnz gtaMisionResetAllBucITEM


        ld hl,#_hateLevel
        ld b,#8     //el hatelevel tiene 8 valores
        xor a
    gtaMisionResetAllBucHate:
        ld (hl),a
        inc hl
        djnz gtaMisionResetAllBucHate


        /*ld hl,#_misionState
        ld b,#MAX_MISIONES-1
        ld (hl),#1
        inc hl
        xor a
    gtaMisionResetAllBuc:
        ld (hl),a
        inc hl
        djnz gtaMisionResetAllBuc*/

        xor a
        dec a       //A=255                 //y ahora hago que empiece la mision 0 que es de intro
        ld (#_misionActual),a
        ld a,#START_MISION_DEBUG              //KABESON PARA DEBUGS
        //inc a           //A=0
        call _gtaMisionStart
        ret
    __endasm;
}


//este metodo comprueba si estas en la posicion pero da igual que vayas andando o en coche, solo mira que estes ahi
void gtaMisionCheckPosition() __naked {
    __asm
        ld ix,#GAME_OBJECTS_PTR
        jp gtaMisionCheckWalkPositionSub
    __endasm;
}

void gtaMisionCheckWalkPosition() __naked {
    __asm
	    ld ix,#GAME_OBJECTS_PTR
	    ld a,OBJ_PARENT_PTR+1(ix)
	    or a
	    ret NZ		//si va en coche salgo y sigo mirando
    
    gtaMisionCheckWalkPositionSub:
	    ld hl,(#_misionActualPtr)
	    inc hl
	    ld a,(hl)		//leo tile X
        ld (#_misionTargetTileX),a
        ld d,a

	    inc hl
	    ld a,(hl)		//leo tile y
        ld (#_misionTargetTileY),a
        ld e,a
	    
	    
	    ld a,OBJ_POSX+1(ix)
	    sub d
        inc a
        inc a
        cp #4           //miro que este entre -1 y 1 de diferencia para tener 3 tiles de margen
	    jr NC,gtaMisionCheckWalkPositionBack
	    
	    ld a,OBJ_POSY+1(ix)
	    sub e
        inc a
        inc a
        cp #4           //miro que este entre -1 y 1 de diferencia para tener 3 tiles de margen
	    jr NC,gtaMisionCheckWalkPositionBack
	    
	    //si llego aqui estoy en el sitio correcto, avanzo y paso a siguiente instruccion
	    inc hl
	    ld (#_misionActualPtr),hl

        xor a               //reseteo el misionTargetTileX
        ld (#_misionTargetTileX),a
        ld (#_misionTargetTileY),a

        ret
        
     gtaMisionCheckWalkPositionBack:
     	dec hl		//no coincide, vuelvo y que siga mirando
     	dec hl
     	ld (#_misionActualPtr),hl
     	ret
    __endasm;
}


void gtaMisionCheckDriverPosition() __naked {
    __asm
	    ld ix,#GAME_OBJECTS_PTR
	    ld a,OBJ_PARENT_PTR+1(ix)
	    or a
	    ret Z		//si voy andando salgo del tiron y me quedo mirando

        ld h,a
        ld l,OBJ_PARENT_PTR(ix)
        push hl 
        pop iy

        

        ld hl,(#_misionActualPtr)
        push hl
	    call gtaMisionCheckWalkPositionSub  //si voy en coche hago la misma comprobacion que si voy andando ya que es lo mismo
        pop hl 

        ld a,OBJ_CAR_SPEED(iy)      //solo voy a considerar que ha llegado al sitio si va despacio, sino pasando
        cp #6
        ret C                   //si resto 6 y hay carry perfecto, le hago caso a lo que haya hecho gtaMisionCheckWalkPositionSub

        //si no, recupero la mision para que en el siguiente frame vuelva a mirar si he llegado o no
        ld (#_misionActualPtr),hl

        ret

    __endasm;
}

void gtaMisionCreateNPCanddriver() __naked {
    __asm
        call _gtaMisionCreateNPC
        //y ahora en IX meto el conductor
        ld OBJ_PARENT_PTR(ix),#0xFF         //le pongo 255 y 255 en el puntero, esto es para que el coche tenga su propia IA sin necesidad de que vaya nadie montado
        ld OBJ_PARENT_PTR+1(ix),#0xFF       //si intento robar este coche, entonces ya creo un personaje en ese momento para que parezca que iba dentro (pero me ahorro un objeto)
        ret
    __endasm;
}

void gtaMisionCreateNPC() __naked {
    __asm
    	//va a crear un NPC en la posicion indicada
    	
    	//primero creamos un objeto, ya que si no podemos crear un objeto salimos del tiron sin avanzar la instruccion
		call _vtGetFreeGameObjPtr        //preparamos el objeto del prota
		ld ix,(#_vtGameObjPtr)

		// SAFE_GET_FREE
		/*xor a       //hago una comprobacion rapida por si no hubiese sitio para meter más instancias en el engine
		.dw #0xB4DD    //or ixh      //simplemente hago 0 or IXH (que tiene que ser 0xB5 o por ahi), si el or da Zero es que no hubo espacio para agregarlo, podemos eliminarlo
		ret Z		//si es cero salgo del tiron sin hacer nada y dejo el misionActualPtr en el mismo sitio, para que el siguiente frame se vuelva a intentar
*/
		//si llego aqui he podido crear el objeto, ahora le seteo todo lo necesario
    	
    	ld hl,(#_misionActualPtr)
    	inc hl		//leemos tilex y tiley en DE
    	ld d,(hl)
    	inc hl
    	ld e,(hl)
		push hl		//me guardo HL para continuar despues
    	

		//IX el objeto y DE debe tener el posX y posY (en tiles) donde se va a crear
		call _gtaConfigRandomPerson
		
		pop hl		//recupero HL
		
		inc hl
		ld a,(hl)		//leo el NPC que voy a configurar
		inc hl
		ld (#_misionActualPtr),hl		//vuelvo a guardar misionActualPtr apuntando ya a la siguiente instruccion
		
		//y ahora por ultimo seteo todo lo necesario del NPC (que tengo en A, usando el objeto IX)
		call _gtaConfigNPC
    
        //le agregamos el flag de no destroy
        set 6,OBJ_FLAGS(ix)     //le agrego el FLAG_NO_DESTROY, para que no se lo cargue cuando salgamos de la pantalla

        ret
    __endasm;
}

void gtaMisionDestroyNPC() __naked {
    __asm
        ld hl,(#_misionActualPtr)
    	inc hl		//leemos que id de NPC nos tenemos que cargar
    	ld c,(hl)       //dejo en C el id del que me tengo que cargar
        inc hl      //y pasamos a la siguiente instruccion y guardamos el puntero
        ld (#_misionActualPtr),hl   

        ld ix,#GAME_OBJECTS_PTR     //vamos a recorrer todos los objetos y el que tenga OBJ_ID_NPC_CAR=C nos lo cargamos (le pongo OBJ_ID_NPC_CAR a 255 para que haga el step y se elimine y asi se borra el muñeco)
	    ld b,#16
        ld de,#48
        
    gtaMisionDestroyNPCBucle:
        ld a,OBJ_ID_NPC_CAR(ix)
        cp c
        jr NZ,gtaMisionDestroyNPCBucleFin

        //es el que me quiero cargar
        ld OBJ_ID_NPC_CAR(ix),#255      //le hago la marca para que se elimine en el step (asi se borra bien de la pantalla), se eliminara en gtaPersonaIAStepFunc

    gtaMisionDestroyNPCBucleFin:
        add ix,de
        djnz gtaMisionDestroyNPCBucle

        ret
    __endasm;
}



void gtaMisionNPCWalkPoint() __naked {
    __asm

        ld hl,(#_misionActualPtr)
        push hl         //me guardo HL por si no ha llegado aun...
    	inc hl		
    	ld d,(hl)       //leo tileX
    	inc hl
    	ld e,(hl)       //leo tileY
        inc hl 
        ld c,(hl)       //leo el NPC
        inc hl 
        ld (#_misionActualPtr),hl       //guardo el puntero de la mision

		push de		//me guardo DE para continuar despues
        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando
        //aqui no deberia ser cero, pero bueno podría ocurrir?
        pop de 

        //ahora tengo que comprobar si IX ya está en el punto DE o no
        ld a,OBJ_POSX+1(ix)
        cp d
        jr NZ,gtaMisionNPCWalkPointGoto
        ld a,OBJ_POSY+1(ix)
        cp e
        jr NZ,gtaMisionNPCWalkPointGoto

        //si llego aqui el personaje ya esta donde quiero, lo unico que tengo que hacer es pasar a la siguiente instruccion
        pop de      //suelo HL de la pila y nos vamos

        ld hl,#_iaPersonRelajado                //dejo al NPC en relajado, que se quede ahi un rato y si luego se quiere ir que se vaya
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h
        ld OBJ_FRAMES_FOR_NEXT_STATE(ix),#200		//para que no cambie de estado rapido

        ret


    gtaMisionNPCWalkPointGoto:
        //aun no esta donde debe, recupero HL y hago que siga en esta instruccion
        pop hl 
        ld (#_misionActualPtr),hl

        //y ahora calculo la direccion que debo tomar para ir a D,E
        //la entrada es X=BC e Y=DE, y en A devuelve el angulo (256 based)
        ld l,OBJ_POSX(ix)
        ld h,OBJ_POSX+1(ix)
        ld b,d
        ld c,#0
        xor a
        sbc hl,bc
        ld b,h
        ld c,l      //dejo en BC la diferencia horizontal

        ld l,OBJ_POSY(ix)
        ld h,OBJ_POSY+1(ix)
        ld d,e
        ld e,#0
        xor a
        sbc hl,de
        ex de,hl        //dejo en DE la diferencia vertical

        call _vtAtan2_16        //calculo el angulo en A

        //voy al angulo contrario porque lo he calculado al reves
        add #128

        //y hago que IX vaya tirando para ese lugar
        ld c,#15
        ld b,#24
        call _vtAccelToSpeedAng		//ajusto la velocidad para que paya

        //y para que a la IA no se le vaya la pinza, le pongo que siga dando el paseito
        ld hl,#_iaPersonSiguiendoPunto
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h
        ld OBJ_FRAMES_FOR_NEXT_STATE(ix),#200		//para que no cambie de estado rapido


        call _gtaSetAnimWalkIX

        ret         //salgo y a ver si en el siguiente frame ya he llegado al lugar correcto
    __endasm;
}

void gtaMisionNPCFollowPlayerWalk() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        inc hl
        ld c,(hl)   //leo NPC que tiene que seguir al prota
        inc hl
        ld (#_misionActualPtr),hl       //es inmediata asi que paso a la siguiente instruccion

        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando (que va en C)

        ld hl,#_iaPersonSiguiendoProta      //le pongo la IA para que siga al prota
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h

        set 7,OBJ_FLAGS(ix)     //por seguridad le pongo que no colisione, ya que si colisiona puede cambiar la ani y deja de seguirnos

        call _gtaSetAnimWalkIX

        ret
    __endasm;
}



void gtaMisionNPCFollowPlayerCar() __naked {
    __asm
        call _gtaMisionNPCFollowPlayerWalk
        ld hl,#_iaPersonSiguiendoProtaSubeCoche      //le pongo la IA para que siga al prota
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h
        ret
    __endasm;
}

void gtaMisionNPCLeftCar() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        inc hl
        ld c,(hl)   //leo NPC que tiene que seguir al prota
        inc hl
        ld (#_misionActualPtr),hl       //es inmediata asi que paso a la siguiente instruccion

        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando (que va en C)

        xor a                       //se baja del coche
        ld OBJ_PARENT_PTR+1(ix),a
        ld OBJ_PARENT_PTR(ix),a

        ld hl,#_iaPersonSiguiendoPunto      //le pongo la IA que no haga nada, que se quee ahi quieta cojone
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h

        ret
    __endasm;
}

void gtaMisionLockPlayer() __naked {
    __asm
        /*ld hl,(#_misionActualPtr)
        inc hl
        ld (#_misionActualPtr),hl
        ld ix,#GAME_OBJECTS_PTR
        ld OBJ_IA_LOCK_MOVE(ix),#250        //le ponemos esto a 250 para bloquear al prota un buen rato  */
        ret
    __endasm;
}

void gtaMisionUnlockPlayer() __naked {
    __asm
        /*ld hl,(#_misionActualPtr)
        inc hl
        ld (#_misionActualPtr),hl
        ld ix,#GAME_OBJECTS_PTR
        ld OBJ_IA_LOCK_MOVE(ix),#0        //le ponemos esto a 250 para bloquear al prota un buen rato*/
        ret
    __endasm;
}

void gtaMisionTarget() __naked {
    __asm
        //aqui pueden ocurrir varias cosas,
        //primero buscamos el NPC o coche que tenemos que destruir
        //si existe, seteamos el misionTargetTileX y misionTargetTileY con la posicion del mismo y nos quedamos en la misma instruccion
        //si no existe, pasamos a la siguiente instruccion y seteamos a cero misionTargetTileX y misionTargetTileY
        ld hl,(#_misionActualPtr)
        inc hl
        ld c,(hl)
        inc hl
        push hl     //me guardo HL por si tengo que pasar a la siguiente instruccion

        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando (que va en C)

        //compruebo si IX existe o no
        ld de,#0xB7D0
        push ix 
        pop hl 
        xor a 
        sbc hl,de
        jr Z,gtaMisionTargetNoExiste

        //si entra aqui si existe, seteo la posicion a la que tengo que ir
        ld a,OBJ_POSX+1(ix)
        ld (#_misionTargetTileX),a
        ld a,OBJ_POSY+1(ix)
        ld (#_misionTargetTileY),a

        pop hl      //quitamos de la pila hl y nos quedamos en la misma instruccion hasta que elimine el NPC o el coche
        ret


    gtaMisionTargetNoExiste:
        pop hl                          //no existe el NPC, pasamos a la siguiente instruccion y ya
        ld (#_misionActualPtr),hl
        ret
    __endasm;
}



void gtaMisionRace() __naked {
    __asm
        //mRace,CAR_RACE_1, CAR_RACE_2, 86,55,   88,26,   220,26,   219,52,   156,59,    147,124,  28,123,  24,92,  0,
        //aqui hay que hacer varias cosas,
        //1º busco si existen los 2 coches de la carrera
        //2º si alguno no existe lo creo y le pongo la IA para que siga la carrera
        //3º compruebo si el prota, o alguno de los dos coches está cerca del ultimo punto de control
        ld a,(#raceStarted)
        or a
        jr NZ,gtaMisionRaceStarted

        
        
        //lo primero que hago es crear los dos corredores
        ld hl,(#_misionActualPtr)
		inc hl
		ld a,(hl)		//leo el NPC que voy a configurar
		call gtaMisionRaceCreaCorredores
        ld a,(#0xB500+OBJ_POSY+1)
        sub #5
        ld OBJ_POSY+1(ix),a
        ld (#raceIX1),ix

		inc hl
		ld a,(hl)		//leo el NPC que voy a configurar
        call gtaMisionRaceCreaCorredores
        ld a,(#0xB500+OBJ_POSY+1)
        add #5
        ld OBJ_POSY+1(ix),a
        ld (#raceIX2),ix

        inc hl      //me situo en el primer punto de control y se lo pongo a los 3 corredores
        ld (#racePuntoProta),hl
        ld (#racePuntoR1),hl
        ld (#racePuntoR2),hl
        
        ld a,#1                 //y pongo que ya se ha iniciao la carrera
        ld (#raceStarted),a

        //y pa fuera, en el siguiente frame entrara en gtaMisionRaceStarted y hara lo que hay que hacer
        ret


        




    gtaMisionRaceStarted:
        //si entra aqui tenemos que continuar la carrera hasta que alguien llegue a un punto de control que empiece por 0
        //primero seteo nuestro target para que el prota sepa pa donde tiene que tirar
        ld hl,(#racePuntoProta)
        ld a,(hl)
        ld d,a      //lo dejo en D
        ld (#_misionTargetTileX),a
        or a
        jp Z,gtaMisionRaceWin
        inc hl 
        ld a,(hl)
        ld e,a          //lo dejo en E
        ld (#_misionTargetTileY),a



        //compruebo si estoy cerca del punto para pasar al siguiente o no
        ld a,(#0xB500+OBJ_POSX+1)
        sub d
        bit 7,a
        jr Z,gtaMisionRaceStarteds2
        neg
    gtaMisionRaceStarteds2:
        cp #7
        jr NC,gtaMisionRaceStarteds6    //si no hay carry es que esta lejos, seguimos



        ld a,(#0xB500+OBJ_POSY+1)
        sub e
        bit 7,a
        jr Z,gtaMisionRaceStarteds3
        neg
    gtaMisionRaceStarteds3:
        cp #7
        jr NC,gtaMisionRaceStarteds6    //si no hay carry es que esta lejos, seguimos

        //si llego aqui, tengo que pasar al siguiente punto al prota porke ya está sobre este punto su coche
        inc hl 
        ld (#racePuntoProta),hl








    gtaMisionRaceStarteds6:
        //despues seteo el target para los otros dos jugadores
        ld ix,(#raceIX1)
        ld hl,(#racePuntoR1)
        call gtaMisionRaceCheckRacer
        ld (#racePuntoR1),hl
        

        ld ix,(#raceIX2)
        ld hl,(#racePuntoR2)
        call gtaMisionRaceCheckRacer
        ld (#racePuntoR2),hl






    gtaMisionRaceStarteds16:

        ret







    gtaMisionRaceCreaCorredores:
        push hl
        push af

        call _vtGetFreeGameObjPtr 
		ld ix,(#_vtGameObjPtr)

        ld a,(#0xB500+OBJ_POSX+1)
        ld d,a

		call _gtaConfigRandomPerson
		
        //y ahora por ultimo seteo todo lo necesario del NPC (que tengo en A, usando el objeto IX)
        pop af
		call _gtaConfigNPC

        ld a,#0xFF
        ld OBJ_PARENT_PTR(ix),a
        ld OBJ_PARENT_PTR+1(ix),a

        set 6,OBJ_FLAGS(ix)     //le agrego el FLAG_NO_DESTROY, para que no se lo cargue cuando salgamos de la pantalla

        ld hl,#_gtaCocheIAgotoPoint
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h

        pop hl
        ret


    gtaMisionRaceWin:
        inc hl      //pasamos a la siguiente instruccion 
        ld (#_misionActualPtr),hl       //la guardamos en el puntero y palante
        xor a           //reinicio por si luego hay otra carrera
        ld (#raceStarted),a
        ret



    gtaMisionRaceLose:
        //aqui has perdido la carrera (no se que coño hacer)
        pop hl      //hago un pop para quitarme el call que llamo a gtaMisionRaceCheckRacer
        ld hl,#_misionDie
    	ld (#_misionActualPtr),hl	//preparamos para que salga la conversacion de estas muerto y que acabe el juego
        ret





    gtaMisionRaceCheckRacer:
        ld OBJ_LIFE(ix),#100        //no quiero que exploten 
        ld a,(hl)
        ld d,a
        ld OBJ_CAR_TILETO_X(ix),a
        or a
        jr Z,gtaMisionRaceLose
        inc hl 
        ld a,(hl)
        ld e,a
        ld OBJ_CAR_TILETO_Y(ix),a


        //compruebo si estoy cerca del punto para pasar al siguiente o no
        ld a,OBJ_POSX+1(ix)
        sub d
        bit 7,a
        jr Z,gtaMisionRaceStarteds7
        neg
    gtaMisionRaceStarteds7:
        cp #7
        jr NC,gtaMisionRaceStarteds10    //si no hay carry es que esta lejos, seguimos



        ld a,OBJ_POSY+1(ix)
        sub e
        bit 7,a
        jr Z,gtaMisionRaceStarteds8
        neg
    gtaMisionRaceStarteds8:
        cp #7
        jr NC,gtaMisionRaceStarteds10    //si no hay carry es que esta lejos, seguimos

        //si llego aqui, tengo que pasar al siguiente punto al prota porke ya está sobre este punto su coche
        inc hl 
        ret

    gtaMisionRaceStarteds10:
        dec hl
        ret


        //aqui guardo por cual punto de control va cada uno
    raceStarted:
        .db #0

    raceIX1:
        .dw #0
    raceIX2:
        .dw #0
    
    racePuntoProta:
        .dw #0
    racePuntoR1:
        .dw #0
    racePuntoR2:
        .dw #0
    __endasm;
}

void gtaMisionCreateTempo() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        inc hl
        ld e,(hl)                   //leo los ticks low
        inc hl
        ld d,(hl)                   //leo los ticks high
        inc hl
        ld (#_misionActualPtr),hl       //paso a la siguiente instruccion
        ld (#_misionTemporizador),de        //me guardo los ticks del temporizador
        ret
    __endasm;
}

void gtaMisionDestroyTempo() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        inc hl
        ld (#_misionActualPtr),hl
        ld hl,#0
        ld (#_misionTemporizador),hl        //pongo el temporizador a 0
        ret
    __endasm;
}

void gtaMisionCreateItem() __naked {
    __asm
        //primero creamos un objeto
		call _vtGetFreeGameObjPtr 
		ld ix,(#_vtGameObjPtr)


    	ld hl,(#_misionActualPtr)
    	inc hl		//leemos tilex y tiley en DE
    	ld d,(hl)
    	inc hl
    	ld e,(hl)		
		

        ld OBJ_POSX+1(ix),d
        ld OBJ_POSY+1(ix),e

        
        

        inc hl		//leemos el tipo del item 
    	ld a,(hl)
        ld OBJ_SELECTED_WEAPON(ix),a        //el tipo de item, lo metemos en selected weapon mismo

        cp #ITEM_BOX                    //miramos que animacion le tenemos que poner 
        jr NZ,gtaMisionCreateItems2
        
        ld de,#_animItemBox
        ld OBJ_ANIMATION_LIST(ix),e
        ld OBJ_ANIMATION_LIST+1(ix),d
        jr gtaMisionCreateItems4

    gtaMisionCreateItems2:
        cp #ITEM_TNT
        jr NZ,gtaMisionCreateItems4

        ld de,#_animItemBox     //aqui iria el TNT
        ld OBJ_ANIMATION_LIST(ix),e
        ld OBJ_ANIMATION_LIST+1(ix),d



    gtaMisionCreateItems4:
		inc hl  //y paso al siguiente
		ld (#_misionActualPtr),hl		//vuelvo a guardar misionActualPtr apuntando ya a la siguiente instruccion
		
		//y acabo de configurar el resto de cosas del item
        ld OBJ_ACTIVE_TYPE(ix),#TYPE_AUX_OBJECT
        ld OBJ_FLAGS(ix),#0
        ld OBJ_WIDTH(ix),#2
        ld OBJ_HEIGHT(ix),#1
    
        //si es un item... (menor que 16) le pongo colision y la funcion step y draw por defecto de momento
        ld hl,#_vtStepObjectFunc
        ld OBJ_STEP_FUNC(ix),l
        ld OBJ_STEP_FUNC+1(ix),h
      
        ld hl,#_gtaItemColisionFunc            //esta hará que puedas pillar el item y se autodestruya
        ld OBJ_COLISION_FUNC(ix),l
        ld OBJ_COLISION_FUNC+1(ix),h
      
        ld hl,#_vtDrawObjectFunc
        ld OBJ_PREPARE_FUNC(ix),l
        ld OBJ_PREPARE_FUNC+1(ix),h

        //le agregamos el flag de no destroy
        set 6,OBJ_FLAGS(ix)     //le agrego el FLAG_NO_DESTROY, para que no se lo cargue cuando salgamos de la pantalla


        ret
    __endasm;
}





void gtaMisionEscape() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        push hl
        
        inc hl
        ld c,(hl)
        inc hl
        ld (#_misionActualPtr),hl

        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando (que va en C)

        ld iy,#GAME_OBJECTS_PTR     //pongo en IY al prota

        ld l,OBJ_PARENT_PTR(ix)             //miro si el parent de IX (el coche encontrado) es el prota, 
        ld h,OBJ_PARENT_PTR+1(ix)           //si se da este caso, 
        push iy                             //hay que quitarle el ID_NPC a IX (el coche encontrado) ya que esta intentando escapar de si mismo
        pop bc                              // ya que es posible que tenga que escapar de un CAR_BURGUER, llevando un CAR_BURGUER el prota
        xor a                               //por eso le quitamos el id al coche del prota, para que no lo tenga en cuenta en el Escape en el siguiente check
        sbc hl,bc   
        jr Z,gtaMisionEscapeNoEscapeQuitarID

        call _gtaDistanceIX_IY     //esto me deja en HL la distancia

        ld a,#25
        cp h 

        pop hl          //recupero el comienzo de esta instruccion por si tengo que volver a ella

        ret C       //si H > 25 ya le hemos dado esquinazo, podemos pasar a la siguiente instruccion


    gtaMisionEscapeNoEscape:
        //si no hay carry H < 25 es que nos siguen de cerca aun, tenemos que recuperar la instruccion y seguir mirando
        ld (#_misionActualPtr),hl
        ret


    gtaMisionEscapeNoEscapeQuitarID:
        ld OBJ_ID_NPC_CAR(ix),#0
        pop hl 
        jr gtaMisionEscapeNoEscape      //hago que lo vuelva a mirar en el siguiente frame (ya no encontrara el mismo coche)

    __endasm;
}


//conversacion con personaje (idper1,frptr1,....,idperN,frptrN,0)
//mConversation,  NPC_BURGUER,fraseCojeBazoka%256,fraseCojeBazoka/256
void gtaMisionConversation() __naked {
    __asm
        ld a,(#_vtStopGame)
        or a
        ret NZ      //si el juego esta parado no podemos crear la siguiente conversacion, asi que lo dejamos todo como está y en el siguiente frame creará la conversacion

        ld hl,(#_misionActualPtr)
        inc hl 
        ld c,(hl)
        inc hl
        ld e,(hl)
        inc hl 
        ld (#_misionActualPtr),hl

        ld hl,#_frase_list
        ld d,#0
        add hl,de 
        add hl,de 
        ld e,(hl)
        inc hl 
        ld d,(hl)

        push de

        
        ld ix,#GAME_OBJECTS_PTR
        inc c
        jr Z,gtaMisionConversations3    //si C=255, le sumo 1 y da 0 es que es el prota el que tiene que hablar, me salto el buscar el NPC porque ya tengo IX con B500
        dec c

        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando (que va en C)

    gtaMisionConversations3:
        pop de
        ex de,hl        //dejo la frase en HL

        ld (#_talkInstancePtr),ix
        //xor a 
        //ld (#_talkTime),a
      
        call _gtaCreaFrase

        ld a,#NUMERO_FRAMES_SCROLL_BLOQUEADO_TRAS_CONVERSACION
        ld (#_vtScrollLockTime),a
        ret
    __endasm;
}

void gtaMisionWaitTempo() __naked {
    __asm
        ld hl,(#_misionTemporizador)
        ld de,#1
        xor a 
        sbc hl,de
        ret NZ       //si no es cero seguimos en la misma instruccion y no hay que hacer nada

        //si es cero es que el temporizador está en 1, tenemos que ponerlo a cero y pasar a la siguiente instruccion
        xor a
        ld (#_misionTemporizador),a     //el byte bajo a 0 (el alto ya se que esta a 0)
    
        ld hl,(#_misionActualPtr)       //paso a la siguiente instruccion
        inc hl
        ld (#_misionActualPtr),hl
        ret
    __endasm;
}

/*
void gtaMisionAttackMe() __naked {
    __asm
        ld hl,#_iaPersonAtacandoProta
        jp _gtaMisionChangeIAforNPC
    __endasm;
}


void gtaMisionEscapeMe() __naked {
    __asm
        ld hl,#_iaPersonHuyendo
        jp _gtaMisionChangeIAforNPC
    __endasm;
}
*/

void gtaMisionStopRelaxNPCs() __naked {
    __asm
        xor a
        jr gtaMisionRelaxNPCsSub
    __endasm;
}

void gtaMisionRelaxNPCs() __naked {
    __asm
        ld a,#1
    gtaMisionRelaxNPCsSub:
        ld (#_relaxNPCs),a      //activamos el relaxNPC
        ld hl,(#_misionActualPtr)
        inc hl
        ld (#_misionActualPtr),hl
        ret
    __endasm;
}

//entra en HL la ia que se tiene que aplicar y el NPC se lee de la instruccion
void gtaMisionChangeIAforNPC() __naked {
    __asm
        push hl

        ld hl,(#_misionActualPtr)
        inc hl
        ld c,(hl)
        inc hl
        ld (#_misionActualPtr),hl

        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando (que va en C)

        pop hl
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h
        ld OBJ_FRAMES_FOR_NEXT_STATE(ix),#127
        ret
    __endasm;
}


//esta funcion es de pega, es solo por si hiciera falta meter más luego
void gtaMisionIdle() __naked {
    __asm
        ret
    __endasm;
}

void gtaMisionEnable() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        inc hl
        ld a,(hl)               //leo que mision tengo que habilitar
        inc hl
        ld (#_misionActualPtr),hl

    //gtaMisionEnableSub:
        /*ld e,a
        ld d,#0
        ld hl,#_misionState
        add hl,de
        ld (hl),#1          //mision enabled*/

        ret
    __endasm;
}

void gtaMisionNext() __naked {
    __asm
        call _gtaMisionEnable       //habilito la mision que tengo que empezar

        push af     //me la guardo en A

        call _gtaMisionEnd          //finalizo la mision actual

        pop af          //recupero la mision que voy a empezar

        call _gtaMisionStart        //comienzo la mision que tengo en A

        ret
    __endasm;
}

void gtaMisionEnd() __naked {
    __asm
        /*ld a,(#_misionActual)
        ld e,a
        ld d,#0
        ld hl,#_misionState
        add hl,de
        ld (hl),#2          //mision finalizada*/

        xor a
        ld (#_misionTargetTileX),a
        ld (#_misionTargetTileY),a
        ld (#_misionActualPtr),a
        ld (#_misionActualPtr+1),a
        ld (#_misionTemporizador),a
        ld (#_misionTemporizador+1),a
        dec a
        ld (#_misionActual),a       //le pongo 255 a la mision
        ret
    __endasm;
}


//esta funcion busca un NPC concreto y lo devuelve en IX o devuelve IX = 0 si no lo encuentra
//mete el NPC a buscar en C
void gtaMisionFindNPC() __naked {
    __asm
        ld ix,#GAME_OBJECTS_PTR     //vamos a recorrer todos los objetos y el que tenga OBJ_ID_NPC_CAR=C nos lo cargamos (le pongo OBJ_ID_NPC_CAR a 255 para que haga el step y se elimine y asi se borra el muñeco)
	    ld b,#16
        ld de,#48
        
    gtaMisionFindNPCBucle:
        ld a,OBJ_ID_NPC_CAR(ix)
        cp c
        jr NZ,gtaMisionFindNPCBucleFin

        //este es el que estoy buscando
        ret     //salgo porque ya tengo en IX el NPC
        

    gtaMisionFindNPCBucleFin:
        add ix,de
        djnz gtaMisionFindNPCBucle

        //si llego aqui no lo he encontrado, devuelvo IX apuntando al ultimo, que seguramente sea un objeto en blanco y como despues va a setear alguna cosa, no deberia pasar nada (teoricamente...)
        ld ix,#0xB7D0
        ret
    __endasm;
}


//funcion que configura el objeto IX con el NPC indicado (pasado en A)
void gtaConfigNPC() __naked {
    __asm
    
    	//le indico que numero de NPC es
	    ld OBJ_ID_NPC_CAR(ix),a	
    
    	//le configuro el tipo correcto por si es un hombre/mujer
    	ld hl,#_configNPCType
        dec a       //le resto uno porque es 1 based y los arrays es 0 based
    	ld e,a
    	ld d,#0
    	add hl,de
    	ld a,(hl)
    	ld OBJ_ACTIVE_TYPE(ix),a


    	//hago lo mismo para el custom color 1
    	ld hl,#_configNPCCustomColor1
    	add hl,de
    	ld a,(hl)
    	ld OBJ_CUSTOM_COLOR(ix),a
    	
    	//hago lo mismo para el custom color 2
    	ld hl,#_configNPCCustomColor2
    	add hl,de
    	ld a,(hl)
    	ld OBJ_CUSTOM_COLOR_2(ix),a
    	
    	
		ld hl,#_configNPCAnimation2
		add hl,de
		add hl,de		//2 bytes
    	ld c,(hl)
    	inc hl
    	ld b,(hl)		//leo en BC la animacion 2 (si la hay)
    
    	ld OBJ_ANIMATION_LIST_2(ix),c
    	ld OBJ_ANIMATION_LIST_2+1(ix),b
    	

        bit 5,OBJ_ACTIVE_TYPE(ix)
        jr Z,gtaConfigNPCPersona


    gtaConfigNPCCoche:
        //ld OBJ_ACTIVE_TYPE(ix),#TYPE_CAR		esto ya esta metio
        xor a
        ld OBJ_PARENT_PTR(ix),a         //lo creo con el parent a 0 para que no tenga conductor a priori
        ld OBJ_PARENT_PTR+1(ix),a

        ld OBJ_LIFE(ix),#CAR_START_LIFE_MISION
        ld OBJ_FLAGS(ix),#16     //FLAG_AUTO_MOVE 
        ld hl,#_gtaCocheStepFunc
        ld OBJ_STEP_FUNC(ix),l
        ld OBJ_STEP_FUNC+1(ix),h
        ld hl,#_gtaCocheColisionFunc
        ld OBJ_COLISION_FUNC(ix),l
        ld OBJ_COLISION_FUNC+1(ix),h
        ld hl,#_gtaCocheDrawFunc
        ld OBJ_PREPARE_FUNC(ix),l
        ld OBJ_PREPARE_FUNC+1(ix),h

        ld a,#3
        ld OBJ_WIDTH(ix),a
        ld OBJ_HEIGHT(ix),a
        

        ld a,OBJ_ID_NPC_CAR(ix)
        sub #17
        ld hl,#_configCarsType
        ld e,a
        ld d,#0
        add hl,de
        ld a,(hl)

        ld OBJ_SELECTED_CAR(ix),a    //aqui tenemos que saber que coche meter de alguna forma
        add a
        ld hl,#_carPropAnim
        add l
        jr NC,gtaConfigNPCCoches3
        inc h
    gtaConfigNPCCoches3:
        ld l,a
        ld e,(hl)
        inc hl
        ld d,(hl)

        ld OBJ_ANIMATION_LIST(ix),e
        ld OBJ_ANIMATION_LIST+1(ix),d
        ld OBJ_ANIMATION_MAX(ix),#8

        //miro si tengo que cabrear al coche o no en funcion del NPC que sea

        ld a,OBJ_ID_NPC_CAR(ix)
        sub #16
        ld e,a
        ld d,#0
        ld hl,#_hateLevel
        add hl,de
        ld a,(hl)
        cp #2
        ret C //si hay carry es que es menor de 2, por lo tanto no ataco al jugador
        
        //si es 2 tengo que cabrear a este coche para que vaya a por el prota a saco
        ld hl,#_gtaCocheIAgotoProta
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h
		
		ret		//hay que salir porke como siga le mete la animacion de andar a la persona


    gtaConfigNPCPersona:

        ld hl,#_gtaNPCDrawFunc
        ld OBJ_PREPARE_FUNC(ix),l
        ld OBJ_PREPARE_FUNC+1(ix),h

        call _gtaSetAnimWalkIX
        


        ld e,OBJ_ID_NPC_CAR(ix)
        dec e       //le resto uno porke los NPC empiezan desde 1
        ld d,#0
        ld hl,#_configNPCweaponSelected
        add hl,de
        ld a,(hl)
        ld OBJ_SELECTED_WEAPON(ix),a
        ld OBJ_AMMO(ix),#255
        ld OBJ_LIFE(ix),#PERSON_START_LIFE_MISION

        ld a,OBJ_ID_NPC_CAR(ix)
        cp #8
        ret NC      //si es persona y es OBJ_ID_NPC_CAR es que es uno de los compis del prota, no un NPC, por lo tanto no puede salir cabreado

        ld e,a
        ld d,#0
        ld hl,#_hateLevel
        add hl,de
        ld a,(hl)
        cp #2
        ret C //si hay carry es que es menor de 2, por lo tanto no ataco al jugador

        //cabreo a la persona, (le pongo la ani de ir a pegar)
        ld hl,#_iaPersonAtacandoProta
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h

        ret

    __endasm;
}




void gtaSetAnimWalkIX() __naked {
    __asm
        bit 1,OBJ_ACTIVE_TYPE(ix)           //compruebo si es hombre/mujer
        ld hl,#_animWomanWalk              //le pongo la animacion de andar de la mujer
        jr Z,gtaSetAnimWalkIXs2        //si este bit es cero es mujer
        ld hl,#_animManWalk              //le pongo la animacion de andar de la mujer
    gtaSetAnimWalkIXs2:
        ld OBJ_ANIMATION_LIST(ix),l
        ld OBJ_ANIMATION_LIST+1(ix),h

        ld OBJ_FRAME_SPEED(ix),#96

        ret
    __endasm;
}


void gtaSetAnimFallIX() __naked {
    __asm
        bit 1,OBJ_ACTIVE_TYPE(ix)           //compruebo si es hombre/mujer
        ld hl,#_animWomanFall
        jr Z,gtaSetAnimFallIXs2        //si este bit es cero es mujer
        ld hl,#_animManFall              //le pongo la animacion de andar de la mujer
    gtaSetAnimFallIXs2:
        ld OBJ_ANIMATION_LIST(ix),l
        ld OBJ_ANIMATION_LIST+1(ix),h

        xor a
        ld OBJ_FRAME_INDEX(ix),a
        ld OBJ_FRAME_INDEX+1(ix),a
        ld OBJ_FRAME_SPEED(ix),a

        ret
    __endasm;
}




//compruebo si estoy en el coche indicado (o en cualquier coche si se indico 0)
void gtaMisionGetCar() __naked {
    __asm

        ld hl,(#_misionActualPtr)
        push hl
        inc hl
        ld c,(hl)       //leo que coche tengo que buscar
        inc hl
        ld (#_misionActualPtr),hl

        //si C=0 no busco el npc
        xor a
        or c
        jr Z,gtaMisionGetCarCheckCualquierCoche

        call _gtaMisionFindNPC      //pongo en IX el NPC que estoy buscando (que va en C)

        ld a,(#GAME_OBJECTS_PTR+OBJ_PARENT_PTR+1)       //leo el coche que lleva el prota
        ld d,a

        ld a,(#GAME_OBJECTS_PTR+OBJ_PARENT_PTR)
        ld e,a

        push ix                 //saco la direccion del coche que estoy buscando
        pop hl 

        xor a
        sbc hl,de               //compruebo si son iguales

        pop hl              //recupero en HL la mision pointer
        ret Z       //si es 0 estamos ya en el coche indicado asi que pa fuera

        //si no estoy en el coche indicado debo restaurar misionActualPtr y salir
        ld (#_misionActualPtr),hl
        
        ld a,OBJ_POSX+1(ix)					//como aun no he pillado el coche, y es un coche concreto, indico el target para que el jugador sepa cual tiene que pillar
        ld (#_misionTargetTileX),a
        ld a,OBJ_POSY+1(ix)
        ld (#_misionTargetTileY),a
        
        ret
    


    gtaMisionGetCarCheckCualquierCoche:
        ld a,(#GAME_OBJECTS_PTR+OBJ_PARENT_PTR+1)
        or a
        pop hl
        ret NZ      //si ya estoy en un coche pa fuera sin hacer nada más

        //si no estoy en un coche debo restaurar misionActualPtr y salir
        ld (#_misionActualPtr),hl
        ret

    __endasm;
}



void gtaHateMeGroup() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        inc hl
        ld e,(hl)       //leo el grupo que tengo que hatear
        inc hl
        ld b,(hl)       //leo el nivel de hateo que le tengo que aplicar
        inc hl
        ld (#_misionActualPtr),hl       //paso al siguiente evento

        ld d,#0
        ld hl,#_hateLevel       //me desplazo hasta el que tengo que hatear
        add hl,de
        ld (hl),b               //lo hateo y salgo






        //cabreamos a todo el mundo  tengo en E el grupo
        ld ix,#GAME_OBJECTS_PTR+96     //vamos a recorrer todos los objetos y el que tenga OBJ_ID_NPC_CAR=C nos lo cargamos (le pongo OBJ_ID_NPC_CAR a 255 para que haga el step y se elimine y asi se borra el muñeco)
        ld c,e      //dejo el grupo de cabreo en C
	    ld b,#14
        ld de,#48
        
    gtaHateMeGroupBucle:
        ld a,OBJ_ID_NPC_CAR(ix)             //miro si este muñeco es del grupo que tengo que cabrear o no
        cp c
        jr NZ,gtaHateMeGroupBucles2

        //lo cabreo si es persona       
        ld hl,#_iaPersonAtacandoProta
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h
        jr gtaHateMeGroupBucleFin
        

    gtaHateMeGroupBucles2:
        sub #16     //le resto 16 y vuelvo a mirar por si fuese un coche
        cp c
        jr NZ,gtaHateMeGroupBucleFin            //si no coinciden paso al siguiente

        //ojo, solo cabreo al coche si no lo lleva el prota
        ld a,OBJ_PARENT_PTR+1(ix)
        cp #0xB5
        jr Z,gtaHateMeGroupBucleFin         //lo lleva el prota paso al siguiente

        ld hl,#_gtaCocheIAgotoProta         //no lo lleva el prota, lo cabreo
        ld OBJ_MACHINE_STATE_PTR(ix),l
        ld OBJ_MACHINE_STATE_PTR+1(ix),h

    gtaHateMeGroupBucleFin:
        add ix,de
        djnz gtaHateMeGroupBucle


        ret
    __endasm;
}


void gtaWeaponItemState() __naked {
    __asm
        ld hl,(#_misionActualPtr)
        inc hl
        ld e,(hl)       //leo el item de arma que tengo que cambiar
        inc hl
        ld b,(hl)       //leo el nuevo estado (0 se puede pillar, 1 ya esta pillado)
        inc hl
        ld (#_misionActualPtr),hl       //paso al siguiente evento

        ld d,#0
        ld hl,#ITEM_YA_RECOGIDO       //me desplazo hasta el que tengo que hatear
        add hl,de
        ld (hl),b               //lo hateo y salgo

        ret
    __endasm;
}

void gtaMisionEndGame() __naked {
    __asm
		ld a,#255
		ld (#0xB500+OBJ_FLAGS),a		//activo todos los flags del prota y eso hace que el juego se salga
        
        ld hl,#0xB500                   //elimino todos los objetos para que no haga nada más el juego (les pongo el OBJ_ACTIVE_TYPE a 0)
        ld b,#16
        ld de,#48
        xor a
    gtaMisionEndGameBucle:
        ld (hl),a 
        add hl,de
        djnz gtaMisionEndGameBucle
		ret                             //teoricamente al tener todos los flags activados el prota vuelve al menu principal
    __endasm;
}
