#ifndef ARMONY_H
#define ARMONY_H

#include <cpctelera.h>

//MEMORY MAP   ------------------------------------------

/*
0040-00FF vt sprite to draw list
0100-10FF tiles
1100-20FF metatiles
2100-24FF scene

2500-26FF log2_tab, atan_tab (contiene dos listas de 256 con datos preparados para la funcion vtAtan2 que devuelve el angulo entre dos puntos)
2700-27FF tabla de aceleración por angulo, van en grupitos de 8 y es para usar la funcion vtCosAdvance (ver funcion para entender su funcionamiento)

2800-865F codigo del juego   OJO, LA COMPILACION NO PUEDE PASAR DE 865F o sobreescribe la musica y la lia
(lo de arriba era antes, ahora va con lo de abajo...)



00A0-865F codigo del juego   OJO, LA COMPILACION NO PUEDE PASAR DE 865F o sobreescribe la musica y la lia

8660-8AFF music FX
8B00-9AFF tileset
9B00-AAFF metatileset
AB00-AEFF scene
AF00-AFFF log2 table
B000-B0FF atan table
B100-B1FF cos partial table

B200-B3FF acel tile table
B400-B4FF FLIP_TABLE
B500-B7FF vtGameObjects
B800-B8FF vtTileRowToDraw1
B900-B9FF vtTileRowToDraw2
BA00-BAFF vtTileRowToDraw3
BB00-BBFF vtTileRowToDraw4
BC00-BC3F talkfrase
BC40-BC4F restaura luces array
BC50-BC5F items ya recogidos
BC60-BC7F vtGameObjOrderYList
BC80-BC9F vtGameObjColiList


BD00-BDFF	//por seguridad en esta zona casi mejor no poner nada, por si vtTileRowToDraw4 se pasa colocando tiles y jode la pila (que no deberia pero weno)

BE00-BF00 STACK no tocar bajo ningun concepto
BF00-BF50 zona para conservar pixeles que tienen que seguir dibujandose unos frames más (para los derrapes)
BF51-BFFF ZONA DE DIBUJO EN CUARENTENA, o lo que es lo mismo, el hueco de seguridad por si los sprites compilados se salen de la pantalla dibujando
C000-FFFF buffer de video para la pantalla
*/

//ENGINE CONSTANTS
//lo que hay que aumentar para pasar a la siguiente linea (normalmente no hace falta cambiar)
#define NEXT_LINE_ADD_VIDEO_MEM 0x0800
//lo que hay que aumentar si al pasar a la siguiente linea desbordas (vuelves a 0x0000) para volver a colocarte en la memoria de video en su sitio
//si usas 64 bytes de ancho 0xC040, si usas 80 bytes de ancho 0xC050 y si usas otra cosa calculalo tu mismo
#define MEMOUT_JUMP_VIDEO_MEM 0xC050

//simplemente una constante para el maximo de objetos que puede mover el engine (para usar en los for)
#define MAX_OBJECTS 16



/*				 USA LOS COLORES Hard+Command directamente en las constantes
;; Firmware | Hardware  | Hard+Command | Colour Name    |  R%   G%   B% Colour
;; ---------------------------------------------------------------------------
;;      0   | 20 (0x14) |  0x54        | Black          |   0    0    0
;;      1   |  4 (0x04) |  0x44 (0x50) | Blue           |   0    0   50
;;      2   | 21 (0x15) |  0x55        | Bright Blue    |   0    0  100
;;      3   | 28 (0x1C) |  0x5C        | Red            |  50    0    0
;;      4   | 24 (0x18) |  0x58        | Magenta        |  50    0   50
;;      5   | 29 (0x1D) |  0x5D        | Mauve          |  50    0  100
;;      6   | 12 (0x0C) |  0x4C        | Bright Red     | 100    0    0
;;      7   |  5 (0x05) |  0x45 (0x48) | Purple         | 100    0   50
;;      8   | 13 (0x0D) |  0x4D        | Bright Magenta | 100    0  100
;;      9   | 22 (0x16) |  0x56        | Green          |   0   50    0
;;     10   |  6 (0x06) |  0x46        | Cyan           |   0   50   50
;;     11   | 23 (0x17) |  0x57        | Sky Blue       |   0   50  100
;;     12   | 30 (0x1E) |  0x5E        | Yellow         |  50   50    0
;;     13   |  0 (0x00) |  0x40 (0x41) | White          |  50   50   50
;;     14   | 31 (0x1F) |  0x5F        | Pastel Blue    |  50   50  100
;;     15   | 14 (0x0E) |  0x4E        | Orange         | 100   50    0
;;     16   |  7 (0x07) |  0x47        | Pink           | 100   50   50
;;     17   | 15 (0x0F) |  0x4F        | Pastel Magenta | 100   50  100
;;     18   | 18 (0x12) |  0x52        | Bright Green   |   0  100    0
;;     19   |  2 (0x02) |  0x42 (0x51) | Sea Green      |   0  100   50
;;     20   | 19 (0x13) |  0x53        | Bright Cyan    |   0  100  100
;;     21   | 26 (0x1A) |  0x5A        | Lime           |  50  100    0
;;     22   | 25 (0x19) |  0x59        | Pastel Green   |  50  100   50
;;     23   | 27 (0x1B) |  0x5B        | Pastel Cyan    |  50  100  100
;;     24   | 10 (0x0A) |  0x4A        | Bright Yellow  | 100  100    0
;;     25   |  3 (0x03) |  0x43 (0x49) | Pastel Yellow  | 100  100   50
;;     26   | 11 (0x0B) |  0x4B        | Bright White   | 100  100  100
;; ---------------------------------------------------------------------------
*/

/*quiero usar los 3 bits bajos para el color, y el bit alto para si es brillante o no
0000 negro     0x54
0001 rojo      0x5C
0010 verde     0x56
0011 amarillo  0x5E
0100 azul      0x44
0101 Magenta   0x58
0110 cyan      0x46
0111 Naraja    0x4E
1000 gris      0x40
1001 rojo b    0x4C
1010 verde b   0x52
1011 amarillo b  0x4A
1100 azul b    0x55
1101 Magenta b 0x4D
1110 cyan      0x53
1111 blanco    0x4B   */


//es para hacer los limites para el CRTC3, deja el negro
#define PAL_HARD_BLACK 0x54


//usa los valores Hard+Command de la tabla de arriba (se usan estos valores por optimización a la hora de cambiar las paletas)







//#define DEBUG_INTERRUPT_BLOCKS
//#define DEBUG_PROC_BLOCKS
//borde yellow cuando pinta sprites
//#define DEBUG_DRAW_SPRITES
//boder rojo cuando pinta tiles
//#define DEBUG_DRAW_TILES

/*		si se define el anterior los bordes se dibujan de la siguiente manera
FRAME A:
- negro: STEPing game (lee teclado, resetea frame y llama a todos los step de todos los objetos)
- gris: Scroll control (controla el movimiento del scroll hacia donde deba moverse y prepara los tiles que entran en pantalla)
- cyan: DRAWing game (llama a todos los draw de todos los objetos, ojo, esto no dibuja, solo prepara lo que se tiene que dibujar)

FRAME B y C:
- verde: WAITing sync (esta esperando a que el raster se ponga en una posicion concreta para empezar a dibujar)
- amarillo: DRAWing tiles (está dibujando tiles en una de las 4 zonas)
- rojo: DRAWing sprites (está dibujando sprites en una de las 4 zonas)
*/



#define END_DATAFULL 0x9D29



#define VT_SPRITE_LIST_TO_DRAW 0x0040

//posicion de los metatiles
//#define METATILE_START_MEM_HI 0x11
//#define METATILE_START_MEM 0x1100
#define METATILE_START_MEM_HI 0x9B
#define METATILE_START_MEM 0x9B00


//posicion donde esta el mapa
//#define SCENE_START_MEM 0x2100
//#define SCENE_START_MEM_HI 0x21
//esta ultima es por optimizacion, es la posicion donde esta el mapa entre 4  y -1 (cosas de optimizacion...)
//#define SCENE_START_MEM_HI_DIV4 0x08


#define SCENE_START_MEM 0xAB00
#define SCENE_START_MEM_HI 0xAB
//171
//esta ultima es por optimizacion, es la posicion donde esta el mapa entre 4  y -1 (cosas de optimizacion...)
//43*4=172
#define SCENE_START_MEM_HI_DIV4 43




#define SCENE_END_MEM 0xB4FF
#define GAME_OBJECTS_PTR 0xB500
#define GAME_OBJECTS_PTR_LIMIT_H 0xB8
#define TILEROW_TO_DRAW_1 0xB800
#define TILEROW_TO_DRAW_2 0xB900
#define TILEROW_TO_DRAW_3 0xBA00
#define TILEROW_TO_DRAW_4 0xBB00

//vtGameObjOrderYList
#define GAME_OBJ_ORDER_Y_LIST 0xBC60 

//vtGameObjColiList
#define GAME_OBJ_COLI_LIST 0xBC80

//esto es para definir la distancia a partir de la cual se empieza a usar scroll rapido
#define FAST_SCROLL_DISTANCE_X 3
#define FAST_SCROLL_DISTANCE_Y 3

//cuando se inicia una conversación dejamos unos frames que no se pueda tocar ninguna tecla para que te de tiempo a verla siempre
#define NUMERO_FRAMES_BLOQUEO_CONVERSACION 50

//esto es el numero de interrupciones que van a durar un step completo del engine, se puede usar 18 y 24 pero es recomendable 24 sino se renderizarán menos sprites
//#define INTERRUPT_CYCLE_COUNT 18
//esto es la interrupcion limite para dibujar sprites, cuando lleguemos a esta interrupcion hay que parar si o si ya que puede joderse el engine, siempre menor que INTERRUPT_CYCLE_COUNT
//#define INTERRUPT_MOMENT_LIMIT_SPRITE_DRAW 21

//#define OVERHEAT_RELAX_FRAMES 0

//si se define esta etiqueta dibujará en la esquina superior izquierda una linea de puntos (cuando llegue al final del ciclo de juego, 
//por cada interrupción que haya saltado de más, se pintara un byte negro y el siguiente blanco), o dicho de otra forma, eso es el retraso acumulado del engine
#define DEBUG_INTERRUPT_DELAY


//tipo del objeto para identificarlo (0 es que no hay objeto, está libre el slot y se puede usar para un objeto nuevo)
#define OBJ_ACTIVE_TYPE 0
//funcion step que se llamara para mover el objeto
#define OBJ_STEP_FUNC 1
//funcion prepare que se llamara cuando se vaya a preparar el dibujado (si no vas a dibujar nada ponlo a 0)
#define OBJ_PREPARE_FUNC 3
//funcion que va a saltar si hay una colision, si no quieres colision dejalo a 0
#define OBJ_COLISION_FUNC 5
//el id de otro objeto (si es un personaje puede ser el id del vehiculo donde esta montado, si es un coche puede ser el id del conductor)
#define OBJ_PARENT_PTR 7

//frame maximo de animacion, cuando llegue a este frame vuelve a 0
#define OBJ_ANIMATION_MAX 9
//0 no necesita limpiar el fondo, 1 si necesita dibujar los tiles de fondo
#define OBJ_NEED_REDRAW 10
//velocidad a la que ira la animación
#define OBJ_FRAME_SPEED 11
//frame actual que se esta mostrando de la animacion (el byte alto, el bajo es solo para precision)
#define OBJ_FRAME_INDEX 12
//puntero al array que contiene una lista de frames para la animacion
#define OBJ_ANIMATION_LIST 14
//posicion
#define OBJ_POSX 16
#define OBJ_POSY 18
//velocidad
#define OBJ_SPEEDX 20
#define OBJ_SPEEDY 22
//ancho y alto
#define OBJ_WIDTH 24
#define OBJ_HEIGHT 25
//flags (ver documentacion)
#define OBJ_FLAGS 26
//vida del objeto, se puede usar para otras cosas
#define OBJ_LIFE 27
//estas dos variables se usan para guardar el lugar donde se dibujo el ultimo frame y sirve para saber donde se tiene que limpiar
#define OBJ_REDRAWX 28
#define OBJ_REDRAWY 29
//municion del arma
#define OBJ_AMMO 30
#define OBJ_WEAPON_DISTANCE 30
//colores custom A y B para el objeto 
#define OBJ_CUSTOM_COLOR 31
//esto guarda los colores custom por si hay un sprite secundario superpuesto (como por ejemplo el pelo)
#define OBJ_CUSTOM_COLOR_2 32
//al igual que animationArrayPtr pero se usa para el pelo u cualquier otro sprite superpuesto del tipo que sea (0 si no se va a usar)
#define OBJ_ANIMATION_LIST_2 33


#define OBJ_AUXILIAR_7 35
//más flags para definir comportamientos en el objeto que sean true/false
//0 - optimize restore background horizontal (si esta a 1 se dibuja justo el width tiles sin añadirle 1)
//1 - optimize restore background vertical (si esta a 1 se dibuja justo el height tiles sin añadirle 1)
#define OBJ_FLAGS_2 35

#define OBJ_AUXILIAR_6 36
#define OBJ_WEAPON_DAMAGE 36
#define OBJ_CAR_TILETO_X 36

#define OBJ_AUXILIAR_5 37
//el arma que llevas (0 si vas a puños)
#define OBJ_SELECTED_WEAPON 37
#define OBJ_CAR_TILETO_Y 37


#define OBJ_AUXILIAR_4 38
//el coche en el que vas
#define OBJ_SELECTED_CAR 38

#define OBJ_AUXILIAR_3 39
#define OBJ_CAR_SPEED 39

#define OBJ_AUXILIAR_2 40
#define OBJ_CAR_TORQUE 40
#define OBJ_PERSON_TORQUE 40

#define OBJ_PROTA_ACUM_FIRE 41
#define OBJ_BASE_TYPE 41


//puntero a la funcion que controlara un estado concreto de la IA    
#define OBJ_MACHINE_STATE_PTR 42
//numero de frames que quedan para ver a que estado pasamos (para que no este cambiando de estado todo el rato)
#define OBJ_FRAMES_FOR_NEXT_STATE 44

//3 variables auxiliares para controlar parametros de IA que sean necesarios (esto dependerá de cada juego...)
#define OBJ_IA_AUX_3 45
//indica el numero de frames que la IA (o la prota) no se pueden mover del sitio (osea, que se ajustara la velocidad a 0 aunque esten moviendose)
#define OBJ_IA_LOCK_MOVE 45   

#define OBJ_IA_AUX_2 46
#define OBJ_IA_TORQUE_TO 46

//indica el id del NPC o del Coche
#define OBJ_ID_NPC_CAR 47

   



//ESTRUCTURAS---------------------------------------------------------------------------
struct vtObjStruct {   //si w es cero el objeto esta inactivo y pasamos de el para todo
   //0
   u8 activeType;    //0 no activo, 1 o más, el tipo del objeto, simplemente por identificar, no es estrictamente necesario
   //1
   void (*stepFunc)(void);     //puntero a la funcion step, la que mueve el muñeco
   //3
   void (*prepareDrawFunc)(void);   //puntero a la funcion prepareDraw, la que prepara las variables para que se dibuje o no el objeto
   //5
   void (*colisionFunc)(void);      //funcion que se llama cuando ha habido una colision con este objeto, o 0 si no se quiere que tenga colision
   //7
   u8* parentObjPtr;	   //el id de otro objeto (si es un personaje, puede ser 0 o el id de un vehiculo donde va montado. Si es un coche, es el id de quien conduce el coche)
   

	//9  
	u8 animationMax;		//indica cuantos frames tiene la animacion

   //10
   u8 needRedraw;
   //11
   u8 frameSpeed;			//lo que va a ir avanzando esa animacion en cada frame, se sumará a frameIndex en cada frame
   //12
   u16 frameIndex;   		//el byte alto es el frame actual, y el frame bajo es simplemente para poder ajustar la velocidad más fina
   //14
   u16* animationArrayPtr;	//puntero a la animacion actual (un array con la lista de sprites de esa animacion)



   //16
   u16 posx;      //posicion X del objeto, el byte alto es el tile actual, y el byte bajo para presicion dentro del tile
   //18
   u16 posy;      //posicion y del objeto, el byte alto es el tile actual, y el byte bajo para presicion dentro del tile
   //20
   i16 speedX;    //velocidad X del muñeco  (simplemente se le suma en cada step, la IA tendra que ajustarlo como vea)
   //22
   i16 speedY;    //velocidad X del muñeco
   //24
   u8 widthTiles;     //cuanto ocupa en horizontal el bixo (en tile)
   //25
   u8 heightTiles;     //cuanto ocupa en vertical el bixo (en tiles), ojo que el punto cero es abajo en el centro
   //26				
   u8 flags; 			//guarda flags (0 a 1) del objeto en cuestion
   //bit 0 (necesita redibujar tiles) 
   //bit 1 (necesita redibujar sprite)
   //bit 2 (está en pantalla)
   //bit 3 (hacer flash en el sprite, osea, dibujar el sprite con los dos custom a blanco durante 1 frame para dar feedback)
   //bit 4 (auto move, mueve el personaje auto con speedX y speedY)
   //bit 5 (auto anim, anima de forma automatica al personaje con frameSpeed y frameIndex)
   //bit 6 (NO_DESTROY)
   //bit 7 (no colision, si está a 1 se ignorará la colision con este objeto)
   	
   //27
   u8 life;       	//vida del objeto antes de espichar
   //28
   u8 lastTileXtoRedraw;  //ultima posicion (en tiles) donde se dibujo el keko (posicion X del escenario)
   //29
   u8 lastTileYtoRedraw;   //ultima posicion (en tiles) donde se dibujo el keko (posicion Y del escenario)
   //30  
   u8 ammo;             //esto guarda la municion del arma actual (si es que tiene claro, los puños no se gastan)
   //31  
   u8 customColor;       //esto guarda los colores custom que se van a usar para el sprite principal
   //32
   u8 customColor2;     //esto guarda los colores custom por si hay un sprite secundario superpuesto (como por ejemplo el pelo)
   //33
   u16* animationArrayPtr2;	//al igual que animationArrayPtr pero se usa para el pelo u cualquier otro sprite superpuesto del tipo que sea (0 si no se va a usar)
   //35
   u8 aux7;          //variables auxiliares de momento sin usar, si veo que va haciendo falta le ire dando usos
   //36
   u8 aux6;
   //37
   u8 aux5;
   //38
   u8 aux4;
   //39
   u8 aux3;
   //40
   u8 aux2;
   //41
   u8 aux1;
   

   //42-47  
   void (*iaMachineStatePtr)(void); //puntero a la funcion de la maquina de estados que controlara la IA de este personaje
   u8 iaTimeToNextState;          //numero de frames para calcular el siguiente estado
   u8 iaState3;                   //3 variables auxiliares para controlar ciertos elementos de la IA (cada cual que la use para lo que le haga falta)
   u8 iaState2;
   u8 iaState1;
   

};

typedef struct vtObjStruct vtGameObj;



   //bit 0 (necesita redibujar tiles) 
   //bit 1 (necesita redibujar sprite)
   //bit 2 (está en pantalla)
   //bit 3 (hacer flash en el sprite, osea, dibujar el sprite con los dos custom a blanco durante 1 frame para dar feedback)
   //bit 4 (auto move, mueve el personaje auto con speedX y speedY)
   //bit 5 (auto anim, anima de forma automatica al personaje con frameSpeed y frameIndex)
   //bit 6 (no destruir, se usa para cuando hay un NPC que forma parte de la mision y no quieres que se destruya nunca)
   //bit 7 (no colisionar con nada)

#define FLAG_REDRAW_TILES 0b00000001
#define FLAG_REDRAW_SPRITE 0b00000010
#define FLAG_IS_IN_SCREEN 0b00000100
#define FLAG_FLASH_SPRITE 0b00001000
#define FLAG_AUTO_MOVE 0b00010000
#define FLAG_AUTO_ANIM 0b00100000
#define FLAG_NO_DESTROY 0b01000000
#define FLAG_NO_COLISION 0b10000000



//aqui vamos a poner unas constantes para indicar el custom color más facilmente  //11332244 los bits
#define CUSTOM_A_PAL_0 0b00000000
#define CUSTOM_A_PAL_1 0b01000000
#define CUSTOM_A_PAL_2 0b00000100
#define CUSTOM_A_PAL_3 0b01000100
#define CUSTOM_A_PAL_4 0b00010000
#define CUSTOM_A_PAL_5 0b01010000
#define CUSTOM_A_PAL_6 0b00010100
#define CUSTOM_A_PAL_7 0b01010100
#define CUSTOM_A_PAL_8 0b00000001
#define CUSTOM_A_PAL_9 0b01000001
#define CUSTOM_A_PAL_10 0b00000101
#define CUSTOM_A_PAL_11 0b01000101
#define CUSTOM_A_PAL_12 0b00010001
#define CUSTOM_A_PAL_13 0b01010001
#define CUSTOM_A_PAL_14 0b00010101
#define CUSTOM_A_PAL_15 0b01010101

#define CUSTOM_B_PAL_0 0b00000000
#define CUSTOM_B_PAL_1 0b10000000
#define CUSTOM_B_PAL_2 0b00001000
#define CUSTOM_B_PAL_3 0b10001000
#define CUSTOM_B_PAL_4 0b00100000
#define CUSTOM_B_PAL_5 0b10100000
#define CUSTOM_B_PAL_6 0b00101000
#define CUSTOM_B_PAL_7 0b10101000
#define CUSTOM_B_PAL_8 0b00000010
#define CUSTOM_B_PAL_9 0b10000010
#define CUSTOM_B_PAL_10 0b00001010
#define CUSTOM_B_PAL_11 0b10001010
#define CUSTOM_B_PAL_12 0b00100010
#define CUSTOM_B_PAL_13 0b10100010
#define CUSTOM_B_PAL_14 0b00101010
#define CUSTOM_B_PAL_15 0b10101010









#define LOG2_TAB_TABLE_PAGE 0xAF
#define ATAN_TAB_TABLE_PAGE 0xB0
#define COS_PARTIAL_TABLE_PAGE 0xB1


#define ACCEL_TABLE_FOR_TILES 0xB2
#define ACCEL_TABLE_FOR_TILES_2 0x59
#define FLIP_TABLE_PAGE 0xB4






//ENGINE VARIABLES-------------------------------------------------------- 
//si pongo [R] read only no modificar que son variables internas del engine
u8 vtInterruptCycleCount;     //[R] esta variable es muy critica, posiblemente la más importante de todo el engine, y solo toma valores 18 o 24, lo que hace es 
                              //adaptar automaticamente el engine a 1/3 frames o 1/4 frames en funcion de la carga que tenga en ese momento el mismo
                              //lo hace de una forma bastante simple, si cuando haya acabado KABESA

u8 debugDelayInterruptMax;    //[R] esta variable indica como de jodido va el engine (numero de interrupciones maxima que se ha tenido que comer del siguiente 
                              //ciclo de juego porque no le ha dado tiempo a renderizarlo todo en su ciclo). Está variable deberia ser 0 o un valor muy cercano a 0
                              //para que se considere que el engine va perfecto

//u8 vtSpriteListToDraw[7*32];  //[R] este array es un precalculo para que a la hora de redibujar los tiles se haga de forma más rapida, basicamente lo
                              //que tiene es una lista de bloques de 7 bytes que contienen (zona,scrPtr,sprPtr,customAB,widthFlip), no tocar

u8* vtSpriteListToDrawPtr;    //[R] puntero para que el engine sepa por donde va en el array anterior, no tocar



//vtGameObj* vtGameObjOrderYList[16];   //[R] esta lista es para gestionar el orden de dibujado de los sprites, de forma que los que estan más arriba se dibujen antes
                                       //para que los que están más abajo puedan pisar el sprite de forma que quede con vista ortogonal

//vtGameObj* vtGameObjColiList[16];   //[R] es una lista para optimizar el calculo de las colisiones, tiene punteros a los 16 
                                    //objetos del engine pero ordenados por ejeX+width, si el objeto esta inactivo se va a al final del array
                                    //de esta forma para calcular luego las colisiones no tengo que comparar todos los objetos con todos,
                                    //solo el objeto actual con 1 o 2 siguientes y ya está

u8 vtGameObjColiListIndex;          //[R] Indice para que el engine sepa por donde va en la lista anterior


u8* vtPointerAux;             //[R] puntero interno para hacer calculos intermedios en el engine
u8* vtPointerAux2;            //[R] puntero interno para hacer calculos intermedios en el engine
u8 vtZoneCalc;                //[R] variable interna para guardar en que zona se ha calculado que debe dibujarse el sprite

u8 vtDespWidth;               //[R] si esto es 0 el sprite se dibuja hacia la derecha, sino metemos aqui el numero de bytes que ocupa en horizontal para que se dibuje mirando a la izq

u8 vtScrollPage;              //[R] variables del control del scroll y CRTC, no tocar
u8 vtScrollOffset;            //[R]      la page y offset controlan el scroll al tile
u8 vtScrollCRTC3;             //[R]      el CRTC 3 controla el movimiento de la ventana en horizontal (puede moverse un byte a la izquierda)
u8 vtScrollCRTC5;             //[R]      el CRTC 5 controla el movimiento de la ventana en vertical (puede moverse de 0 a 7 pixeles en vertical)
u8 vtScrollCRTC5old;          //[R]      guarda la ultima posicion de vtScrollCRTC5
u8 vtScrollHorizontalMoving;	//[R]      esta guarda si se ha movido horizontalmente el scroll (0- no se ha movido, 1- se ha movido sin cambio de tile, 2- se ha movido con cambio de tile)

u8 vtScrollLockTime;          // esta variable bloquea el scroll el numero de frames que se le indique (puede valer para detener la camara un poco mientras están hablando y asi quitar sobrecarga)

u8 vtScrollTurbo;             //si es 0 se usa R3 y R5 para mover medio tile el scroll, pero si se pone a 1 mueve el scroll siempre al tile (para scrollear más rapido si fuese necesario)
//u8 vtScrollLock;              //si es 0 funciona todo normal, si es 1 el scroll queda bloqueado, no se hará scroll bajo ningun concepto hasta que vuelva a 0

//u8* vtTileSetPtr;		         //tiene que apuntar al comienzo del tileset, todos los tiles deben estar unidos, set gray code y ocupar 16 bytes cada tile (2x8 bytes)
//u8* vtMetaTileSetPtr;	      //tiene que apuntar al comiento del metatileset, todos los metatiles deben estar unidos, son de 8x8 bytes (osea 64) cada bytes apunta a un tile
//OJO, se pueden cambiar en cualquier momento sin ningun problema, pero hay que tener en cuenta que el juego no redibuja todo en cada 
//  	frame, por lo tanto si lo cambias es posible que no veas el cambio hasta que alguien redibuje todo el fondo

//u8 vtEngineOverHeat; 	      //[NO SE USA] cuando el engine detecta que no le da tiempo de dibujar toda la tralla de sprites pone esta variable a 1, para que en el siguiente frame no intente hacer scroll aliviando asi un poco la sobrecarga del mismo


u8* vtVidMemStart;            //[R] apunta a la direccion de memoria que va a leer el crtc cuando el raster llegue al primer caracter de la esquina superior izquierda
                              //todas las operaciones de dibujado deben usar este puntero de referencia

u8 vtInterruptMoment;
u8 vtStopGame;                //si es 1 el juego se para hasta que se pulse una tecla (esta pensado para sacar conversaciones y que el juego se pare hasta que se lean)



u8* vtDrawTileSprite;         //[R] usado por vtDrawTile2x8gc para saber que tile tiene que dibujar
u8* vtTileRowToDraw1Ptr;      //[R] vtPushTilesIniX,vtPushTilesIniY,vtPushTilesEndX,vtPushTilesEndY
u8* vtTileRowToDraw2Ptr;      //[R] esta funcion esta preparada para usar un escenario de 64x32 metatiles de 8x8 tiles, si necesitas
u8* vtTileRowToDraw3Ptr;      //[R] otra forma de guardar el escenario puedes escribir tu propia funcion que meta en vtTileRowToDrawXPtr
u8* vtTileRowToDraw4Ptr;      //[R] los tiles a dibujar, basicamente es meter 1 byte con el numero de tiles, 2 bytes con la posicion de la pantalla
                              //    y las posiciones de memoria donde se encuentras esos tiles una tras otra.
u8* vtPushTilesDesp;          //[R] variables interna del vtPushTilesToDraw para darle velocidad, no las toques
u8* vtLastPtrMetaTile;        //[R] variable interna para el vtPushTilesToDraw para posible optimizacion si se encuentra en el mismo metatile
u8 vtPushTileStartX;          //[R] variable interna para llevar los bucles de la funcion vtPushTilesToDraw
u8 vtPushTilesDespZone;       //[R] variable interna para optimización en funcion vtPushTilesToDrawColumn

u8 vtPushTilesIniX;           //parametros de entrada para el vtPushTilesToDraw
u8 vtPushTilesIniY;
u8 vtPushTilesEndX;
u8 vtPushTilesEndY;


u8 dibujaEsquina;             //[R] esta variable es un poco rarita, es simplemente 0/1, si es 1 se dibuja la esquina inferior derecha 
                              //    es simplemente para solucionar un pequeño problema del scroll del cpc


u8 vtSceneScrollX;            //[R] posicion x de la scena donde estamos (en tiles)  (va a ir de 0 a 256)  (tamaño 6 pantallas en horizontal)
u8 vtSceneScrollY;            //[R] posicion y ...									         (va a ir de 0 a 256)  (tamaño 10 pantallas en vertical)
                              //    OJITO: no tocar vtSceneScrollX y vtSceneScrollY, si quieres mover la camara a otro sitio usa vtSceneScrollXto 
                              //          y vtSceneScrollYto y el engine moverá el scroll hacia esa posicion

   
u8 vtSceneScrollXto;          //Indican donde quieres que vaya el scroll (en tiles), simplemente indica la posicion y el engine moverá
u8 vtSceneScrollYto;          //moverá el scroll hacia ese lugar lo más rapido que le sea posible


u8 vtRenderZoneStep;          //[R] variable interna para que el engine sepa por que zona va renderizando 1,2,3 o 4 (las divisiones de las interrupciones).

u8* vtScreenPtr;              //puntero a la pantalla donde se va a dibujar el sprite bytecode de las funciones de dibujado de sprites
u8* vtSpritePtr;              //puntero al sprite del bytecode. Solo se rellenan si vas a usar las funciones vtRenderTSi o vtRenderTS (turbo sprites)
u8 vtDrawSpriteCustomColor1;  //color custom 1 (255,0,255 en sprite)
u8 vtDrawSpriteCustomColor2;  //color custom 2 (255,0,128 en sprite)
                              //estas dos variables indican por cual color de la paleta en uso se van a sustituir los colores custom
                              //del sprite que se vaya a renderizar. Preferiblemente rellenar con el mismo color en el pixel izq y der.
                              //si no usas colores custom en tu sprite puedes ignorar estas variables.

u8* vtStringPtr;              //puntero a la cadena que quieres escribir


vtGameObj* vtGameObjPtr;      //puntero al objeto sobre él que se esta operando y realizando acciones
                              //para muchas funciones de armony tienes que setear el puntero al objeto antes de llamar a la funcion
vtGameObj* vtGameObjPtrAux;   //normalmente no hacen falta dos, pero si en algun momento hace falta se puede usar este puntero
vtGameObj* vtGameObjLastActivePtr;     //[R] esto guardará un puntero al ultimo objeto de la lista que ejecute un step, es simplemente para finalizar los bucles antes de tiempo
u8 vtGameObjCounter;          //[R] contador para saber por que indice de objeto estamos operando (a priori no suele hacer falta para nada, pero ahi esta por si acaso)

u8 vtGameObjCounterActives;   //[R] contador para saber cuantas instancias están activas en este momento (se calcula solo en el runStepEvents, esto quiere decir que si se crean entre medio de los steps es posible que no de el numero exacto)

u8* vtPaletePtr;			      //puntero a la paleta de colores del juego (ojo, colores con +0x40 la instruccion tambien)

u8 vtColisionLastX;		      //[R] guarda el ultimo punto de la colision X y Y. Cuando se llama a las funciones de comprobar colision con
u8 vtColisionLastY;		      //[R] el escenario, en estas dos variables te devuelven en que tile exactamente está la colision


u16 vtClock;                  //variable simple que va a sumar uno en cada iteracion del juego (osea iteracion completa, los 3/4 frames), 
                              //se puede usar para diversas mierdas, si quieres pasarlo a segundos, divide entre 16 (no es exacto, 
                              //pero es rapido) ya que lo exacto seria 16.6667

void (*vtGameController)(void);   //esto es una funcion que controla los elementos que afectan a todo el juego en general (no a entidades concretas)

void (*vtPreDrawFunc)(void);     //esto es una funcion que se llamará justo antes de empezar con el dibujado, se puede usar para dibujar 
                                 //borrar algo de la GUI del frame anterior o cualquier cosa que se te ocurra
void (*vtPostDrawFunc)(void);    //esto es una funcion que se llamará justo despues de acabar con el dibujado, se puede usar para dibujar 
                                 //algo encima (GUI) o ejecutar algo al final de cada step del juego
void (*vtTimeLostFunc)(void);    //esto es un puntero a una funcion, que se llamara cuando el engine quiera perder tiempo, se puede enlazar
                                 //a una funcion que haga tareas secundarias como por ejemplo activar/desactivar instancias, generar eventos, etc





//ENGINE FUNCTIONS--------------------------------------------------------
void vtStartEngine();         //inicializa el engine, hay que llamar a esta funcion una vez al principio
void vtResetEngine();           //ajusta los valores despues de mostrar el menu para que se reseteen y pueda volver a empezar a moverse el scroll y el juego
void vtCreateOptimizationTables();     //crea tablas de aceleración para operaciones matematicas o de dibujado en un lugar de la memoria no accesible durante la carga A700+
void vtRunEngine();           //una vez llames a esta funcion el control pasa al engine
void vtCheckStopGame();          //comprueba si tiene que detener el engine con la variable vtStopGame, si se detiene se para hasta que pulse una tecla 
void vtAdjustDelayInterrupt();      //funcion que agrega un frame más al ciclo del juego si ve que no le ha dado tiempo a dibujar todo y lleva mucho retraso

//void vtMoveScrollReset();     //TODO
   
void vtMoveScrollHorizontalIzq();      //TODO
void vtMoveScrollHorizontalDer();
void vtMoveScrollVerticalArr();
void vtMoveScrollVerticalAba();

void vtConfigInterruptsAndScreen();  //configura las interrupciones (el engine a priori es a ventana completa (sin cambiar valores ni rupturas), si quieres algo más 
										         //tendrás que tocar la funcion vtInterruptFunc)
void vtInterruptFunc();       //funcion de interrupción, ahora mismo solo necesita hacer un +1 al contador de interrupciones, el engine hace el resto
                              //si necesitas hacer rupturas para poner marcador o lo que sea, tendrás que tocar esta funcion
void vtVblankSyncInterrupt();	//esta es la primera interrupcion que va a saltar y lo que hace es esperarse a que coincida con el vsync para avanzar y poner la otra interrupcion

void vtAdjustCRTC();          //ajusta los valores del CRTC para el scroll (el engine lo llamara 1 vez cuando vaya por la interrupcion 11 (al final del frame B)

void vtDrawTile2x8gc();       //dibuja el tile que apunte vtDrawTileSprite en gray code en la posicion de la pantalla que apunte vtPointerAux

//posiblemente la siguiente funcion es la más critica de todas, porque calcula que tiles se tienen que dibujar y donde (ademas de la zona)
//es una funcion lentilla pero lo deja preparado todo para que luego el dibujado sea rapido que es lo que interesa
void vtPushTilesToDraw();     //Prepara los tiles que se van a redibujar en el momento preciso.
void vtPushTilesToDrawColumn();  //igual que el metodo anterior pero optimizado para dibujar una columna (para el scroll horizontal)

void vtPushTilesToDrawAll();	//debe parar el juego y dibujar todo el background (toda la pantalla) lo más rapido posible

void vtRunStepEvents();       //funcion interna que llama a todas las funciones step de todos los objetos activos
void vtRunColisionEvents();   //comprueba si hay colisiones, y en caso afirmativo llama a las funciones de colision de los objetos (si tienen)
void vtRunDrawEvents();       //funcion interna que llama a todas las funciones draw de todos los objetos activos

void vtRenderTilesZone();     //dibuja los tiles pendientes de redibujar de la zona indicada
void vtRenderSpritesZone();   //dibuja los sprites pendientes de dibujar de la zona indicada


void vtRenderTS();            //Turbo Sprite, usa el bytecode de voxeltower para renderizar un sprite (de izq a der)
void vtRenderTSi();           //Turbo Sprite, usa el bytecode de voxeltower para renderizar un sprite (de der a izq)


void vtGetFreeGameObjPtr();   //rellena vtGameObjPtr con un puntero a algun hueco libre, se puede llamar y usar directamente vtGameObjPtr para rellenarlo
                              //       , OJO! si no hay sitio, mete en vtGameObjPtr un 0 para poder detectar que no hay sitio
void vtCleanObject();         //limpia el objeto seleccionado en vtGameObjPtr (lo pone todo a 0 de ese objeto)
void vtObjectsCounter();      //devuelve en A el numero de instancias que estan activas (osea el OBJ_ACTIVE_TYPE > 0)
void vtResetFrame();          //inicializa el frame (limpia los arrays de tiles y sprites para que se empiece a montar el nuevo frame)

u8 vtIsGameObjInScreen();     //calcula si el objeto esta dentro o fuera de la pantalla, se basa en posx posy widthTiles y heightTiles
void vtPushSpriteToDraw();    //pilla el objeto actual en vtGameObjPtr y se prepara para dibujarlo con el array de sprite
void vtGetGameObjScreenPtr(); //pilla el objeto actual y mete en vtPointerAux la direccion de memoria donde se debe dibujar
void vtGetGameScreenPtrBCDE();   //se le pasa el eje X en BC y el eje Y en DE y devuelve en HL la direccion de memoria en pantalla (tambien lo mete en vtPointerAux)


//las funciones de paleta son hardcodeadas para que sean lo más rapida posibles ya que si tardan la división entre negro y paleta se hace difusa mezclando algunos pixeles negros y otros de color
void vtUsePaletteGame();		//pone toda la paleta tal y como se indiquen en las constantes PAL_HARD_x (siendo x de 0 a 15), ojo las constantes se deben definir antes de incluir el engine (ya que este tira de esas constantes)
void vtUsePaletteBlack();		//pone toda la paleta a negro lo más rapidamente posible
void vtConfigurePaletteGame();   //se le pasa un array y prepara la funcion vtUsePaletteGame con los colores indicados

/*
void vtBorderBlack();         //simplemente para hacer debugs de tiempo (puedes cambiar el borde a rojo y luego a negro para hacer un calculo aproximado)
void vtBorderRed();
void vtBorderBlue();
*/


//se le pasa la dirección del ultimo byte del escenario comprimido y esta funcion la descomprime en el lugar indicado para usarla.
//recuerda que los escenarios son de 32x32 metatiles (osea 1024 bytes), no intentes pasar un escenario de otro tamaño o explotará
//recuerda que puedes usar menos parte del escenario, deja el resto a 0, de esta forma te ocupará casi lo mismo al ir comprimido
//void vtLoadSceneCompress(u16 endCompressSceneBytesPtr);

void debugArmony();           //funcion para hacer debugs, no hace nada
//void vtTrapDE();              //estas dos funciones son para debugear si en algun momento determinado DE o HL es menor que C000 
//void vtTrapHL();              //(se usa para saber si va a dibujar fuera de pantalla alguna vez)







u8 vtCheckTile(u8 x, u8 y);		//devuelte el tile que hay en esa posicion
u8 vtCheckMetaTileAsm();         //devuelve en H el metatile que se encuentre en el escenario en la posicion B,C siendo B=X y C=Y
u8 vtCheckTileAsm();             //devuelve en L el tile que se encuentre en el escenario en la posicion B,C siendo B=X y C=Y
                                 //si has llamado antes a vtCheckMetaTileAsm, puedes hacer un call a vtCheckTileAsm2 para sacar el tile
u8 vtCheckTileZoneAsm();         //ponemos los limites en BC y DE (x1 y1 x2 y2) incluidos, 
                                 //y en H ponemos el maximo metatile, 
                                 //y en L el maximo tile si el metatile es mayor de H


//esta funcion pilla vtGameObjPtr y prepara los parametros del vtPushTilesToDraw para limpiar el background del objeto antes de 
//moverse a otra posicion, tambien pone el needRedraw a 0 para que la IA o el jugador lo ponga a 1 si el jugador se ha movido o 
//ha cambiado de sprite. En el step, al final del todo, si needRedraw vale 1 se debe llamar al vtPushTilesToDraw para restaurar 
//el background más tarde en la funcion de draw del objeto si needRedraw sigue valiendo 1 se llamara a dibujar el sprite en la 
//nueva posicion 
void vtPrepareRestoreBackground();  

void vtStepObjectFunc();         //funcion default de Step (controla si se tiene que redibujar el background y actualiza los flags, no mueve el objeto)
void vtDrawObjectFunc();         //funcion default de Draw (controla si el flag del sprite esta activo, y lo dibuja en su posicion)

void vtReorderColisionList();    //esta funcion va haciendo pasadas para reordenar la lista vtGameObjColiList[] ya que 
                                 //para las colisiones debe estar siempre ordenada (usa vtGameObjColiListIndex para 
                                 //saber por donde va)




//FUNCIONES MATEMATICAS RAPIDAS ---------------------------------------------------------------------------
void vtAtan2();         //B es diferencia horizontal, C es diferencia vertical, devuelve en A el angulo (256 based)
void vtAtan2_16();      //esta funcion es la misma que vtAtan2 pero usando dos valores de 16 bits en vez de 2 de 8 bits BC es la dif horizontal DE la vertical
void vtAngleIXtoIY();      //esta funcion devuelve en A el angulo desde IX hasta IY (mirando solo su posicion)
void vtDistance16();    //BC diferencia horizontal, DE diferencia vertical, devuelve en HL distancia entre punto 0,0 y BC,DE
void vtCosAdvance();    //A pasamos el angulo (256 based), en B pasamos la velocidad, y devuelve en DE=cos(A)*B
void vtSinAdvance();    //A pasamos el angulo (256 based), en B pasamos la velocidad, y devuelve en DE=sin(A)*B
void vtLimitSpeed();    //HL pasamos la velocidad maxima, IX la entidad a ajustar, si va más lento no hace nada, si va rapido ajusta la velocidad speedX e speedY
void vtAccelToSpeedAng();  //A pasamos el angulo, B pasamos la velocidad, IX la entidad a ajustar (la velocidad puede ser de 0 a 255)
                        //se realizara una interpolacion entre la velocidad que queremos y la que llevamos usando C (valor de 1 a 15) siendo 1 
                        //la interpolacion más rapida, y 15 la más lenta (se puede usar para hacer derrapar el coche o resbalar)



//FUNCIONES PARA IMPRIMIR CADENAS --------------------------------------------------------------------------
void vtDrawString();    //










//FUNCIONES----------------------------------------------------------------------------------------------------




void vtStartEngine(){
   cpct_setVideoMode(0);
   cpct_setBorder(HW_BLACK);

   //unpacking tiles, metatiles,scene and fast tables
   cpct_zx7b_decrunch_s(#0xB1FF, END_DATAFULL);

   vtCreateOptimizationTables();

   vtUsePaletteGame();

   vtResetEngine();
}


/*
void vtResetEngine()
{
   vtInterruptCycleCount=18;

   vtScrollPage=0x30;     //inicio valores scroll
   vtScrollCRTC3=245;
   vtScrollOffset=0x00;
   vtScrollCRTC5=0;
   vtScrollTurbo=0;
   vtVidMemStart=0;


	//limpio toda la info dinamica que la pongo toda a 0 (gameobjects
   for(u16 ptr=GAME_OBJECTS_PTR; ptr<(GAME_OBJECTS_PTR+0x800); ptr++)
   {
   	*((u8*)ptr)=0;
   }
   
   for(u8 i=0; i<16; i++)
   {
      vtGameObjColiList[i]=(vtGameObj*)(GAME_OBJECTS_PTR+(i*48));
      vtGameObjOrderYList[i]=(vtGameObj*)(GAME_OBJECTS_PTR+(i*48));
   }
}
*/


void vtResetEngine() __naked {
   __asm


		ld	hl,#_vtInterruptCycleCount			;src/armony.h:754: vtInterruptCycleCount=18;
		ld	(hl), #0x12
	
		ld	hl,#_vtScrollCRTC3				;src/armony.h:757: vtScrollCRTC3=245;
		ld	(hl), #0xf5
	
		ld	hl,#_vtScrollPage				;src/armony.h:756: vtScrollPage=0x30;     //inicio valores scroll
		ld	(hl), #0x30
	
	
		xor a
		ld	hl,#_vtScrollOffset				;src/armony.h:758: vtScrollOffset=0x00;
		ld	(hl), a
	
		ld	hl,#_vtScrollCRTC5				;src/armony.h:759: vtScrollCRTC5=0;
		ld	(hl), a
	
		ld	hl,#_vtScrollTurbo				;src/armony.h:760: vtScrollTurbo=0;
		ld	(hl), a
	
		ld	hl, #_vtVidMemStart					;src/armony.h:761: vtVidMemStart=0;
		ld	(hl),a
		inc hl 
		ld (hl),a

      ld (#_vtGameObjColiListIndex),a
	
	
	
	
	
		
		
		ld de,#GAME_OBJECTS_PTR			//   DE -> GAME_OBJECTS_PTR
		ld (de),a						//   (GAME_OBJECTS_PTR)=0
		ld h,d							
		ld l,e							//   HL -> DE
		inc e							//   DE -> DE+1
		ld b,#0x8						
		ld c,a							//   BC = 0x800
      dec bc
		ldir
		
		
		
		
		
		
		ld hl,#GAME_OBJECTS_PTR
		//ld de,#_vtGameObjColiList
      ld de,#GAME_OBJ_COLI_LIST
      //ld ix,#_vtGameObjOrderYList
      ld ix,#GAME_OBJ_ORDER_Y_LIST
		ld bc,#48
	vtResetEngineInitColiList:
		ex de,hl			//  HL apunta al colilist y DE apunta a GAME_OBJECTS_PTR
		ld (hl),e			//  vtGameObjOrderYList[i]=GAME_OBJECTS_PTR+(i*48)
		inc hl
		ld (hl),d
		inc hl
      ld 0(ix),e
      inc ix 
      ld 0(ix),d 
      inc ix
      
		ex de,hl			//  DE apunta al colilist y HL apunta a GAME_OBJECTS_PTR
		add hl,bc			//  siguiente GAME_OBJECTS_PTR
		ld a,#0xb8			//  he llegado a HL=0xB800  ??
		sub h
		jr NZ,vtResetEngineInitColiList		//si no vuelvo al bucle
		
		
		ret
   __endasm;
}


/*
void vtTrapHL() __naked {
   __asm
      ld a,#0xBF
      cp h     //al restar H que debe ser mayor que 0xC0, si NO hay carry es que la vamos a liar, entramos en la trampa
      jr NC,vtTrapHLgo
      xor a    //ld a,#0
      ret

   vtTrapHLgo:
      ld a,#1
      ret
   __endasm;
}

void vtTrapDE() __naked {
   __asm
      ld a,#0xBF
      cp d     //al restar H que debe ser mayor que 0xC0, si NO hay carry es que la vamos a liar, entramos en la trampa
      jr NC,vtTrapDEgo
      xor a    //ld a,#0
      ret

   vtTrapDEgo:
      ld a,#1
      ret
   __endasm;
}
*/
void vtRunEngine()
{
   vtPushTilesToDrawAll();
   cpct_waitVSYNC();
   vtConfigInterruptsAndScreen();		//esto setea la primera interrupcion
	// Loop forever engine (o hasta que reviente)
   while(1)
   {

/*   para debugear....   
FRAME A:
- negro: STEPing game (lee teclado, resetea frame y llama a todos los step de todos los objetos)
- gris: Scroll control (controla el movimiento del scroll hacia donde deba moverse y prepara los tiles que entran en pantalla)
- cyan: DRAWing game (llama a todos los draw de todos los objetos, ojo, esto no dibuja, solo prepara lo que se tiene que dibujar)

FRAME B y C:
- verde: WAITing sync (esta esperando a que el raster se ponga en una posicion concreta para empezar a dibujar)
- amarillo: DRAWing tiles (está dibujando tiles en una de las 4 zonas)
- rojo: DRAWing sprites (está dibujando sprites en una de las 4 zonas)
   */
   
   
   
      //vtInterruptMoment 0 to 5   --------------------- FRAME A (move game and prepare background and sprites to draw)  --------------------------------
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_BLACK);     //BLACK STEPPING GAME
#endif
      cpct_scanKeyboard();
      vtResetFrame();
      
      vtGameController();
      
      vtRunStepEvents();
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_BRIGHT_WHITE);         //STEP COMPLETE, WAIT UNTIL RASTER PASS FRAME A AND ENTER ZONE 2
#endif

      //vtMoveScrollReset();
      if(vtScrollLockTime==0)
      {
         vtMoveScrollHorizontalIzq();
         vtMoveScrollHorizontalDer();
         vtMoveScrollVerticalArr();
         vtMoveScrollVerticalAba();
      }else{
         vtScrollLockTime=vtScrollLockTime-1;
      }


      

#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_WHITE);         //STEP COMPLETE, WAIT UNTIL RASTER PASS FRAME A AND ENTER ZONE 2
#endif   
      vtRunColisionEvents();
  	      
         
      

//----------------------------------------------------------------------------------------------
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_CYAN);         //STEP COMPLETE, WAIT UNTIL RASTER PASS FRAME A AND ENTER ZONE 2
#endif
      
      vtPreDrawFunc();

      vtRunDrawEvents();

      
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_GREEN);         //STEP COMPLETE, WAIT UNTIL RASTER PASS FRAME A AND ENTER ZONE 2
#endif
      while(vtInterruptMoment < 9)
      {
         //wait to vtInterruptMoment>5 (no problem if pass 5 or more)
         vtReorderColisionList();
         vtTimeLostFunc();
      }
      

   
      //vtInterruptMoment 6 to 11  ------------------------  FRAME B (draw zone 1 and zone 2 after pass raster)
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_YELLOW);       //YELLOW, DRAWING ZONE 1 (raster is in zone 2 or more)
#endif
      vtRenderZoneStep=1;
      vtRenderTilesZone();
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_RED);       //RED, DRAWING ZONE 1 (raster is in zone 2 or more)
#endif
      vtRenderSpritesZone();

#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_GREEN);          //RED, ZONE 1 COMPLETE, WAIT RASTER ENTER ZONE 3
#endif

      while(vtInterruptMoment < 10 )
      {
         //wait to raster enter in zone 3 in frame B (if already enter in zone 3 go go go go go)
         vtReorderColisionList();
         vtTimeLostFunc();
      }
      
      
      
      
      
      
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_YELLOW);         //YELLOW, DRAWING ZONE 2 (raster is in zone 3 or more)
#endif
      vtRenderZoneStep=2;
      vtRenderTilesZone();
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_RED);       //RED, DRAWING ZONE 1 (raster is in zone 2 or more)
#endif
      vtRenderSpritesZone();
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_GREEN);        //MAUVE, ZONE 2 COMPLETE, WAIT RASTER ENTER ZONE 4
#endif
      while(vtInterruptMoment < 11 )
      {
         //wait to raster enter in zone 4 in frame B (if already enter in zone 4 go go go go go) aqui debe ajustar el CRTC
         vtReorderColisionList();
         vtTimeLostFunc();
      }




#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_YELLOW);        //YELLOW, DRAWING ZONE 3 (raster is in zone 4 or more)
#endif
      vtRenderZoneStep=3;
      vtRenderTilesZone();
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_RED);       //RED, DRAWING ZONE 1 (raster is in zone 2 or more)
#endif
      vtRenderSpritesZone();

     
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_GREEN);       //PURPLE, ZONE 3 COMPLETE, WAIT RASTER ENTER ZONE 5
#endif
      while(vtInterruptMoment < 12 )
      {
         //wait to raster enter in zone 5 in frame B (if already enter in zone 4 go go go go go)
         vtReorderColisionList();
         vtTimeLostFunc();
      }





#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_YELLOW);     //SKY_BLUE, DRAWING ZONE 4 (raster is in zone 5 or FRAME C)
#endif
      vtRenderZoneStep=4;
      vtRenderTilesZone();     //voy a probar a no renderizar el cuarto cacho?
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_RED);       //YELLOW, DRAWING ZONE 1 (raster is in zone 2 or more)
#endif
      vtRenderSpritesZone();

   
#ifdef DEBUG_PROC_BLOCKS
      cpct_setBorder(HW_GREEN);       //ORANGE, ZONE 4 COMPLETE, WAIT FINISH FRAME C TO LOOP
#endif

      vtPostDrawFunc();

      vtReorderColisionList();      //pongo esto fuera para que como minimo se ejecute 1 vez por step
      vtTimeLostFunc();

      
      vtInterruptCycleCount=18;
        

      while(vtInterruptMoment<vtInterruptCycleCount)     //luego si sobra más tiempo que se ejecute más veces
      {
      	vtReorderColisionList();
         vtTimeLostFunc();
      }

      __asm
         di
      __endasm;

      vtInterruptMoment=vtInterruptMoment-vtInterruptCycleCount;

      __asm
         ei
      __endasm;

#ifdef DEBUG_INTERRUPT_DELAY
      vtAdjustDelayInterrupt();
#endif


      vtCheckStopGame();

      //cuando quiera salir le activo todos los flags al prota y pa fuera
		if(  *((u8*)(0xB500+OBJ_FLAGS)) ==255 )
		{
		   break;	//si la vida de la prota es negativo, rompemos el bucle while y nos vamos (no se si esto funcara...)
		}
		
   }
}




void vtAdjustDelayInterrupt() __naked {
   __asm
         //esta funcion es simplemente para ver si el engine se agobia mucho o no, va a guardar en  debugDelayInterruptMax el maximo retraso que haya tenido de interrupciones
         //esa variable significa cuantas interrupciones de más ha necesitado para acabar de dibujar el frame completo en el ciclo del juego (osea, cuantas interrupciones 
         //se ha comido del siguiente ciclo de juego)
         //si se come más de 6 quizas se pueda agregar un frame intermedio para no romper el engine

      vtAdjustDelayInterruptStart:
         ld a,(#_vtInterruptMoment)
         cp #6
         ret C       //si hay carry vamos más o menos bien, para fuera del tiron


         //si no hay carry tenemos un problemita, estamos tardando mucho en renderizar y lo vamos a arreglar 
         //enchufando un frame en blanco de más para que le de tiempo de acabar de dibujarlo todo
         //pero antes me guardo cual ha sido el maximo para saber como de mal vamos
         ld a,(#_debugDelayInterruptMax)
         ld b,a

         di                //deshabilito las int por si acaso salta mientras hago esto
         ld a,(#_vtInterruptMoment)
         cp b
         jr C,debugDelayInterrupts2          

         ld (#_debugDelayInterruptMax),a     //hay nuevo maximo, actualizo

      debugDelayInterrupts2:
         sub #6
         ld (#_vtInterruptMoment),a       //agregamos un cuarto frame

                  
         // vtInterruptMoment fuese 9 con lo cual estaria en negro, nosotros le ponemos 3 (que ya se ha saltado el 2 que 
         //es el que pone el color) y entonces renderizaria todo ese frame en negro y pegaria un parpadeazo muy guapo


      debugDelayInterrupts3:
         ei          //vuelvo a habilitar las int que ya he cambiado el interruptmoment metiendole 6 interrupciones más para que enchufe un frame 
                     //de más (en vez de 3 frames, este ciclo pillará 4 frames)
         //call #_vtUsePaletteGame       //si vamos a retrasar los frames, tengo que ponerle que use la paleta del juego porque puede darse el caso que 
         jr vtAdjustDelayInterruptStart      //volvemos a ejecutar lo mismo por si por casualidad fuese mayor que 6 y fuese desastre total
         

         ret
   __endasm;
}


//si hay una conversacion activa, tengo que bloquearlo todo quedandome en las interrupciones del 1 al 6 hasta que alguien pulse una tecla, entonces 
//en la interrupcion 6 la pongo a 0 y sigo con el bucle del juego
void vtCheckStopGame() __naked {
   __asm
         ld a,(#_vtStopGame)
         or a
         ret Z

         ld l,#NUMERO_FRAMES_BLOQUEO_CONVERSACION

      checkConversacionActivaBucle1:      //lo dejamos bloqueado hasta que suelte todas las teclas
         ld a,(#_vtInterruptMoment)
         cp #6
         jr C,checkConversacionActivaBucle2
         
         di
         ld a,(#_vtInterruptMoment)
         sub #6
         ld (#_vtInterruptMoment),a
         ei

         xor a 
         or l 
         jr Z,checkConversacionActivaBucle2

         dec l    //bajamos un frame de bloqueo

      checkConversacionActivaBucle2:
         xor a 
         or l
         jr NZ,checkConversacionActivaBucle1    //hasta que L no sea 0 no vamos a leer el teclado

         push hl
         call _cpct_scanKeyboard
         call cpct_isAnyKeyPressed_asm
         pop hl
         or a
         jp NZ,checkConversacionActivaBucle1    //lo bloqueo hasta que se suelten todas las teclas
      




      checkConversacionActivaBucle4:      //y ahora lo bloqueo hasta que pulse una tecla 
         ld a,(#_vtInterruptMoment)
         cp #6
         jr C,checkConversacionActivaBucle5
         
         di
         ld a,(#_vtInterruptMoment)
         sub #6
         ld (#_vtInterruptMoment),a
         ei
      
      checkConversacionActivaBucle5:
         call cpct_scanKeyboard_asm
         call cpct_isAnyKeyPressed_asm
         or a
         jp Z,checkConversacionActivaBucle4    //lo bloqueo hasta que se suelten todas las teclas

         //cuando llegue aqui tenemos que esperar a que la vtInterruptMoment se ponga en 6, y luego ponerla en 0 y salir


      checkConversacionActivaBucle8:      //y ahora lo bloqueo hasta que pulse una tecla 
         ld a,(#_vtInterruptMoment)
         cp #6
         jr C,checkConversacionActivaBucle8
         
         di
         ld a,(#_vtInterruptMoment)
         sub #6
         ld (#_vtInterruptMoment),a
         ei

         //y salimos con la interrupcion a cero para que siga el juego

      ret
   __endasm;
}



/*
void vtMoveScrollReset() __naked {
   __asm
      xor a
      ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLX),a       //pongo un NOP aqui
      ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLY),a       //pongo un NOP aqui
      ret
   __endasm;
}
*/

void vtPushTilesToDrawAll()
{
   u8 ind=0;
   vtUsePaletteBlack();
   vtResetFrame();
   while(ind<25)
   {
      vtPushTilesIniX=0;
      vtPushTilesEndX=40;
      vtPushTilesIniY=ind;
      vtPushTilesEndY=ind+1;
      vtPushTilesToDraw();
      vtRenderZoneStep=(ind/6)+1;
      if(vtRenderZoneStep>4)
      {
         vtRenderZoneStep=4;
      }
      vtRenderTilesZone();
      vtResetFrame();
      ind=ind+1;
   }
}


void vtRenderTilesZone() __naked {
   __asm
   //ya tengo apuntando a la zona que tengo que renderizar
   //vtRenderZoneBgPtr=&vtTileRowToDraw1[0]+((vtRenderZoneStep-1)*256);
   //de momento no haga más ná pero tendra un while que vaya renderizando ristras de backgrounds
   //while(*vtRenderZoneBgPtr!=0)
   //OJO! este metodo tiene que llamar a vtAdjustCRTC() una vez cuando llegue a vtInterruptMoment=11 o 12 para que ajuste el CRTC pero ojito que solo lo tiene que llamar 1 vez


      vtRenderZoneStart:
         //ld hl,#_vtTileRowToDraw1      //vtRenderZoneBgPtr=&vtTileRowToDraw1[0]+((vtRenderZoneStep-1)*256);
         ld hl,#TILEROW_TO_DRAW_1
         ld a,(#_vtRenderZoneStep)
         dec a
         add h
         ld h,a      //vtRenderZoneBgPtr=&vtTileRowToDraw1[0]+((vtRenderZoneStep-1)*256);

         //ya tengo en HL vtRenderZoneBgPtr apuntando al principio de las ristras que debo dibujar
         //mientras no me encuentre un 0 de primeras...
      vtRenderZoneBucle:
         ld a,(hl)
         or a
         //jp Z,vtRenderZoneStartSprites   //si me encuentro un 0 ya he acabao esta ristra de backgrounds, puedo ir a renderizar sprites
         jp Z,vtRenderZoneBlackLineAndGo   //si me encuentro un 0 ya he acabao esta ristra de backgrounds, puedo ir a renderizar sprites

         ld b,a      //si no es cero lo meto en B porque me va a hacer de bucle
         inc hl
         ld e,(hl)
         inc hl
         ld d,(hl)      //dejo en DE el desplazamiento inicial
         inc hl

      vtRenderZoneBucleDrawTile:
         //leo el tile y tiro millas
         ld c,(hl)
         inc hl
         ld a,(hl)
         inc hl
         push hl
         push de
         ld h,a
         ld l,c         //aqui ya tengo en DE el memAux (donde voy a pintar) y en HL el sprite que voy a pintar
         call vtDrawTile2x8gcFastStart2       //hago una llamada rapida sin guardar en variables
         pop de
         
         inc de
         inc de
         
         //aqui hay que revisar que DE no se pase del limite 0xC7D0 , si DE es > 0xC7D0 se va a liar parda porque va a intentar escribir fuera de la memoria de video
         
		 /*ld hl, #0xC7D0       
		 sbc hl,de
		 jr NC,vtRenderZoneBucleDrawTiles2	//si no hay carry no problem, tira milla
		 
		 //si hay carry, hay que "ajustar" el puntero para que no se salga de la memoria de video
		 ld hl,#0xF830		//se le suma este magic number y hace que de la vuelta y vuelva a empezar desde C000 considerando el desplazamiento que ya lleva
		 add hl,de
		 ex de,hl		//y lo intercambio porque el resultado se queda en HL y lo quiero en DE
		 */
		 
      vtRenderZoneBucleDrawTiles2:
         pop hl
      
         
		 
         
         
         djnz vtRenderZoneBucleDrawTile

         jp vtRenderZoneBucle      //voy de nuevo al principio del bucle inicial







//--------------------------------------Y AHORA LA LINEA NEGRA A IZQ O DERECHA-------------------------------------------------
      vtRenderZoneBlackLineAndGo:
         
   
   
         //aqui tenemos que renderizar el trozo de linea que toque (de las 4 zonas), miro en cual estoy y dibujo lo que toque
         //en C tengo la zona que tengo que dibujar (teniendo en cuenta que si C=5 significa que es la 4º zona)
         //asi que simplemente decremento C hasta que llegue a Zero para saber en que zona estoy
         ld hl,(#_vtVidMemStart)       //meto en HL donde empieza la memoria de video
         ld a,#0xC0
         add h
         ld h,a                        //la desplazo a la pantalla
         ld b,#6     

         ld a,(#_vtRenderZoneStep)
         ld c,a      //lo dejo en C

         

         ld a,(#_vtScrollCRTC3)     //leo en A donde esta el vtScrollCRTC3 para ver si es par o impar (no necesito más)
         bit 0,a
         jr NZ,vtRenderZoneBlackLineAndGoLineDer







      vtRenderZoneBlackLineAndGoLineIzq:              //--------------TENGO QUE DIBUJAR LA LINEA IZQUIERDA-----------------
         dec c          //vtRenderZoneStep-1==0 ??
         jr NZ,vtRenderZoneBlackLineAndGoZone2
         //renderizo la linea de la zona 1
         ld de,#0x0050  //para ir sumando al siguiente caracter
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA IZQUERDA ZONA 1---------------------------

      


      vtRenderZoneBlackLineAndGoZone2:
      
         dec c    //vtRenderZoneStep-2==0 ??
         jr NZ,vtRenderZoneBlackLineAndGoZone3
         //renderizo la linea de la zona 2
         //TODO incrementa 6 caracteres a HL y 1 a B para ponerlo a 7
         
         
         ld de,#0x01E0     //empieza en caracter 6
         add hl,de
         jr NC,vtRenderZoneBlackLineAndGoZone2g
         //reajuste por pasada
         ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a

      vtRenderZoneBlackLineAndGoZone2g:
         ld de,#0x0050
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA IZQUERDA ZONA 2---------------------------




      vtRenderZoneBlackLineAndGoZone3:
         dec c         //vtRenderZoneStep-3==0 ??
         jr NZ,vtRenderZoneBlackLineAndGoZone4

         //renderizo la linea de la zona 3
         ld de,#0x03C0
         add hl,de
         jr NC,vtRenderZoneBlackLineAndGoZone3g
         //reajuste por pasada
         ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a

      vtRenderZoneBlackLineAndGoZone3g:
         ld de,#0x0050
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA IZQUERDA ZONA 3---------------------------

      
      


      vtRenderZoneBlackLineAndGoZone4:
         //renderizo la linea de la zona 4        //vtRenderZoneStep==4 ??
         inc b    //la ultima zona tiene un caracter más
         ld de,#0x05A0
         add hl,de
         jr NC,vtRenderZoneBlackLineAndGoZone4g
         //reajuste por pasada
         ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a

      vtRenderZoneBlackLineAndGoZone4g:
         ld de,#0x0050
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA IZQUERDA ZONA 4---------------------------






      vtRenderZoneBlackLineAndGoLineDer:              //--------------TENGO QUE DIBUJAR LA LINEA DERECHA-----------------
         ld a,#79
         add l
         ld l,a    
         jr NC,vtRenderZoneBlackLineAndGoLineDer2
         inc h
      vtRenderZoneBlackLineAndGoLineDer2:
         
         dec c
         jr NZ,vtRenderZoneBlackLineAndGoZone2d
         //renderizo la linea de la zona 1
         ld de,#0x0050  //para ir sumando al siguiente caracter
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA DERECHA ZONA 1---------------------------


      vtRenderZoneBlackLineAndGoZone2d:
         dec c
         jr NZ,vtRenderZoneBlackLineAndGoZone3d
         //renderizo la linea de la zona 2
         //TODO incrementa 6 caracteres a HL y 1 a B para ponerlo a 7
         
         ld de,#0x01E0
         add hl,de
         jr NC,vtRenderZoneBlackLineAndGoZone2dg
         //reajuste por pasada
         ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a

      vtRenderZoneBlackLineAndGoZone2dg:
         //renderizo la linea de la zona 2
         ld de,#0x0050  //para ir sumando al siguiente caracter
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA DERECHA ZONA 2---------------------------



      vtRenderZoneBlackLineAndGoZone3d:
         dec c
         jr NZ,vtRenderZoneBlackLineAndGoZone4d
         ld de,#0x03C0
         add hl,de
         jr NC,vtRenderZoneBlackLineAndGoZone3dg
         //reajuste por pasada
         ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a
         
      vtRenderZoneBlackLineAndGoZone3dg:
         //renderizo la linea de la zona 2
         ld de,#0x0050  //para ir sumando al siguiente caracter
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA DERECHA ZONA 3---------------------------

      
      vtRenderZoneBlackLineAndGoZone4d:
         inc b    //la ultima zona tiene un caracter más
         ld de,#0x05A0
         add hl,de
         jr NC,vtRenderZoneBlackLineAndGoZone4dg
         //reajuste por pasada
         ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a
         
      vtRenderZoneBlackLineAndGoZone4dg:
         //renderizo la linea de la zona 2
         ld de,#0x0050  //para ir sumando al siguiente caracter
         jp vtRenderZoneBlackLineDraw                 //--------------DIBUJO LINEA DERECHA ZONA 4---------------------------




      //esto es la parte que dibuja la linea negra, se le tiene que pasar 
      //HL el principio de la linea
      //DE 0x0050 es fijo para pasar al siguiente caracter
      //C = 0
      //B = 6 o 7 en funcion de la zona que sea es el numero de caracteres

      vtRenderZoneBlackLineDraw:    //hay que ir cambiando los bits de H 5,4,3 para pasar por los 8 estados de esos 3 bits
         ld	a,(#_vtScrollTurbo)
         or a
         ret NZ

         //xor a  si entra aqui ya es cero, con lo cual puedo ahorrarme el xor
         //ld c,#0
         ld c,a

      vtRenderZoneBlackLineDrawBuc:
         ld (hl),c      //000
         set 3,h        
         ld (hl),c      //001
         set 4,h
         ld (hl),c      //011
         set 5,h
         ld (hl),c      //111
         res 4,h
         ld (hl),c      //101
         res 3,h
         ld (hl),c      //100
         set 4,h
         ld (hl),c      //110
         res 5,h
         ld (hl),c      //010
         res 4,h        //volvemos a 000 como el principio

         //pasamos al siguiente caracter, y si nos colamos ajustamos
         add hl,de
         jr NC,vtRenderZoneBlackLineDraw2
         ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a
         xor a

      vtRenderZoneBlackLineDraw2:
         djnz vtRenderZoneBlackLineDrawBuc

         ret      //he acabao, nos piramos





   __endasm;
}


//este metodo dibuja los sprites de la zona (vtRenderZoneStep-1), siempre se dibujan una vez acabados todos los tiles de esa zona que van antes
void vtRenderSpritesZone() __naked {
   __asm

      vtRenderZoneStartSprites:
         

         ld a,(#_vtRenderZoneStep)
         //dec a
         ld c,a      //lo dejo en C  zone - 1

         //ld hl,#_vtSpriteListToDraw
         ld hl,#VT_SPRITE_LIST_TO_DRAW
         //ld hl,(#_vtSpriteListToDrawPtr)

         
      vtRenderZoneStartSpritesBucle:
      	//ld a,(#_vtInterruptMoment)
      	//cp #INTERRUPT_MOMENT_LIMIT_SPRITE_DRAW
      	//jp NC,vtRenderZoneOverHeat		//detecta si hay sobre calentamiento del engine
      	//ret NC 		//si ya hemos llegado a la interrupcion limite (normalmente 18) que debe de pintar sprites porque puede joderlo todo
      
         ld a,(hl)
         or a
         ret Z    //nos piramos, no hay más sprites para renderizar
         //jp Z,vtRenderZoneFinaliza    //si es 0 nos piramos
         
         cp c
         jr Z,vtRenderZoneStartSpritesBucleRenderiza
         //hay que saltarse este sprite
         inc hl      //saltamos la zona
         inc hl   
         inc hl      //saltamos el screen pointer
         inc hl   
         inc hl      //saltamos el sprite pointer
         inc hl      //saltamos el custom color A y B
         inc hl      //saltamos el width del flip o no flip
         jp vtRenderZoneStartSpritesBucle
         //ld (#_vtSpriteListToDrawPtr),hl 
         //ret


      vtRenderZoneStartSpritesBucleRenderiza:
         //hay que dibujar el sprite
         inc hl      //saltamos la zona
         ld e,(hl)
         inc hl
         ld d,(hl)      //pillo en DE el screenPointer
         inc hl

         ld (#_vtScreenPtr),de

         ld e,(hl)
         inc hl
         ld d,(hl)
         inc hl

         ld (#_vtSpritePtr),de

         push bc           //guardamos BC antes de perderlo


         ld a,(hl)      //leo el custom color A+B
         and #0b01010101
         ld b,a
         rlca
         or b
         ld (#_vtDrawSpriteCustomColor1),a


         ld a,(hl)      //leo el custom color A+B
         and #0b10101010
         ld b,a
         rrca
         or b
         ld (#_vtDrawSpriteCustomColor2),a
         inc hl


         ld a,(hl)      //leo si hay hacer flip (width en bytes) o no (0)
         inc hl

         
         push hl        //pusheo HL antes de perderlo

         
         or a
         jr Z,vtRenderZoneStartSpritesBucleRenderiza1Der    //si es cero no hay que hacer flip

         //si A > 0 lo que significa que vamos a dibujar el sprite al reves, lo que tiene que llevar A es el numero de bytes en horizontal que ocupa el sprite
         //ya que para dibujarlo al reves ddebemos colocarlo en el otro lado tambien
         add a       //le sumo A de nuevo porque el width esta en tiles y lo quiero en bytes
         dec a          //le sumo 1 porke si lo voy a dibujar al reves tengo que añadirle uno para que se coloque exactamente en la misma posicion y no mal
         ld hl,(#_vtScreenPtr)
         add l
         jr NC,vtRenderZoneStartSpritesBucleRenderiza1Izq2
         inc h

         /*jr NC,vtRenderZoneStartSpritesBucleRenderiza1Izq2
         
         ld l,a      //si hay carry es que con el inc h hemos pasado a 0x0000, por lo tanto, le sumamos C050 para que vaya al caracter siguiente sin petar
         ld bc,#MEMOUT_JUMP_VIDEO_MEM	//ajuste siguiente caracter
	      add hl,bc
         ld a,l*/

      vtRenderZoneStartSpritesBucleRenderiza1Izq2:
         ld l,a



         /*ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
         and #7
         add #192  //le sumo C000 para tener hl+C000
         ld h,a*/
         set 7,h
         set 6,h

         ld (#_vtScreenPtr),hl

         //del reves
         //call _vtRenderSpriteIBC
         call _vtRenderTSi
         jp vtRenderZoneStartSpritesBucleRenderiza2




      vtRenderZoneStartSpritesBucleRenderiza1Der:
         //del derecho no tengo que hacer nada más
         //call _vtRenderSpriteBC
         call _vtRenderTS

      vtRenderZoneStartSpritesBucleRenderiza2:
         

         pop hl      //recupero hl
         pop bc      //recupero BC   (en C tengo la zona)
         //inc hl      //como lo deje el en ultimo byte lo incremento para pasar al siguiente sprite
         jp vtRenderZoneStartSpritesBucle      //y vuelvo al bucle


      //vtRenderZoneFinaliza:   // (no hace falta, esta el ret arriba)
         //ret      //he acabao, nos piramos
       
      //vtRenderZoneOverHeat:
      	//ld a,#OVERHEAT_RELAX_FRAMES			//hay sobrecalentamiento, demasiados sprites a dibujar, marcamos para que se detenga el scroll un poco
      	//ld (#_vtEngineOverHeat),a
         
      	//ret
   __endasm;
}



//esta funcion va haciendo pasadas para reordenar la lista vtGameObjColiList[] ya que para las colisiones debe 
//estar siempre ordenada (usa vtGameObjColiListIndex para saber por donde va)
void vtReorderColisionList() __naked {
   __asm
      ld hl,#_vtGameObjColiListIndex
      ld a,(hl)
      inc (hl)			//le añado 1 para la siguiente vez que lo lea
      cp #14				//como se mira por el que va y por el siguiente, el 14 es el ultimo que debe mirar, por lo tanto si llego a 14 reseteo el indice
      jr NZ,vtReorderColisionLists2
		ld (hl),#0		//reseteo el indice porque ya he llegao al ultimo      

   vtReorderColisionLists2:
      add a,a		//multiplico por 2 porque es un array de direcciones 2 bytes
	   ld	l,a
	   ld	h,#0
      push hl           //me guardo HL que tiene el desplazamiento correcto para luego comprobar la lista de orderY
	   //ld	de, #_vtGameObjColiList
      ld de,#GAME_OBJ_COLI_LIST
	   add hl, de
	   ld a,(hl)
	   .dw #0x6FDD 	//ld ixl,a
      //ld c,(hl)
      inc hl
      ld a,(hl)
	   .dw #0x67DD	//ld ixh,a
      //ld b,(hl)
      inc hl
      ld a,(hl)
	   .dw #0x6FFD	//ld iyl,a
      //ld e,(hl)
      inc hl
      ld a,(hl)
	   .dw #0x67fd	//ld iyh,a
      //ld d,(hl)

      //ya tengo IX apuntando al objeto por el que voy y IY apuntando al siguiente, miro si los tengo que intercambiar
      ld a,OBJ_ACTIVE_TYPE(ix)		//leo el tipo del IX
      or a
      jr NZ,vtReorderColisionLists6			//si no es cero no hago intercambio por vacio
      //si llego aqui IX no esta activo, si IY si esta activo hago el intercambio
      cp OBJ_ACTIVE_TYPE(iy)		//resto el tipo de IX y si hay carry es que IX esta inactivo y IY esta activo, hago el intercambio
		
      jr NC,vtReorderOrderYList     //si no hay carry significa que los 2 estan inactivos, en este caso no tengo que hacer nada, salgo directamente
		
		
      //si hay carry es que IX esta inactivo y IY esta activo, hago el intercambio para que los activos esten a la derecha y salgo
   vtReorderColisionLists4intercambio:
      //los inserto al reves
      .dw #0x7CDD		//ld a,ixh
      ld (hl),a
      dec hl
      .dw #0x7DDD		//ld a,ixl
      ld (hl),a
		dec hl
		.dw #0x7CFD		//ld a,iyh
      ld (hl),a
		dec hl
		.dw #0x7DFD		//ld a,iyl
      ld (hl),a
		
		jr vtReorderOrderYList
      //ret 	//y ya esta, pa fuera, he hecho el intercambio y salgo
		
		
	vtReorderColisionLists6:
		//si llego aqui IX esta activo y IY no lo se aun
		ld a,OBJ_ACTIVE_TYPE(iy)		//leo el tipo del IY
		or a
      jr Z,vtReorderOrderYList
		//ret Z		//si IY no está activo no tengo que intercambiar nada, lo dejo todo como esta y salgo
		
	vtReorderColisionLists8:
		//si llego aqui IX está activo y IY tambien, tengo que comprobar el ejeX y poner el menor a la izquierda y el mayor a la derecha
		//voy a meter IX.POSX en DE y IY.POSY en BC, hago la resta y si no hay carry tengo que intercambiar (si hay carry ya estan en el orden correcto, no hace falta que cambie nada)
		/*ld e,OBJ_POSX(ix)
		ld d,OBJ_POSX+1(ix)
		ld c,OBJ_POSX(iy)
		ld b,OBJ_POSX+1(iy)
		ex de,hl*/
   
      ex de,hl    //dejo en DE por donde voy
      ld l,OBJ_POSX(iy)
      ld h,OBJ_POSX+1(iy)
      ld b,OBJ_WIDTH(iy)
      ld c,#0
      //tengo el ancho en DE (transformado ya a pixeles), ahora me quedo con un cuarto de ese ancho
      sra b    //divido entre 2 el ancho
      rr c
      sra b    //divido entre 4 el ancho
      rr c
      add hl,bc         //meto en HL la posicion X + 1/4 de ancho
      push hl

      ld l,OBJ_POSX(ix)
      ld h,OBJ_POSX+1(ix)
      ld b,OBJ_WIDTH(ix)
      ld c,#0
      //tengo el ancho en DE (transformado ya a pixeles), ahora me quedo con un cuarto de ese ancho
      sra b    //divido entre 2 el ancho
      rr c
      sra b    //divido entre 4 el ancho
      rr c
      add hl,bc         //meto en HL la posicion X + 1/4 de ancho
      
      pop bc


		xor a
		sbc hl,bc
      jr C,vtReorderOrderYList
		//ret C		//si hay carry es correcto, no tengo que cambiar nada y nos vamos
		
		
	vtReorderColisionLists10:
		//si llego aqui es que IX esta más a la derecha que IY y por lo tanto hay que cambiarlos
		ex de,hl			//recupero HL donde estaba
		jr vtReorderColisionLists4intercambio		//esto hace el intercambio y sale
		
		
		//      ret		no hace falta








   vtReorderOrderYList:
      pop hl           //me guardo HL que tiene el desplazamiento correcto para luego comprobar la lista de orderY
	   //ld	de, #_vtGameObjOrderYList
      ld de,#GAME_OBJ_ORDER_Y_LIST
	   add hl,de
	   ld a,(hl)
	   .dw #0x6FDD 	//ld ixl,a
      //ld c,(hl)
      inc hl
      ld a,(hl)
	   .dw #0x67DD	//ld ixh,a
      //ld b,(hl)
      inc hl
      ld a,(hl)
	   .dw #0x6FFD	//ld iyl,a
      //ld e,(hl)
      inc hl
      ld a,(hl)
	   .dw #0x67fd	//ld iyh,a
      //ld d,(hl)

      //ya tengo IX apuntando al objeto por el que voy y IY apuntando al siguiente, miro si los tengo que intercambiar
      ld a,OBJ_ACTIVE_TYPE(ix)		//leo el tipo del IX
      or a
      jr NZ,vtReorderOrderYLists6			//si no es cero no hago intercambio por vacio
      //si llego aqui IX no esta activo, si IY si esta activo hago el intercambio
      cp OBJ_ACTIVE_TYPE(ix)		//resto el tipo de IX y si hay carry es que IX esta inactivo y IY esta activo, hago el intercambio
      ret NC				//si no hay carry significa que los 2 estan inactivos, en este caso no tengo que hacer nada, salgo directamente
		

		
      //si hay carry es que IX esta inactivo y IY esta activo, hago el intercambio para que los activos esten a la derecha y salgo
   vtReorderOrderYLists4intercambio:
      //los inserto al reves
      .dw #0x7CDD		//ld a,ixh
      ld (hl),a
      dec hl
      .dw #0x7DDD		//ld a,ixl
      ld (hl),a
		dec hl
		.dw #0x7CFD		//ld a,iyh
      ld (hl),a
		dec hl
		.dw #0x7DFD		//ld a,iyl
      ld (hl),a

      ret 	//y ya esta, pa fuera, he hecho el intercambio y salgo
		
		
	vtReorderOrderYLists6:
		//si llego aqui IX esta activo y IY no lo se aun
		ld a,OBJ_ACTIVE_TYPE(iy)		//leo el tipo del IY
		or a
		ret Z		//si IY no está activo no tengo que intercambiar nada, lo dejo todo como esta y salgo
		
	vtReorderOrderYLists8:
		//si llego aqui IX está activo y IY tambien, tengo que comprobar el ejeX y poner el menor a la izquierda y el mayor a la derecha
		//voy a meter IX.POSX en DE y IY.POSY en BC, hago la resta y si no hay carry tengo que intercambiar (si hay carry ya estan en el orden correcto, no hace falta que cambie nada)
		/*ld e,OBJ_POSX(ix)
		ld d,OBJ_POSX+1(ix)
		ld c,OBJ_POSX(iy)
		ld b,OBJ_POSX+1(iy)
		ex de,hl*/
   
      ex de,hl    //dejo en DE por donde voy
      ld l,OBJ_POSY(iy)
      ld h,OBJ_POSY+1(iy)
      ld b,OBJ_HEIGHT(iy)
      ld c,#0
      //tengo el ancho en DE (transformado ya a pixeles), ahora me quedo con un cuarto de ese ancho
      sra b    //divido entre 2 el ancho
      rr c
      sra b    //divido entre 4 el ancho
      rr c
      add hl,bc         //meto en HL la posicion X + 1/4 de ancho
      push hl

      ld l,OBJ_POSY(ix)
      ld h,OBJ_POSY+1(ix)
      ld b,OBJ_HEIGHT(ix)
      ld c,#0
      //tengo el ancho en DE (transformado ya a pixeles), ahora me quedo con un cuarto de ese ancho
      sra b    //divido entre 2 el ancho
      rr c
      sra b    //divido entre 4 el ancho
      rr c
      add hl,bc         //meto en HL la posicion X + 1/4 de ancho
      
      pop bc


		xor a
		sbc hl,bc
		ret C		//si hay carry es correcto, no tengo que cambiar nada y nos vamos
		
		
	vtReorderOrderYLists10:
		//si llego aqui es que IX esta más a la derecha que IY y por lo tanto hay que cambiarlos
		ex de,hl			//recupero HL donde estaba
		jr vtReorderOrderYLists4intercambio		//esto hace el intercambio y sale


      ret
   __endasm;
}



/*
void vtBorderBlack()
{
   cpct_setBorder(HW_BLACK);
}
void vtBorderRed()
{
   cpct_setBorder(HW_RED);
}

void vtBorderBlue()
{
   cpct_setBorder(HW_BLUE);
}
*/

//rellena vtPointerAux y vtZoneCalc a partir de lo que tenga el objeto
void vtGetGameObjScreenPtr() __naked {
   __asm
      xor a
      ld (#_vtZoneCalc),a    //reinicio vtZoneCalc a 0

      ld ix,(#_vtGameObjPtr)

      //calculo la zona
      ld a,(#_vtSceneScrollY)      //pillo vtSceneScrollY
      ld c,a
      ld a,OBJ_POSY+1(ix)      //pillo posy H
      add OBJ_HEIGHT(ix)
      inc a
      sub c
      cp #25
      ret NC      //si no hay carry es que esta fuera, no se puede dibujar


      sub #6
      jr NC,vtGetGameObjScreenPtrs2
      ld a,#1
      jp vtGetGameObjScreenPtrs5
   vtGetGameObjScreenPtrs2:
      sub #7
      jr NC,vtGetGameObjScreenPtrs3
      ld a,#2
      jp vtGetGameObjScreenPtrs5
   vtGetGameObjScreenPtrs3:
      sub #6
      jr NC,vtGetGameObjScreenPtrs4
      ld a,#3
      jp vtGetGameObjScreenPtrs5
   vtGetGameObjScreenPtrs4:
      ld a,#4

   vtGetGameObjScreenPtrs5:
      ld (#_vtZoneCalc),a    //pongo vtZoneCalc a lo que tenga que tener 1,2,3,4 en funcion de donde se vaya a dibujar






      ld b,OBJ_POSX+1(ix)

      ld OBJ_REDRAWX(ix),b       //lo meto de tirona en tiles tal cual el byte alto de la posicion X

      ld a,(#_vtSceneScrollX)
      sub b
      neg      //le damos la vuelta a positivo

      //multiplico por 2 para ponerlo en bytes
      add a          //tengo en A vtPushTilesIniX*2 (aunque lo multiplique por 2 nunca desboradara porque sera 80 como maximo)

      

      //aqui habria que ver si 16(ix) bit 7 es 1, en ese caso habria que sumar uno más a A
      ld b,OBJ_POSX(ix)
      bit 7,b
      jr Z,vtGetGameObjScreenPtrs7
      inc a    //si el bit 7 es 1 incremento un byte (ajuste fino dentro del tile)

   vtGetGameObjScreenPtrs7:
      //ld OBJ_REDRAWX(ix),a

      //vtPushTilesDesp= vtVidMemStart + (vtPushTilesIniX*2) + (vtPushTilesIniY*80);
      ld	hl, (_vtVidMemStart)       // HL = vtVidMemStart
      add l
      ld l,a
      ld a,#0                         // A=0    gilipollas no uses el xor a porque jodes el carry y nos hace falta para la siguiente ADC
      adc h                         // A = A + H + carry
      ld h,a                        // HL = vtVidMemStart + (vtPushTilesIniY*2)

      ld	c, l                       //me guardo HL en BC = vtVidMemStart + (vtPushTilesIniY*2)
	   ld	b, h
      

      //ld	a, (_vtPushTilesIniY)
      ld a,(#_vtSceneScrollY)      //pillo vtSceneScrollY
      ld l,a
      ld a,OBJ_POSY+1(ix)

      ld OBJ_REDRAWY(ix),a    //me lo guardo para el redraw del background para el siguiente frame

      sub l
      ld l,a
      add a,a     //x2
      add a,a     //x4
      add a,l     //x5
      add a,a     //x10
      ld h,#0
      ld l,a
      add hl,hl   //x20
      add hl,hl   //x40
      add hl,hl   //x80


      //finalmente le sumamos el BC y ya tengo en HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80)
      add hl,bc                  // HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80);





   vtGetGameObjScreenPtrs10:
      //ajuste rapido para que nunca se salga de la pantalla e intente dibujar fuera el sprite
      ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
      and #7
      add #192  //le sumo C000 para tener hl+C000
      ld h,a


      //ajustes, pillamos los 3 bits más altos de posyL para ver el desplazamiento dentro del tile fino filipino
      ld a,OBJ_POSY(ix)      //pillo posy L
      rrca
      rrca     //roto 2 bits hacia la derecha para pasar los 3 bits más altos de 765 a 543
      //and #56     //me quedo con esos 3 bits, el resto paso
      and #48     //me quedo con esos 3 NO, solo con 2 bits, el resto paso (voy a hacer una prueba a ponerle menos resolucion, pero para poder optimizar más)
      add h       //se lo sumo a H para que haga el desplazamiento 
      ld h,a      //y lo vuelvo a soltar en H      
      //y con eso tengo desplazado la vertical al pixel


      ld (#_vtPointerAux),hl

      //call _vtTrapHL


      ld a,OBJ_SPEEDX+1(ix)      //pillo el byte alto para ver el signo
      bit 7,a
      jr NZ,vtGetGameObjScreenPtrs14
      xor a
      ld (#_vtDespWidth),a
      ret
   vtGetGameObjScreenPtrs14:
      ld a,OBJ_WIDTH(ix)
      ld (#_vtDespWidth),a


      ret      
   __endasm;
}


//pasando en BC el eje X, y en el DE el eje Y, mete en vtPointerAux la direccion de memoria de video que apunta a este lugar
void vtGetGameScreenPtrBCDE() __naked {
   __asm
      ld a,(#_vtSceneScrollY)      //pillo vtSceneScrollY
      ld l,a
      ld a,d      // D= tile Y

      sub l       //vtSceneScrollY - TileY
      ld l,a      //L=vtSceneScrollY - TileY
      add a,a     //x2
      add a,a     //x4
      add a,l     //x5
      add a,a     //x10
      ld h,#0
      ld l,a
      add hl,hl   //x20
      add hl,hl   //x40
      add hl,hl   // (vtSceneScrollY - TileY) x 80

      push de
      

      //finalmente le sumamos el BC y ya tengo en HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80)
      ld de,(_vtVidMemStart)
      add hl,de                  // HL = vtVidMemStart +  (vtPushTilesIniY*80);

      // ya no necesito DE para nada, ahora le vamos a sumar (vtPushTilesIniY*2)  


      ld a,(#_vtSceneScrollX)       //ahora vamos con el eje X
      sub b       //  vtSceneScrollX - TileX   (tiene que dar algo negativo o de lo contrario no se tendria que ver en pantalla)
      neg      //le damos la vuelta a positivo

      //multiplico por 2 para ponerlo en bytes
      add a          //tengo en A (TileX-vtSceneScrollX) * 2 (aunque lo multiplique por 2 nunca desboradara porque sera 80 como maximo)

      //aqui habria que ver si 16(ix) bit 7 es 1, en ese caso habria que sumar uno más a A
      bit 7,c
      jr Z,vtGetGameScreenPtrBCDEs2
      inc a    //si el bit 7 es 1 incremento un byte (ajuste fino dentro del tile)

   vtGetGameScreenPtrBCDEs2:
      add l
      ld l,a
      ld a,#0
      adc h  
      //ld h,a   

      //ajuste rapido para que nunca se salga de la pantalla e intente dibujar fuera el sprite
      //ld a,h    //le hago modulo 2048 para que no se salga de la pantalla
      and #7
      add #192  //le sumo C000 para tener hl+C000
      ld h,a

      pop de

      ld a,e      //me guardo E, D ya no la necesito

      rrca        //le sumo lo que hace falta de E (osea los 3 bits más altos)
      rrca         //roto 2 bits hacia la derecha para pasar los 3 bits más altos de 765 a 543
      and #56     //me quedo con esos 3 bits, el resto paso
      add h       //se lo sumo a H para que haga el desplazamiento 
      ld h,a      //y lo vuelvo a soltar en H    

      ld (#_vtPointerAux),hl
      ret      
   __endasm;
}


//se le pasan los parametros con vtPushTilesIniXY vtPushTilesEndXY de donde hasta donde tiene que redibujar
//y prepara las ristras para que el renderizador haga su trabajo en el momento del render que le toque
//u8 vtTileRowToDraw1[256];
//u8 vtTileRowToDraw2[256];
//u8 vtTileRowToDraw3[256];
//u8 vtTileRowToDraw4[256];
void vtPushTilesToDraw() __naked {
   __asm
      //call _vtBorderRed
      push ix
      push iy

      //ahora calculo en vtPushTilesDesp el desplazamiento inicial de pantalla
      ld	a,(#_vtPushTilesIniX)
      add a          //tengo en A vtPushTilesIniX*2 (aunque lo multiplique por 2 nunca desboradara porque sera 80 como maximo)

      //vtPushTilesDesp= vtVidMemStart + (vtPushTilesIniX*2) + (vtPushTilesIniY*80);
      ld	hl, (_vtVidMemStart)       // HL = vtVidMemStart
      add l
      ld l,a

      ld a,#0                         // A=0    gilipollas no uses el xor a porque jodes el carry y nos hace falta para la siguiente ADC
      adc h                         // A = A + H + carry
      ld h,a                        // HL = vtVidMemStart + (vtPushTilesIniY*2)

      ex de,hl

      ld	a, (_vtPushTilesIniY)
      ld l,a
      add a,a     //x2
      add a,a     //x4
      add a,l     //x5
      add a,a     //x10
      ld h,#0
      ld l,a
      add hl,hl   //x20
      add hl,hl   //x40
      add hl,hl   //x80

   

      //finalmente le sumamos el BC y ya tengo en HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80)
      //add hl,bc                  // HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80);
      add hl,de                  // HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80);

      ld	(_vtPushTilesDesp), hl          //lo meto en vtPushTilesDesp y tira millas


      

      //metemos en IXL vtSceneScrollX+vtPushTilesIniX
      ld a,(_vtSceneScrollX)
      ld l,a
      ld a,(_vtPushTilesIniX)
      add l
      .dw #0x6FDD    //ld ixl,a
      ld (_vtPushTileStartX),a
      //ld l,a
      //ld h,#0
      //push hl
   	//pop ix		//me lo guardo en ix
		//push ix			//me lo guardo para ir manteniendo el inicio del eje X en cada iteracion vertical


      //metemos en IYL vtSceneScrollY+vtPushTilesIniY
      ld a,(_vtSceneScrollY)
      ld l,a
      ld a,(_vtPushTilesIniY)
      add l
      .dw #0x6FFD    //ld iyl,a
      


      //metemos en IYH la diferencia entre vtPushTilesIniX y vtPushTilesEndX, o lo que es lo mismo, numero de tiles horizontal a dibujar
      ld	a, (#_vtPushTilesIniX)
      ld l,a
      ld	a, (#_vtPushTilesEndX)
      sub l
      .dw #0x67FD    //ld iyh,a


      //metemos en C la diferencia entre vtPushTilesIniY y vtPushTilesEndY, o lo que es lo mismo, numero de tiles vertical a dibujar
      ld	a, (#_vtPushTilesIniY)
      ld c,a         
      
      //ya tengo en C el bucle vertical, se supone que la C no la voy a tocar, la dejo solo para eso, y la B la ire recuperando en cada iteracción








   rtaosBucleY:
      ld hl,#0             //reinicio vtLastPtrMetaTile ya que en cada linea hay que reiniciarlo por si acaso
      ld (#_vtLastPtrMetaTile),hl
      
      
      ld a,(_vtPushTileStartX)
      .dw #0x6FDD    //ld ixl,a

      //pop ix         //esto reinicia ixl (ejeX) y ixh (bucle horizontal)
      //push ix

      //preparo B para el bucle horizontal
      //.dw #0x44DD    //ld b,ixh
      .dw #0x44FD    //ld b,iyh


      //antes de entrar en el bucle, cargo el numero de tiles y la direccion donde los voy a dibujar
      //lo primero es saber en que zona estoy y cargar en HL el puntero correspondiente
      //.dw #0x7dfd    //ld a,iyl
      
      //ld	a, (#_vtPushTilesIniY)     //pillamos el inicio
      //add c                         // más por el que vamos verticalmente y vemos en que zona cae
      ld a,c
      sub #6

               //ZONA 1-----------------------------------------------------------------------------
   
      jr NC,rtaosBucleYs2

   rtaosBucleYs1aastart:
      //si hay carry esta en la primera zona
      ld hl,(#_vtTileRowToDraw1Ptr)
      bit 7,l                    //voy a mirar los dos bits más altos de L, si los dos son 1 es que L>128 y ya
      jr NZ,rtaosBucleYs2

   rtaosBucleYs1aa:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a        //x2 porque son direcciones de memoria
      add l
      jr NC,rtaosBucleYs1b
      inc h
   rtaosBucleYs1b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw1Ptr),hl    //actualizo el puntero ahi justo
      jp rtaosBucleYs5


               //ZONA 2-----------------------------------------------------------------------------
   rtaosBucleYs2:
      sub #6
      jr NC,rtaosBucleYs3
      //si hay carry esta en la segunda zona
      ld hl,(#_vtTileRowToDraw2Ptr)
      bit 7,l                    //voy a mirar los dos bits más altos de L, si los dos son 1 es que L>128 y ya
      jr NZ,rtaosBucleYs3

   rtaosBucleYs2bb:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a
      add l
      jr NC,rtaosBucleYs2b
      inc h
   rtaosBucleYs2b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw2Ptr),hl    //actualizo el puntero ahi justo
      jp rtaosBucleYs5

   rtaosBucleYs3:
      sub #6
      jr NC,rtaosBucleYs4
      //tercera zona
      ld hl,(#_vtTileRowToDraw3Ptr)
      bit 7,l                    //voy a mirar los dos bits más altos de L, si los dos son 1 es que L>128 y ya
      jr NZ,rtaosBucleYs4 

   rtaosBucleYs3bb:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a
      add l
      jr NC,rtaosBucleYs3b
      inc h
   rtaosBucleYs3b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw3Ptr),hl    //actualizo el puntero ahi justo
      jp rtaosBucleYs5

   rtaosBucleYs4:
      //cuarta zona
      ld hl,(#_vtTileRowToDraw4Ptr)
      bit 7,l  
      jr Z,rtaosBucleYs4bb

      //si no puedo meterlo en el 4, voy directamente a meterlo en el 2 que debe haber hueco si o si
      ld hl,(#_vtTileRowToDraw2Ptr)
      jr rtaosBucleYs2bb
      //ret NZ         //si no puedo enchufarla en la ultima nos vamos pa fuera del tiron pa ke no la lie parda
      
      //jp NZ,rtaosBucleYs1aastart          //volvemos a principio y que lo encaje donde pueda
      

   rtaosBucleYs4bb:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a
      add l
      jr NC,rtaosBucleYs4b
      inc h
   rtaosBucleYs4b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw4Ptr),hl    //actualizo el puntero ahi justo


   rtaosBucleYs5:
      //aqui tengo metido en la pila HL la posicion donde tengo que pintar las direcciones de los tiles
      



   rtaosBucleX:

      //cargamos la parte baja de rtaEjeXtemp, osea IXL
      .dw #0x7DDD    //ld a,ixl
      //and #0x0F         //si A AND 15 != 0 es que no hemos cambiado de metatile y por lo tantos algunos calculos podemos obviarlos
      and #0x07         //si A AND 7 != 0 es que no hemos cambiado de metatile y por lo tantos algunos calculos podemos obviarlos
      jr Z,rtaosBucleXSub0

      //si llego aqui puedo intentar optimizar con 
      ld de, (#_vtLastPtrMetaTile)
      ld a,d
      add e
      jr NZ,rtaosBucleXSub3optPoint    //si no es cero puedo reutilizar el metatile que llevo
      

   rtaosBucleXSub0:
      //si entro aqui no hay optimización, tengo que ver que metatile tengo que usar

      //dibujamos el tile que toque (pillamos parte alta de vtSceneScrollX y vtSceneScrollY para calcular el super tile, 
      //y parte baja de vtSceneScrollX y vtSceneScrollY para calcular el tile dentro del supertile)
      //vtDrawTileSprite=gra_tileset[     
      //      (metatilelist[     
      //            scene[(((vtSceneScrollY+rtaEjeY)/16)*64+((vtSceneScrollX+rtaEjeX)/16))]     
      //               ] 
      //               [  ((((vtSceneScrollY+rtaEjeY)%16)*16)+((vtSceneScrollX+rtaEjeX)%16))   ]  )       
      //               ];

      //aqui va la forma nueva  como rtaEjeYtemp hay que dividirlo entre 8 y multiplicarlo por 32, directamente lo multiplico por 8 y ya lo tengo
      //aqui va la forma nueva  como rtaEjeYtemp hay que dividirlo entre 8 y multiplicarlo por 32, directamente lo multiplico por 4 y ya lo tengo
      //ld a,(#_rtaEjeYtemp)


      // SACAMOS EL METATILE-----------------------------------------------------
      .dw #0x7DFD    //ld a,iyl   cargo A=rtaEjeYtemp    
      and #0xF8      //antes FC y creo que estaba mal
      ld l,a
      //ld h,#0x8        //20 deplazado 2 veces a la der
      ld h,#SCENE_START_MEM_HI_DIV4
      add hl,hl      //x2
      add hl,hl      //x4
      //inc h             //le sumo 1 a H para que en vez de ser B0 ahora sea B1 osea SCENE_START_MEM
      dec h				//le resto 1 a H para que en vez de ser AC sea AB osea SCENE_START_MEM

      

      //ld de,(#_rtaEjeXtemp)
      .dw #0x7DDD     //ld a,ixl
      and #0b11111000
      rrca
      rrca
      rrca     //entre 8
      add l
      ld l,a      //sumo los dos desplazamientos y tengo HL= & scene[(((vtSceneScrollY+rtaEjeY)/8)*64+((vtSceneScrollX+rtaEjeX)/8)]
      //y ya tengo en HL= & scene[(((vtSceneScrollY+rtaEjeY)/8)*64+((vtSceneScrollX+rtaEjeX)/8)]
      


      //PONGO EN HL EL PUNTERO AL COMIENZO DEL METATILE------------------------------
      ld h,(hl)            //leo el metatile que voy a usar en H y lo divido entre 4 (ya que van de 64 en 64 bytes, tiles de 8x8)
      dec h          //le resto uno porke el mapa es 1 based
      xor a
	   sra h       //entre 2
      rra
      sra h       //entre 4
      rra
      ld l,a
//      ld de,#_metatile0    //le sumo el desplazamiento del array donde este el primer metatile
	   //ld de,(#_vtMetaTileSetPtr) 		//pregunto por el puntero a los metatiles
      //add hl,de


      ld a,#METATILE_START_MEM_HI
      //ld a,#0x11
      add h
      ld h,a






      // SACAMOS EL TILE-----------------------------------------------------
      //ahora tengo que sacar metatilelist [ A ] [  ((((vtSceneScrollY+rtaEjeY)%8)*8)+((vtSceneScrollX+rtaEjeX)%8))   ] 
      //o lo que es lo mismo DE [  (((( B )%8)*64)+(( C )%8))   ]
      //ld a,(#_rtaEjeYtemp)
      .dw #0x7DFD      //ld a,iyl
      and #0x07
      rlca
      rlca
      rlca
      ld d,a      //me lo guardo en D que no tengo nada ahora mismo


      //ld a,(#_rtaEjeXtemp)
      .dw #0x7DDD     //ld a,ixl
      and #0x07
      add d
      add l
      
      ld l,a      //ya tengo DE =  & metatilelist [ A ] [  ((((vtSceneScrollY+rtaEjeY)%8)*8)+((vtSceneScrollX+rtaEjeX)%8))   ]   
      ex de,hl




   rtaosBucleXSub3optPoint:
      ld a,(de)   //    A= metatilelist [ A ] [  ((((vtSceneScrollY+rtaEjeY)%8)*16)+((vtSceneScrollX+rtaEjeX)%8))   ]
      //dec a       //prueba porque los tiles empiezan en 1 en vez de 0 //KABESA
      //ESTE DE ME LO GUARDO, YA QUE, cuando vaya a pintar el tile que va a la derecha de este, si (vtSceneScrollX+rtaEjeX)%16!=0 puedo simplemente sumarle 1 y ya lo tengo sin hacer todos los calculos
      inc de   //le sumo 1 y lo enchufo en last pointer meta tile para que se pueda optimizar el siguiente dibujado de tile
      ld (_vtLastPtrMetaTile),de       //realmente esto apunta al tile dentro del metatile





      //ahora solo me falta gra_tileset[ A ]
      /*ld h,#0     //multiplico A por 2
      ld l,a
      add hl,hl   //x2
      add hl,hl   //x4
      add hl,hl   //x8
      add hl,hl   //x16
      inc h    //le sumo 1 a H para que empiece desde 0x0100
      ex de,hl
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      ex de,hl


      ld l,a
      rrca
      rrca
      rrca
      rrca
      ld h,a
      ld a,l
      rlca
      rlca
      rlca
      rlca
      ld l,a
      inc h
      ex de,hl
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      ex de,hl



      ld hl,#_myvarchunga
      ld (hl),a
      rld
      ld h,a
      ld a,(hl)
      ld l,a
      ex de,hl
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      ex de,hl
      */


      exx
      ld h,#ACCEL_TABLE_FOR_TILES_2
      ld l,a
      add hl,hl
      ld a,(hl)
      ld (de),a
      inc de
      inc l
      ld a,(hl)
      ld (de),a
      inc de
      exx
      


      //incrementamos ixl ixh para hacer rtaEjeXtemp=rtaEjeXtemp+1
      .dw #0x2CDD     //inc ixl
      djnz rtaosBucleX     //B=B-1, si no es cero volvemos a rtaosBucleX

        
   rtaosBucleXfin:
      inc c       //le sumo 1 a C y si C es igual al fin ya he acabao
      ld a,(#_vtPushTilesEndY)
      sub c
      jr Z,rtaosBucleYfin


      //si no es cero tengo que seguir
      ld de,#0x50
      ld hl,(#_vtPushTilesDesp)
      add hl,de
      ld (#_vtPushTilesDesp),hl
      

      .dw #0x2CFD     //inc iyl

      jp rtaosBucleY

   rtaosBucleYfin:
      //call _vtBorderBlack
      pop iy 
      pop ix
      ret      

   __endasm;
}



//esta funcion es igual que la anterior pero esta optimizada para dibujar una columna completa hacia abajo
//es mayormente para el scroll horizontal cuando tiene que redibujar los bordes izquierdo o derecho
//solo se puede llamar con ancho 1 ya que la optimizacion se aprovecha de esto precisamente
void vtPushTilesToDrawColumn() __naked {
   __asm
      //antes de nada, esta funcion solo se puede usar, si el scrollX+inix % 8 es menor de 7
      //ya que si pintamos 2 columnas para el scroll y tenemos que estar cambiando de metatile en cada horizontal
      //perdemos mucho tiempo para la optimizacion, asi que antes de nada, comprobamos que esto se cumpla
      //y si no se cumple, directamente llamamos a la rutina no optimizada
      ld a,(_vtSceneScrollX)
      ld l,a
      ld a,(_vtPushTilesIniX)
      add l
      and #7
      cp #7
      jp Z,_vtPushTilesToDraw        //si restamos 7 y es 0, no podemos optimizar, nos piramos para la rutina no optimizada y que lo haga lento

      //si llego aqui si puedo optimizar...
      //call _vtBorderBlue

      //la idea es sacar el metatile, y no cambiarlo hasta que cambie de metatile verticalmente (osea y%8==0)
      //de forma que el calculo chungo solo lo haga cada 8 filas

      //ademas solo voy a comprobar la zona cada 8 tiles, al ir hacia abajo no hay problemas en que meta más 
      //tiles de la cuenta en la zona de arriba  (creo...)


      
      //ahora calculo en vtPushTilesDesp el desplazamiento inicial de pantalla
      ld	a,(#_vtPushTilesIniX)
      add a          //tengo en A vtPushTilesIniX*2 (aunque lo multiplique por 2 nunca desboradara porque sera 80 como maximo)

      //vtPushTilesDesp= vtVidMemStart + (vtPushTilesIniX*2) + (vtPushTilesIniY*80);
      ld	hl, (_vtVidMemStart)       // HL = vtVidMemStart
      add l
      ld l,a

      ld a,#0                         // A=0    gilipollas no uses el xor a porque jodes el carry y nos hace falta para la siguiente ADC
      adc h                         // A = A + H + carry
      ld h,a                        // HL = vtVidMemStart + (vtPushTilesIniY*2)

      ex de,hl

      ld	a, (_vtPushTilesIniY)
      ld l,a
      add a,a     //x2
      add a,a     //x4
      add a,l     //x5
      add a,a     //x10
      ld h,#0
      ld l,a
      add hl,hl   //x20
      add hl,hl   //x40
      add hl,hl   //x80

   

      //finalmente le sumamos el BC y ya tengo en HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80)
      add hl,de                  // HL = vtVidMemStart + (vtPushTilesIniY*2) + (vtPushTilesIniY*80);

      ld	(_vtPushTilesDesp), hl          //lo meto en vtPushTilesDesp y tira millas


      

      //metemos en IXL vtSceneScrollX+vtPushTilesIniX
      ld a,(_vtSceneScrollX)
      ld l,a
      ld a,(_vtPushTilesIniX)
      add l
      .dw #0x6FDD    //ld ixl,a
      ld (_vtPushTileStartX),a


      //metemos en IYL vtSceneScrollY+vtPushTilesIniY
      ld a,(_vtSceneScrollY)
      ld l,a
      ld a,(_vtPushTilesIniY)
      add l
      .dw #0x6FFD    //ld iyl,a
      


      //metemos en IYH la diferencia entre vtPushTilesIniX y vtPushTilesEndX, o lo que es lo mismo, numero de tiles horizontal a dibujar
      ld	a, (#_vtPushTilesIniX)
      ld l,a
      ld	a, (#_vtPushTilesEndX)
      sub l
      .dw #0x67FD    //ld iyh,a
      
      add a    //A=A x 2   (porque metemos direcciones de memoria por cada tile 2 bytes)
      add #3   //A=A + 3   (porque hay que meter el numero de tiles a dibujar, y la direccion de memoria de la pantalla)
      ld (#_vtPushTilesDespZone),a        //esto es lo que hay que avanzar el puntero de la zona por cada fila simplemente



      //metemos en C la diferencia entre vtPushTilesIniY y vtPushTilesEndY, o lo que es lo mismo, numero de tiles vertical a dibujar
      ld	a, (#_vtPushTilesIniY)
      ld c,a         
      
      

      

      push hl
   rtaosColBucleYpre:
      pop hl         //esto no vale pa na, simplemente que cuando vengo del bucle llevo un elemento en la pila que ya no me hace falta y tengo que sacarlo


      //ya tengo en C el bucle vertical, se supone que la C no la voy a tocar, la dejo solo para eso, y la B la ire recuperando en cada iteracción
      .dw #0x44FD    //ld b,iyh
      
      ld a,c                        //vemos en que zona cae
      sub #6

               //ZONA 1-----------------------------------------------------------------------------
   
      jr NC,rtaosColBucleYs2

   rtaosColBucleYs1aastart:
      //si hay carry esta en la primera zona
      ld hl,(#_vtTileRowToDraw1Ptr)
      bit 7,l                    //voy a mirar los dos bits más altos de L, si los dos son 1 es que L>128 y ya
      jr NZ,rtaosColBucleYs2

   rtaosColBucleYs1aa:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a        //x2 porque son direcciones de memoria
      add l
      jr NC,rtaosColBucleYs1b
      inc h
   rtaosColBucleYs1b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw1Ptr),hl    //actualizo el puntero ahi justo
      ld hl,#_vtTileRowToDraw1Ptr
      ld (#rtaosColBucleXend1+1),hl
      ld (#rtaosColBucleXend4+1),hl
      jp rtaosColBucleYs5


               //ZONA 2-----------------------------------------------------------------------------
   rtaosColBucleYs2:
      sub #6
      jr NC,rtaosColBucleYs3
      //si hay carry esta en la segunda zona
      ld hl,(#_vtTileRowToDraw2Ptr)
      bit 7,l                    //voy a mirar los dos bits más altos de L, si los dos son 1 es que L>128 y ya
      jr NZ,rtaosColBucleYs3

   rtaosColBucleYs2bb:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a
      add l
      jr NC,rtaosColBucleYs2b
      inc h
   rtaosColBucleYs2b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw2Ptr),hl    //actualizo el puntero ahi justo
      ld hl,#_vtTileRowToDraw2Ptr
      ld (#rtaosColBucleXend1+1),hl
      ld (#rtaosColBucleXend4+1),hl
      jp rtaosColBucleYs5

   rtaosColBucleYs3:
      sub #6
      jr NC,rtaosColBucleYs4
      //tercera zona
      ld hl,(#_vtTileRowToDraw3Ptr)
      bit 7,l                    //voy a mirar los dos bits más altos de L, si los dos son 1 es que L>128 y ya
      jr NZ,rtaosColBucleYs4 

   rtaosColBucleYs3bb:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a
      add l
      jr NC,rtaosColBucleYs3b
      inc h
   rtaosColBucleYs3b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw3Ptr),hl    //actualizo el puntero ahi justo
      ld hl,#_vtTileRowToDraw3Ptr
      ld (#rtaosColBucleXend1+1),hl
      ld (#rtaosColBucleXend4+1),hl
      jp rtaosColBucleYs5

   rtaosColBucleYs4:
      //cuarta zona
      ld hl,(#_vtTileRowToDraw4Ptr)
      bit 7,l                    //voy a mirar los dos bits más altos de L, si los dos son 1 es que L>192 y ya
      jp NZ,rtaosColBucleYs1aastart          //volvemos a principio y que lo encaje donde pueda
      

   rtaosColBucleYs4bb:
      ld (hl),b            //meto cuantos tiles voy a pintar
      inc hl
      ld	de,(_vtPushTilesDesp)     //meto la zona de memoria donde tiene que empezar a pintar
      ld (hl),e
      inc hl
      ld (hl),d
      inc hl
      push hl              //me guardo en la pila donde tengo que empezar a meter las direcciones de los tiles
      exx
      pop de               //y lo meto en HL'
      exx
      ld a,b               //avanzo vtTileRowToDraw1Ptr Bx2 para que se coloque en la siguiente ristra
      add a,a
      add l
      jr NC,rtaosColBucleYs4b
      inc h
   rtaosColBucleYs4b:
      ld l,a
      ld (hl),#0                       //meto un cero para finalizar ahi
      ld (#_vtTileRowToDraw4Ptr),hl    //actualizo el puntero ahi justo
      ld hl,#_vtTileRowToDraw4Ptr
      ld (#rtaosColBucleXend1+1),hl
      ld (#rtaosColBucleXend4+1),hl


   rtaosColBucleYs5:
      


      
      // SACAMOS EL METATILE-----------------------------------------------------
      .dw #0x7DFD    //ld a,iyl   cargo A=rtaEjeYtemp    
      and #0xF8      //antes FC y creo que estaba mal
      ld l,a
      //ld h,#0x8        //20 deplazado 2 veces a la der
      ld h,#SCENE_START_MEM_HI_DIV4
      add hl,hl      //x2
      add hl,hl      //x4
      //inc h             //le sumo 1 a H para que en vez de ser B0 ahora sea B1 osea SCENE_START_MEM
		dec h				//le resto 1 a H para que en vez de ser AC sea AB osea SCENE_START_MEM
      

      //ld de,(#_rtaEjeXtemp)
      .dw #0x7DDD     //ld a,ixl
      and #0b11111000
      rrca
      rrca
      rrca     //entre 8
      add l
      ld l,a      //sumo los dos desplazamientos y tengo HL= & scene[(((vtSceneScrollY+rtaEjeY)/8)*64+((vtSceneScrollX+rtaEjeX)/8)]
      //y ya tengo en HL= & scene[(((vtSceneScrollY+rtaEjeY)/8)*64+((vtSceneScrollX+rtaEjeX)/8)]
      


      //PONGO EN HL EL PUNTERO AL COMIENZO DEL METATILE------------------------------
      ld h,(hl)            //leo el metatile que voy a usar en H y lo divido entre 4 (ya que van de 64 en 64 bytes, tiles de 8x8)
      dec h          //le resto uno porke el mapa es 1 based
      xor a
	   sra h       //entre 2
      rra
      sra h       //entre 4
      rra
      ld l,a
//      ld de,#_metatile0    //le sumo el desplazamiento del array donde este el primer metatile
	   //ld de,(#_vtMetaTileSetPtr) 		//pregunto por el puntero a los metatiles
      //add hl,de
      ld a,#METATILE_START_MEM_HI
      //ld a,#0x11
      add h
      ld h,a






      // SACAMOS EL TILE-----------------------------------------------------
      //ahora tengo que sacar metatilelist [ A ] [  ((((vtSceneScrollY+rtaEjeY)%8)*8)+((vtSceneScrollX+rtaEjeX)%8))   ] 
      //o lo que es lo mismo DE [  (((( B )%8)*64)+(( C )%8))   ]
      //ld a,(#_rtaEjeYtemp)
      .dw #0x7DFD      //ld a,iyl
      and #0x07
      rlca
      rlca
      rlca
      ld d,a      //me lo guardo en D que no tengo nada ahora mismo


      //ld a,(#_rtaEjeXtemp)
      .dw #0x7DDD     //ld a,ixl
      and #0x07
      add d
      add l
      
      ld l,a      //ya tengo DE =  & metatilelist [ A ] [  ((((vtSceneScrollY+rtaEjeY)%8)*8)+((vtSceneScrollX+rtaEjeX)%8))   ]   
      ex de,hl

      //y ya tengo el tile correcto en (DE)      


   rtaosColBucleY:

      //preparo B para el bucle horizontal
      .dw #0x44FD    //ld b,iyh


      push de

   rtaosColBucleXSub3optPoint:
      ld a,(de)   //    A= metatilelist [ A ] [  ((((vtSceneScrollY+rtaEjeY)%8)*16)+((vtSceneScrollX+rtaEjeX)%8))   ]
      //ESTE DE ME LO GUARDO, YA QUE, cuando vaya a pintar el tile que va a la derecha de este, si (vtSceneScrollX+rtaEjeX)%16!=0 puedo simplemente sumarle 1 y ya lo tengo sin hacer todos los calculos
      inc de   //le sumo 1 y lo enchufo en last pointer meta tile para que se pueda optimizar el siguiente dibujado de tile
      //ld (_vtLastPtrMetaTile),de       //realmente esto apunta al tile dentro del metatile


      //SACO EL GRAFICO DEL TILE QUE CORRESPONDE (el tile lo tengo en A)
      exx
      ld h,#ACCEL_TABLE_FOR_TILES_2
      ld l,a
      add hl,hl
      ld a,(hl)
      ld (de),a
      inc de
      inc l
      ld a,(hl)
      ld (de),a
      inc de
      exx
      

      


      //incrementamos ixl ixh para hacer rtaEjeXtemp=rtaEjeXtemp+1
      .dw #0x2CDD     //inc ixl
      //djnz rtaosBucleX     //B=B-1, si no es cero volvemos a rtaosBucleX
      djnz rtaosColBucleXSub3optPoint     //B=B-1, si no es cero volvemos a rtaosColBucleXSub3optPoint 
        
   rtaosColBucleXfin:
      inc c       //le sumo 1 a C y si C es igual al fin ya he acabao
      ld a,(#_vtPushTilesEndY)
      sub c
      jr Z,rtaosColBucleYfin

      //aqui empieza el bucle Y normal hasta que llegue un caso en que tengamos que cambiar de metatile
      ld a,(_vtPushTileStartX)
      .dw #0x6FDD    //ld ixl,a

      
      ld de,#0x50                      //avanzo a la siguiente linea el puntero a la pantalla
      ld hl,(#_vtPushTilesDesp)
      add hl,de
      ld (#_vtPushTilesDesp),hl

      pop de         //recupero y avanzo el tilepointer una linea abajo (osea más 8 para moverme una fila abajo en el metatile)
      ld hl,#8
      add hl,de
      ex de,hl
      push de

      .dw #0x7DFD       //ld a,iyl       //bajo una linea iyl
      inc a
      .dw #0x6ffd         //ld iyl,a

      
      and #7               //aqui miro si iyl%8 es igual a 0, por que si es cero tengo que cambiar de metatile y quizas de zona
      jp Z,rtaosColBucleYpre        //hemos cambiado verticalmente de tile, hay que volver a calcular el metatile (y quizas la zona)
      
      //sino simplemente seguimos rellenando con el mismo metatile
      //pero como hemos cambiado de linea tenemos que agregar una nueva linea
      exx
      .dw #0x7CFD   //ld a,iyh      leemos numero de tiles horizontal 
      ld (de),a 
      inc de
      ld hl,(#_vtPushTilesDesp)     // leemos comienzo donde tiene que empezar a dibujar la fila
      ld a,l
      ld (de),a
      inc de
      ld a,h
      ld (de),a
      inc de
      exx

      //aqui hay que añadir al puntero de la zona que vamos a avanzarlo una fila más
      ld a,(#_vtPushTilesDespZone)
   rtaosColBucleXend1:
      ld hl,(#_vtTileRowToDraw1Ptr)       //OJO!!! SELF-MODIFIED-CODE  el puntero lo modifica arriba cuando calcula la zona en la que esta
      add l
      jr NC,rtaosColBucleXend3
      inc h
   rtaosColBucleXend3:
      ld l,a
   rtaosColBucleXend4:
      ld (#_vtTileRowToDraw1Ptr),hl       //OJO!!! SELF-MODIFIED-CODE   el puntero lo modifica arriba cuando calcula la zona en la que esta
      ld (hl),#0

      .dw #0x44FD    //ld b,iyh           cargo B para el bucle horizontal

      jp rtaosColBucleXSub3optPoint



   rtaosColBucleYfin:
      pop de      //despopeamos
      //call _vtBorderBlack
      ret      

   __endasm;
}






//destroy HL,DE,A
void vtDrawTile2x8gc() __naked {
   __asm

      ld de,(_vtPointerAux)      //lo pillo de aqui mejor para ahorrarme algunas instrucciones
   vtDrawTile2x8gcFastStart1:
      ld hl,(_vtDrawTileSprite)
   vtDrawTile2x8gcFastStart2:

   


#ifdef DEBUG_DRAW_TILES
         push bc
         push de
         push hl
         ld	hl, #0x0C10
	      push	hl
	      call	_cpct_setPALColour
         pop hl
         pop de
         pop bc
#endif
		
      

      

      // comento esto porque creo que ya no hace falta se ajusta antes de llamar aqui
      ld a,d    //le hago modulo 2048 para que no se salga de la pantalla
      and #7
      add #192  //le sumo C000 para tener hl+C000
      ld d,a 
      

      //call _vtTrapDE
 
      di                   ;; [1] Disable interrupts before starting (we are using SP to read values)
      ld (save_sp + 1), sp ;; [6] Save actual SP to restore it in the end
      ld sp, hl            ;; [2] SP = end of sprite
      ex de, hl            ;; [1] HL = Destination in Video Memory (place where the sprite will be drawn)

      ;; Sprite Line 0. Drawing order [>>]
      pop de               ;; [3] Get 2 sprite bytes
      ld (hl), e           ;; [2] 1st byte is the left byte
      inc hl               ;; [2] HL++ -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the right byte
      set 3, h             ;; [2] --000---=>--001--- (Next sprite line: 1)

      ;; Sprite Line 1. Drawing order [<<]
      pop de               ;; [3] Get 2 sprite bytes
      ld (hl), e           ;; [2] 1st byte is the right byte
      dec hl               ;; [2] HL-- -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the left byte
      set 4, h             ;; [2] --001---=>--011--- (Next sprite line: 3)

      ;; Sprite Line 3. Drawing order [>>]
      pop de               ;; [3] Get 2 sprite bytes 
      ld (hl), e           ;; [2] 1st byte is the left byte
      inc hl               ;; [2] HL++ -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the right byte
      res 3, h             ;; [2] --011---=>--010--- (Next sprite line: 2)

      ;; Sprite Line 2. Drawing order [<<]
      pop de               ;; [3] Get 2 sprite bytes
      ld (hl), e           ;; [2] 1st byte is the right byte
      dec hl               ;; [2] HL-- -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the left byte
      set 5, h             ;; [2] --010---=>--110--- (Next sprite line: 6)

      ;; Sprite Line 6. Drawing order [>>]
      pop de               ;; [3] Get 2 sprite bytes
      ld (hl), e           ;; [2] 1st byte is the left byte
      inc hl               ;; [2] HL++ -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the right byte
      set 3, h             ;; [2] --110---=>--111--- (Next sprite line: 7)

      ;; Sprite Line 7. Drawing order [<<]
      pop de               ;; [3] Get 2 sprite bytes
      ld (hl), e           ;; [2] 1st byte is the right byte
      dec hl               ;; [2] HL-- -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the left byte
      res 4, h             ;; [2] --111---=>--101--- (Next sprite line: 5)

      ;; Sprite Line 5. Drawing order [>>]
      pop de               ;; [3] Get 2 sprite bytes
      ld (hl), e           ;; [2] 1st byte is the left byte
      inc hl               ;; [2] HL++ -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the right byte
      res 3, h             ;; [2] --101---=>--100--- (Next sprite line: 4)

      ;; Sprite Line 4. Drawing order [<<]
      pop de               ;; [3] Get 2 sprite bytes
      ld (hl), e           ;; [2] 1st byte is the right byte
      dec hl               ;; [2] HL-- -> next video mem location
      ld (hl), d           ;; [2] 2nd byte is the left byte

   save_sp:
      ld sp, #0000         ;; [3] Restore SP (#0000 is a placeholder)
      ei                   ;; [1] Reenable interrupts before returning




#ifdef DEBUG_DRAW_TILES
         push bc
         ld	hl, #0x1410
	      push	hl
	      call	_cpct_setPALColour
         pop bc
#endif


      ret      
      
   __endasm;
}






void vtVblankSyncInterrupt() __naked {
	__asm
         PUSH AF
         // Test for VBlank
         //LD   A,>PPI_B
         LD A,#0xF5

         IN A,(#0x00)
         RRA
         JP NC,vtVblankSyncInterruptExit

         ; We are in the vblank interrupt
         PUSH HL

	      ld a,#1		//lo pongo a 1
    	   ld (#_vtInterruptMoment),a

         LD HL,#_vtInterruptFunc
         LD (#0x0039),HL
         
         POP HL

      vtVblankSyncInterruptExit:
         POP AF
         EI
         RETI
   __endasm;
}



//la interrupcion lo unico que hace es aumentar en 1 el interrupt moment, nada más
void vtInterruptFunc() __naked {
   __asm
         //al entrar en la funcion hay un DI implicito
      ld (#stackSaveInte),sp     //me guardo donde esta la pila actual OJO!
      ld sp,#0xBE80        //pongo la pila en una posicion que se que no hay nada y hay algo de hueco

      push af
      push hl
      push bc
      push de
      ld a, (#_vtInterruptMoment)   //leemos y decrementamos vtInterruptMoment
      inc a
      ld (#_vtInterruptMoment),a

      cp #6
      call z,#_vtUsePaletteBlack    //final primer frame
      cp #12
      call z,#_vtUsePaletteBlack    //final segundo frame
      cp #18
      call z,#_vtUsePaletteBlack    //final tercer frame
      //cp #24       //si llega a 24 ya no quiero que se ponga más negro, que se quede con el color aunque se vea reborde arriba o abajo, pero es mejor asi porque la interrupcion podria llegar a 30 o más y no vamos a controlarlas todas
      //call z,#_vtUsePaletteBlack

      cp #2
      call z,#_vtUsePaletteGame     //comienzo primer frame
      call z,#_vtAdvanceMusic
      cp #8
      call z,#_vtUsePaletteGame     //comienzo segundo frame
      call z,#_vtAdvanceMusic
      cp #14
      call z,#_vtUsePaletteGame     //comienzo tercer frame
      call z,#_vtAdvanceMusic
      cp #20
      call z,#_vtUsePaletteGame     //comienzo cuarto frame
      call z,#_vtAdvanceMusic

      //cp #19
      //call NC,#_vtUsePaletteGame    //si vtInterruptMoment > 18 activamos la paleta del juego para que no se le vaya la olla y cambie la paleta a negro y pegue el parpadeo chungo


      ld a, (#_vtInterruptMoment)   //leemos y decrementamos vtInterruptMoment
      cp #12
      call z, #_vtAdjustCRTC  //si vamos por la 12


   vtInterruptFunc2:
      //LD   HL,#_vtInterruptFunc
      //LD   (#0x0039),HL
      pop de
      pop bc
      pop hl
      pop af
      
      ld sp,(#stackSaveInte)     //me guardo donde esta la pila actual OJO!
      ei
      ret      //si no es 0 fuera, no hago nada, sino ajusto la pantalla

   stackSaveInte:
      .dw #0x0000

   __endasm;
}

void vtAdvanceMusic() __naked {
   __asm
      push af
      ex af,af'
      //'
      push af        //pusheo af'
      ex af,af'
      //'
      
      push ix           //pusheo ix e iy
      push iy
      exx
      push bc           //pusheo todos los registros shadow
      push de 
      push hl

      

      //segun docu se pela AF, AF’, BC, DE, HL, IX, IY (aunque juraria que se pela algo más pero weno...)
      call cpct_akp_musicPlay_asm

      pop hl            //recupero los registros shadow
      pop de 
      pop bc 
      exx

      pop iy         //recupero iy e ix
      pop ix 
       
      ex af,af'      
      //'
      pop af
      ex af,af'
      //'
      pop af
      ret
   __endasm;
}


void vtAdjustCRTC() __naked {
   __asm
      

      ld a,(#_vtScrollPage)                       //r12 y r13 apuntamos memoria de video a C000
      or #0b00110100       //estos bits siempre tienen que estar activos, asi que le hago un or
      and #0b00110111      //y ahora le hago un and con los que quiero dejar, (el vtScrollPage debe mantenerse siempre entre 0x34 y 0x37 para que no se le vaya la olla al scroll)
      //los dos primeros bits no valen pa na, los dos siguiente son la pagina donde se dibuja, osea 0xC0, los siguientes son la pagina que quiero mantenerla siempre en 01 para que pueda ir hacia arriba o hacia abajo sin problemas
      //y los ultimos dos bits son realmente el offset
      ld (#_vtScrollPage),a                       //r12 y r13 apuntamos memoria de video a C000)
      ld bc,#0xbc0c	
      out (c),c	
      inc b		
      out (c),a	

      ld a,(#_vtScrollOffset)                       //r12 y r13 apuntamos memoria de video a C000
      ld bc,#0xbc0d	
      out (c),c	
      inc b		
      out (c),a

      ld de,#_vtScrollCRTC5         			//pillamos desplazamiento vertical del r5 y lo aplicamos
      ld a,(de)
      ld bc,#0xbc05				
      out (c),c
      ld bc,#0xbd00+0
      ld c,a
      out (c),c

      ld de,#_vtScrollCRTC3           			//pillamos desplazamiento horizontal del r3 y lo aplicamos
      ld a,(de)
      ld bc,#0xbc03				
      out (c),c
      ld bc,#0xbd00+0
      ld c,a
      out (c),c

      ret
   __endasm;
}


void vtConfigInterruptsAndScreen() __naked {
	__asm

      DI

		ld a,#0					//preparo el interrupt moment a 0
		ld (#_vtInterruptMoment),a

	//seteo la primera interrupcion para sincronizar el VBLANK para que se sincronice todo bien y no haga cosas raras en cada cpc

      LD   A,#0xC3
      LD   (#0x0038),A
      //LD   HL,#_vtInterruptFunc
      ld HL,#_vtVblankSyncInterrupt		
      LD   (#0x0039),HL

      
      //ajusto el vsync del CRTC r7 para que se ajuste bien con las interrupciones y pueda jugar con las paletas de colores
      ld a,#31
      ld bc,#0xbc07
      out (c),c
      ld bc,#0xbd00+0
      ld c,a
      out (c),c


      EI


		//OK, ahora que ya esta configurada la interrupcion espero a que se sincronice la primera interrupcion con la pantalla
		//tengo que esperar a que salte la interrupcion que coincida con el VBLANK (vtVblankSyncInterrupt) y en ese momento vtInterruptMoment pasa a 1 y 
   		//ya estoy sincronizado y puedo seguir con la interrupcion buena (vtInterruptFunc) 
	vtConfigInterruptsAndScreenWaitUntilSync:
		ld a,(#_vtInterruptMoment)
		or a
		jr Z,vtConfigInterruptsAndScreenWaitUntilSync		//me quedo aqui hasta que deje de valer 0
  
  		//se supone que cuando llegue aqui, acaba de saltar la interrupcion más alta, la que coincide con el VSYNC, por lo tanto puedo ya salir y continuar con el juego
		

      ret
   __endasm;
}
      

void vtRunStepEvents() __naked {
   __asm
   
      ld	hl, #GAME_OBJECTS_PTR             //;src/armony.h:3396: vtGameObjPtr=GAME_OBJECTS_PTR;
      ld bc,#48
      xor a

      ld (#_vtGameObjCounter),a     		//;src/armony.h:3398: vtGameObjCounter=0;
      ld (#_vtGameObjCounterActives),a     	//;src/armony.h:3399: vtGameObjCounterActives=0;
   
   
   vtRunStepEventsBucle:         //;src/armony.h:3400: while(vtGameObjCounter<16)
	   ld	a,(#_vtGameObjCounter)
	   sub #16
	   ret NC

      

		xor a					//;src/armony.h:3402: if(vtGameObjPtr->activeType!=0)		//si el objeto esta activo y tiene stepfunc lo llamamos
		or (hl)
		jr	Z,vtRunStepEventsBucleFin 

      //ld (#0xFFFB),a         //debug de cual karajea al final

		//si entra aqui el objeto esta activo, ahora veremos si tiene funcion step o no...
		
		ld (_vtGameObjPtr), hl		//ahora que se que esta activo, lo meto en el puntero al objeto

      //ld (#0xFFFC),hl         //debug de cual karajea al final

		push hl
		push bc

		inc hl          //;src/armony.h:3404: if(vtGameObjPtr->stepFunc!=0)
		ld c,(hl)
		inc hl
		ld h,(hl)
		ld a,h
		or c
		jr Z,vtRunStepEventsBucles2
   
      
		ld l,c                 	//;src/armony.h:3406: vtGameObjPtr->stepFunc();


      //ld (#0xFFFE),hl         //debug de cual karajea al final

		call ___sdcc_call_hl

   vtRunStepEventsBucles2:  
		ld hl,#_vtGameObjCounterActives     //;src/armony.h:3409: vtGameObjCounterActives=vtGameObjCounterActives+1;  //esta instancia está activa, la contamos
		inc (hl)
		
   	pop bc				//recupero BC y HL para ir pasando al siguiente objeto
   	pop hl

   vtRunStepEventsBucleFin:

		add hl,bc								//;src/armony.h:3412: vtGameObjPtr=vtGameObjPtr+1;
   
		ld a,(#_vtGameObjCounter)				//vtGameObjCounter=vtGameObjCounter+1
		inc a
		ld (#_vtGameObjCounter),a
	   
		jr vtRunStepEventsBucle
 
		ret
   __endasm;
}


//KABESA hay que hacer algo para deshabilitar las colisiones de alguna forma ( por ejemplo si no se renderiza no colisiona ? podemos mirar el last tile x por ejemplo )

void vtRunColisionEvents() __naked {
   __asm
      //ret
      //vamos a meter en BC el puntero al array ordenado por eje X
   	//ld bc,#_vtGameObjColiList
      ld bc,#GAME_OBJ_COLI_LIST
   		
   vtRunColisionEvents:
      //como primera version solo vamos a comparar uno con el de al lado (aunque se deberian comprobar más pero por velocidad...)
      ld a,(bc)
      .dw #0x6fdd     //ld ixl,a
      inc bc
      ld a,(bc)
      .dw #0x67dd     //ld ixh,a
      inc bc

      
		
      //y ya tengo en IX y en IY los que tengo que comprobar
      ld a,OBJ_ACTIVE_TYPE(ix)
      or a
      ret Z		//si el tipo de IX es 0 es que ya no tenemos que mirar más nada, porque todos estan ordenados a la izq por lo tanto cuando encontremos uno inactivo no hace falta seguir


      ld a,OBJ_FLAGS(ix)
      //bit 1,a        //compruebo si hay que dibujar el sprite o no
      //jr Z,vtRunColisionEvents      //si no se esta dibujando tampoco miramos sus colisiones
      bit 7,a
      jr NZ,vtRunColisionEvents      //si tiene el flag de no colision activo, pasamos al siguiente

      push bc        //me pusheo BC para luego seguir por aqui (ahora mismo apunta al siguiente de por el que voy)


      //ahora voy a hacer un bucle para ir comprobando colisiones, hasta que me encuentre con uno que este lo suficientemente 
      //lejos del eje X como para que ya no haya posibilidad de colisionar
      //simplemente voy a comparar el posX alto y miro si la diferencia es menor de 4 tiles, en ese caso
      //llamo a ver la distancia16 y veo si hay colision o no

   vtRunColisionEventsBucleChecking:
      ld a,(bc)
      .dw #0x6ffd     //ld iyl,a
      inc bc
      ld a,(bc)
      .dw #0x67fd        //ld iyh,a
      inc bc		//dejo BC en el siguiente (osea resto uno y me quedo en el L del segundo)


      
   vtRunColisionEventsBucleCheckings0:
      bit 7,OBJ_FLAGS(iy)
      jr NZ,vtRunColisionEventsBucleChecking
      

   
   vtRunColisionEventsBucleCheckings1:
      ld a,OBJ_POSX+1(ix)
      sub OBJ_POSX+1(iy)
      bit 7,a
      jr Z,vtRunColisionEventsBucleCheckings2
      neg

   vtRunColisionEventsBucleCheckings2:
      cp #4
      jr C,vtRunColisionEventsBucleCheckings4      //si es menor de 4 hacemos las comprobaciones de verdad
      //si restamos 4 y no hay carry estan los suficientemente lejos como para que no haya colision de ningun tipo y podemos pasar al siguiente elemento
      pop bc
      jr vtRunColisionEvents


   vtRunColisionEventsBucleCheckings4:
      //si del eje X estamos más cerca de 4 tiles podemos ver ahora el ejeY
      //antes de nada hacemos la comprobación rapida tambien restando solo el OBJ_POSY+1 para ver si la diferencia es menor de 4 tambien o no
      ld a,OBJ_POSY+1(ix)
      sub OBJ_POSY+1(iy)
      bit 7,a
      jr Z,vtRunColisionEventsBucleCheckings6
      neg
   
   vtRunColisionEventsBucleCheckings6:
      cp #4
      jr C,vtRunColisionEventsBucleCheckings8

      jr vtRunColisionEventsBucleChecking    //si entra aqui es que horizontalmente si estan cerca pero verticalmente no,
                                             // tengo que seguir mirando los siguientes, no cambio de entidad aun

   vtRunColisionEventsBucleCheckings8:
      //si llegamos aqui estamos cerca horizontal y verticalmente, ahora vamos a hacer un chequeo fino para ver la distancia real entre

      //pero antes miro si se está dibujando o no iy, ya que si no se dibuja pasamos al siguiente
      ld a,OBJ_FLAGS(iy)
      bit 1,a        //compruebo si hay que dibujar el sprite o no
      jr Z,vtRunColisionEventsBucleChecking      //si no se esta dibujando tampoco miramos sus colis, pasamos al siguiente


      //las dos instancias usando la funcion distance16
      push bc

      ld h,OBJ_POSX+1(ix)
      ld l,OBJ_POSX(ix)


      ld a,OBJ_WIDTH(ix)
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a1
      ld de,#128     //si entra aqui es que el width es 1 tile, con lo cual le sumo la mitad 128
      jr vtRunColisionEventsBucleCheckings8a4

   vtRunColisionEventsBucleCheckings8a1:
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a2
      ld de,#256       //si entra aqui es que el width es 2 tiles, con lo cual le sumo la mitad 1 tile, osea 256
      jr vtRunColisionEventsBucleCheckings8a4

   vtRunColisionEventsBucleCheckings8a2:
      ld de,#384     //si entra aqui es que el width es 3 tiles, (no tengo nada de 4), con lo cual le sumo la mitad 1 tile y medio, osea 384

   vtRunColisionEventsBucleCheckings8a4:
      add hl,de
      ex de,hl       //lo dejo en DE




      ld h,OBJ_POSX+1(iy)
      ld l,OBJ_POSX(iy)

      ld a,OBJ_WIDTH(iy)
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a6
      ld bc,#128     //si entra aqui es que el width es 1 tile, con lo cual le sumo la mitad 128
      jr vtRunColisionEventsBucleCheckings8a10

   vtRunColisionEventsBucleCheckings8a6:
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a8
      ld bc,#256       //si entra aqui es que el width es 2 tiles, con lo cual le sumo la mitad 1 tile, osea 256
      jr vtRunColisionEventsBucleCheckings8a10

   vtRunColisionEventsBucleCheckings8a8:
      ld bc,#384     //si entra aqui es que el width es 3 tiles, (no tengo nada de 4), con lo cual le sumo la mitad 1 tile y medio, osea 384

   vtRunColisionEventsBucleCheckings8a10:
      add hl,bc
      
      sbc hl,de         //el carry en este caso no importa porque influye muy poco ni me preocupo por resetearlo
      
      push hl        //me guardo la diferencia en la pila





      ld h,OBJ_POSY+1(ix)        //ahora vamos a por la diferencia vertical
      ld l,OBJ_POSY(ix)

      ld a,OBJ_HEIGHT(ix)
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a11
      ld de,#128     //si entra aqui es que el width es 1 tile, con lo cual le sumo la mitad 128
      jr vtRunColisionEventsBucleCheckings8a14

   vtRunColisionEventsBucleCheckings8a11:
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a12
      ld de,#256       //si entra aqui es que el width es 2 tiles, con lo cual le sumo la mitad 1 tile, osea 256
      jr vtRunColisionEventsBucleCheckings8a14

   vtRunColisionEventsBucleCheckings8a12:
      ld de,#384     //si entra aqui es que el width es 3 tiles, (no tengo nada de 4), con lo cual le sumo la mitad 1 tile y medio, osea 384

   vtRunColisionEventsBucleCheckings8a14:
      add hl,de
      ex de,hl       //lo dejo en DE


      ld h,OBJ_POSY+1(iy)
      ld l,OBJ_POSY(iy)

      ld a,OBJ_HEIGHT(iy)
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a16
      ld bc,#128     //si entra aqui es que el width es 1 tile, con lo cual le sumo la mitad 128
      jr vtRunColisionEventsBucleCheckings8a20

   vtRunColisionEventsBucleCheckings8a16:
      dec a
      jr NZ,vtRunColisionEventsBucleCheckings8a18
      ld bc,#256       //si entra aqui es que el width es 2 tiles, con lo cual le sumo la mitad 1 tile, osea 256
      jr vtRunColisionEventsBucleCheckings8a20

   vtRunColisionEventsBucleCheckings8a18:
      ld bc,#384     //si entra aqui es que el width es 3 tiles, (no tengo nada de 4), con lo cual le sumo la mitad 1 tile y medio, osea 384

   vtRunColisionEventsBucleCheckings8a20:
      add hl,bc
      
      sbc hl,de         //el carry en este caso no importa porque influye muy poco ni me preocupo por resetearlo

      ex de,hl          //me quedo con la diferencia vertical en DE

      pop bc            //recupero la diferencia horizontal en BC




      //entrada: BC diferencia horizontal, DE diferencia vertical
      //salida: HL distancia entre punto 0,0 y punto BC,DE
      //OJO!!! esta funcion va a hacer los calculos como si fuera i16
      call _vtDistance16

      pop bc

      //el resultado va en el mismo formato que OBJ_POSX y OBJ_POSY por lo tanto H tiene la diferencia en tiles y L para precision
      //si H > 1 es que esta como minimo a 2 tiles de distancia y por lo tanto podemos no considerar colision
      ld a,#1
      cp h
      jr NC,vtRunColisionEventsBucleCheckings10
      
      //si entra aqui, H>1 y por lo tanto esta como minimo a 2 tiles de distancia, no lo consideramos colision, y seguimos comprobando
      jp vtRunColisionEventsBucleChecking       //otras entidades


   vtRunColisionEventsBucleCheckings10:
      //si entra aqui consideramos que los dos objetos estan muy cerca, hay colision

      //ahora hay que ver si IX tiene funcion de colision y si IY tiene funcion de colision para llamarlas o no
      ld a,OBJ_COLISION_FUNC+1(ix)
      or a
      jr Z,vtRunColisionEventsBucleCheckings18			//si IX no tiene funcion de colision vamos a mirar si IY la tiene o no

      push BC				//me guardo BC porque la funcion de colision lo mismo se la peta

      ld e,OBJ_COLISION_FUNC(ix)
      ld d,a
      ld hl,#vtRunColisionEventsBucleCheckings14
      di          //para hacer el trucazo desactivo las interrupciones porque la puede liar si salta en este mismo momento
      push HL
      push DE
      ret			//esto equivale a hacer un CALL DE y que luego al hacer el RET vuelva a HL
   		
   		
   vtRunColisionEventsBucleCheckings14:
      ei          //luego cuando vuelvo las vuelvo a habilitar
      pop BC				//recupero BC
   		

   vtRunColisionEventsBucleCheckings18:
      ld a,OBJ_COLISION_FUNC+1(iy)
      or a
      jp Z,vtRunColisionEventsBucleChecking		//si no tiene funcion de colision volvemos al bucle

      //IY tiene funcion de colision, asi que intercambiamos IX e IY y la llamamos
      push ix
      push iy
      pop ix
      pop iy

      push BC			//me guardo BC por si la colision se lo peta

      ld e,OBJ_COLISION_FUNC(ix)
      ld d,OBJ_COLISION_FUNC+1(ix)
      ld hl,#vtRunColisionEventsBucleCheckings20
      di          //para hacer el trucazo desactivo las interrupciones porque la puede liar si salta en este mismo momento
      push HL
      push DE
      ret
   		
   vtRunColisionEventsBucleCheckings20:
      ei          //luego cuando vuelvo las vuelvo a habilitar

      push ix     //vuelvo a intercambiar ix e iy ya que en IX llevo por el que voy y no se puede modificar
      push iy
      pop ix
      pop iy

      pop BC				//recupero BC y salimos
      jp vtRunColisionEventsBucleChecking			//volvemos al bucle
   	
   __endasm;
}



/*
void vtRunColisionEvents() __naked {
   __asm
   	//vamos a meter en BC el puntero al array ordenado por eje X
   	ld bc,#_vtGameObjColiList
   		
   vtRunColisionEvents:
      //como primera version solo vamos a comparar uno con el de al lado (aunque se deberian comprobar más pero por velocidad...)
      ld a,(bc)
      .dw #0x6fdd     //ld ixl,a
      inc bc
      ld a,(bc)
      .dw #0x67dd     //ld ixh,a
      inc bc

      ld a,(bc)
      .dw #0x6ffd     //ld iyl,a
      inc bc
      ld a,(bc)
      .dw #0x67fd        //ld iyh,a
      dec bc		//dejo BC en el siguiente (osea resto uno y me quedo en el L del segundo)
		
      //y ya tengo en IX y en IY los que tengo que comprobar
      ld a,OBJ_ACTIVE_TYPE(ix)
      or a
      ret Z		//si el tipo de IX es 0 es que ya no tenemos que mirar más nada, porque todos estan ordenados a la izq por lo tanto cuando encontremos uno inactivo no hace falta seguir

      ld a,OBJ_ACTIVE_TYPE(iy)
      or a
      ret Z		//si el tipo de IY es 0, tambien podemos salir porque ya no va a darse más colisiones


      //si llego aqui los dos objetos existen, podemos comprobar si hay colision o no
      //como se seguro que el IY.POSX va a ser mayor seguro que el IX.POSX, puedo empezar por restarlos directamente
      //	LOCIX=IX.POSX+IX.WIDHT*256
      //  si LOCIX-IY.POSY no da carry, es que hay colision
      //  x1-----w1
      //	   x2----------w2
      //  LOCIX=x1+w1*256
      //	if LOCIX<x2 tonces hay colision
      ld d,OBJ_WIDTH(ix)
      ld e,#0
      //tengo el ancho en DE (transformado ya a pixeles), ahora me quedo con un cuarto de ese ancho
      sra d    //divido entre 2 el ancho
      rr e
      sra d    //divido entre 4 el ancho
      rr e

      ld l,OBJ_POSX(ix)
      ld h,OBJ_POSX+1(ix)

      add hl,de      //le sumo el 1/4 del ancho a la posicion
      add hl,de      //le sumo el 1/4 del ancho a la posicion
      add hl,de      //le sumo el 1/4 del ancho a la posicion


      ld e,OBJ_POSX(iy)
      ld d,OBJ_POSX+1(iy)
      xor a
      sbc hl,de
      jr C,vtRunColisionEvents		//no hay colision, pasamos al siguiente



      //si llego aqui hay colision horizontal, ahora tengo que ver la colision vertical,
      ld a,OBJ_HEIGHT(ix)
      sra a       //entre 2
      ld l,OBJ_POSY(ix)
      ld h,OBJ_POSY+1(ix)
      add h
      ld h,a


      ld e,OBJ_POSY(iy)
      ld d,OBJ_POSY+1(iy)
      xor a
      sbc hl,de
      jr C,vtRunColisionEvents		//no hay colision, pasamos al siguiente



      ld a,OBJ_HEIGHT(iy)
      sra a
      ld l,OBJ_POSY(iy)
      ld h,OBJ_POSY+1(iy)
      add h
      ld h,a


      ld e,OBJ_POSY(ix)
      ld d,OBJ_POSY+1(ix)
      xor a
      sbc hl,de
      jr C,vtRunColisionEvents		//no hay colision, pasamos al siguiente






      //ahora hay que ver si IX tiene funcion de colision y si IY tiene funcion de colision para llamarlas o no


      ld a,OBJ_COLISION_FUNC+1(ix)
      or a
      jr Z,vtRunColisionEventss5			//si IX no tiene funcion de colision vamos a mirar si IY la tiene o no

      

      push BC				//me guardo BC porque la funcion de colision lo mismo se la peta

      ld e,OBJ_COLISION_FUNC(ix)
      ld d,a
      ld hl,#vtRunColisionEventss4
      push HL
      push DE
      ret			//esto equivale a hacer un CALL DE y que luego al hacer el RET vuelva a HL
   		
   		
   			
   vtRunColisionEventss4:
      pop BC				//recupero BC
   		
   vtRunColisionEventss5:
      ld a,OBJ_COLISION_FUNC+1(iy)
      or a
      jp Z,vtRunColisionEvents		//si no tiene funcion de colision volvemos al bucle

      //IY tiene funcion de colision, asi que intercambiamos IX e IY y la llamamos
      push ix
      push iy
      pop ix
      pop iy

      push BC			//me guardo BC por si la colision se lo peta

      ld e,OBJ_COLISION_FUNC(ix)
      ld d,a
      ld hl,#vtRunColisionEventss6
      push HL
      push DE
      ret
   		
   vtRunColisionEventss6:
      pop BC				//recupero BC y salimos
      jp vtRunColisionEvents			//volvemos al bucle
   	
		//ret
   __endasm;
}

*/


/*
void vtRunDrawEvents()
{
   vtGameObjCounter=0;
   while(vtGameObjCounter<16)
   {
      vtGameObjPtr=vtGameObjOrderYList[vtGameObjCounter];
      if(vtGameObjPtr->activeType!=0)
      {
         if(vtGameObjPtr->prepareDrawFunc!=0)
         {
            if(vtIsGameObjInScreen())
            {
               vtGameObjPtr->prepareDrawFunc();
            }
         }
      }

      vtGameObjCounter=vtGameObjCounter+1;     
   }
   //como ya he hecho todos los draw, reseteo el puntero a la lista de sprites para que 
   //el renderSpritesZone pueda optimizar un poco y no tenga que recorrerlos todos siempre 
   //vtSpriteListToDrawPtr=&vtSpriteListToDraw[0];      
   vtSpriteListToDrawPtr=#VT_SPRITE_LIST_TO_DRAW;
}
*/



void vtRunDrawEvents() __naked {
   __asm

	xor a
	ld	bc,#_vtGameObjCounter			;src/armony.h:3904: vtGameObjCounter=0;
	ld	(bc), a
	//ld hl,#_vtGameObjOrderYList
   ld hl,#GAME_OBJ_ORDER_Y_LIST


vtRunDrawEventsBucle:
	ld e,(hl)			//DE = vtGameObjOrderYList[vtGameObjCounter];
	inc hl
	ld d,(hl)
	inc hl
	
	ld a,(de)				//leo el ACTIVE_TYPE y miro si es 0
	or a
	jr Z,vtRunDrawEventsBucleFin		//si el tipo es 0 ya está, pasamos al siguiente sin hacer nada más
	
	ld (#_vtGameObjPtr),de		//si no es cero hay que mirar más cosas, voy preparando ya el puntero vtGameObjPtr
	
	//ahora miramos si tiene preparefunc o no (si tiene draw vamos...) 
	inc	de
	inc	de
	inc	de
	inc de				//me voy al byte alto del preparefunc
	ld	a, (de)
	or a
	jr Z,vtRunDrawEventsBucleFin		//si es 0 aunque existe no tiene drawfunc, asi que al siguiente
	
	//si llega aqui existe y tiene draw, tenemos que ver si esta dentro de la pantalla o no
	push bc			//me guardo en la pila por donde voy porke lo siguiente se lo va a cargar
	push hl
	
	ld h,a				// HL -> vtGameObjPtr->preparefunc
	dec de
	ld a,(de)
	ld l,a
	
	push hl				//pusheo tambien el puntero al preparefunc por si luego hay que usarlo
	
	call _vtIsGameObjInScreen		//miro si esta en pantalla o no
	
	ld a,l
	pop hl			//recupero el puntero a HL -> vtGameObjPtr->preparefunc
	
	or a						//miro si esta en la pantalla L=1?
	jr Z,vtRunDrawEventsBucleFinPre		//si L=0 es que no esta en la pantalla, no hace falta que llame al preparefunc, sigo mirando el siguiente
	
	//si llego aqui existe, tiene preparefunc y esta en pantalla, llamo a su preparefunc que lo tengo en HL con el vtGameObjPtr que tengo ya relleno
	call ___sdcc_call_hl
	
vtRunDrawEventsBucleFinPre:
	pop hl
	pop bc
	
vtRunDrawEventsBucleFin:
	ld a,(bc)
	inc a
	ld (bc),a
	bit 4,a
	jr NZ,vtRunDrawEventsBucleExit		//si es NZ es que hemos llegado a 16
	jr vtRunDrawEventsBucle		//sino vuelvo al bucle
	
vtRunDrawEventsBucleExit:
	ld hl,#VT_SPRITE_LIST_TO_DRAW			//	vtSpriteListToDrawPtr=#VT_SPRITE_LIST_TO_DRAW;
	ld (#_vtSpriteListToDrawPtr),hl
	ret

   __endasm;
}





//esta funcion antes recorria el array de entidades simplemente, ahora usa el array vtGameObjOrderYList para llamar 
//a los draw en orden del eje Y
/*void vtRunDrawEvents() __naked {
   __asm


;src/armony.h:3303: vtGameObjPtr=&vtGameObjOrderYList[0];
	ld	hl, #0xb500
	ld	(_vtGameObjPtr), hl
;src/armony.h:3304: vtGameObjCounter=0;
	ld	hl,#_vtGameObjCounter + 0
	ld	(hl), #0x00
;src/armony.h:3305: while(vtGameObjCounter<16)
00107$:
	ld	a,(#_vtGameObjCounter + 0)
	sub	a, #0x10
	ret	NC
;src/armony.h:3307: if(vtGameObjPtr->activeType!=0)
	ld	hl, (_vtGameObjPtr)
	ld	a, (hl)
	or	a, a
	jr	Z,00106$
;src/armony.h:3309: if(vtGameObjPtr->prepareDrawFunc!=0)
	inc	hl
	inc	hl
	inc	hl
	ld	c, (hl)
	inc	hl
	ld	a, (hl)
	or	a,c
	jr	Z,00106$
;src/armony.h:3311: if(vtIsGameObjInScreen())
	call	_vtIsGameObjInScreen
	ld	a, l
	or	a, a
	jr	Z,00106$
;src/armony.h:3313: vtGameObjPtr->prepareDrawFunc();
	ld	hl, (_vtGameObjPtr)
	inc	hl
	inc	hl
	inc	hl
	ld	a, (hl)
	inc	hl
	ld	h, (hl)
	ld	l, a
	call	___sdcc_call_hl
00106$:
;src/armony.h:3318: vtGameObjPtr=vtGameObjPtr+1;
	ld	hl, #_vtGameObjPtr
	ld	a, (hl)
	add	a, #0x30
	ld	(hl), a
	inc	hl
	ld	a, (hl)
	adc	a, #0x00
	ld	(hl), a
;src/armony.h:3319: vtGameObjCounter=vtGameObjCounter+1;
	ld	hl, #_vtGameObjCounter+0
	inc	(hl)
	jr	00107$
//ret
   __endasm;
}*/



/*
void vtResetFrame()
{
   //vtSpriteListToDrawPtr=&vtSpriteListToDraw[0];
   vtSpriteListToDrawPtr=#VT_SPRITE_LIST_TO_DRAW;
   *vtSpriteListToDrawPtr=0;

   //  *((u8*)&vtTileRowToDraw1[0])=0;     //inicializo los punteros al principio las ristras
   //  *((u8*)&vtTileRowToDraw2[0])=0;
   //  *((u8*)&vtTileRowToDraw3[0])=0;
   //  *((u8*)&vtTileRowToDraw4[0])=0;
   *((u8*)TILEROW_TO_DRAW_1)=0;     //inicializo los punteros al principio las ristras
   *((u8*)TILEROW_TO_DRAW_2)=0;
   *((u8*)TILEROW_TO_DRAW_3)=0;
   *((u8*)TILEROW_TO_DRAW_4)=0;
   //vtTileRowToDraw1Ptr=&vtTileRowToDraw1[0]; 
   //vtTileRowToDraw2Ptr=&vtTileRowToDraw2[0];
   //vtTileRowToDraw3Ptr=&vtTileRowToDraw3[0];
   //vtTileRowToDraw4Ptr=&vtTileRowToDraw4[0];
   vtTileRowToDraw1Ptr=TILEROW_TO_DRAW_1;
   vtTileRowToDraw2Ptr=TILEROW_TO_DRAW_2;
   vtTileRowToDraw3Ptr=TILEROW_TO_DRAW_3;
   vtTileRowToDraw4Ptr=TILEROW_TO_DRAW_4;

   vtClock=vtClock+1;      //sumamos uno al tiempo
}
*/


void vtResetFrame() __naked {
   __asm
   
	ld	hl, #0x0040    //;src/armony.h:4000: vtSpriteListToDrawPtr=#VT_SPRITE_LIST_TO_DRAW;
	ld	(_vtSpriteListToDrawPtr), hl

   xor a
	ld	(hl), a       //;src/armony.h:4001: *vtSpriteListToDrawPtr=0;

	ld	hl, #0xb800       //;src/armony.h:4007: *((u8*)TILEROW_TO_DRAW_1)=0;     //inicializo los punteros al principio las ristras
	ld	(hl), a
   ld	(_vtTileRowToDraw1Ptr), hl    //;src/armony.h:4015: vtTileRowToDraw1Ptr=TILEROW_TO_DRAW_1;

	//ld	h, #0xb9
   inc h             //;src/armony.h:4008: *((u8*)TILEROW_TO_DRAW_2)=0;
	ld	(hl), a
   ld	(_vtTileRowToDraw2Ptr), hl    //vtTileRowToDraw2Ptr=TILEROW_TO_DRAW_2;

	//ld	h, #0xba
   inc h             //;src/armony.h:4009: *((u8*)TILEROW_TO_DRAW_3)=0;
	ld	(hl), a
   ld	(_vtTileRowToDraw3Ptr), hl    //vtTileRowToDraw3Ptr=TILEROW_TO_DRAW_3;


	//ld	h, #0xbb
   inc h                   //;src/armony.h:4010: *((u8*)TILEROW_TO_DRAW_4)=0;
	ld	(hl), a
   ld	(_vtTileRowToDraw4Ptr), hl          //vtTileRowToDraw4Ptr=TILEROW_TO_DRAW_4;

	ld hl,(#_vtClock)       //;src/armony.h:4020: vtClock=vtClock+1;      //sumamos uno al tiempo
   inc hl
   ld (#_vtClock),hl

	ret
   __endasm;
}




//OJO si no hay sitio, mete en vtGameObjPtr un 0 para poder detectarlo
/*void vtGetFreeGameObjPtr()
{
   //vtGameObjPtr=&vtGameObjects[0];
   vtGameObjPtr=GAME_OBJECTS_PTR;
   vtGameObjCounter=0;
   while(vtGameObjCounter<16)
   {
      if(vtGameObjPtr->activeType==0)
      {
         //limpiamos algunos campos basicos que se van a querer limpiar siempre
         vtCleanObject();
         return;
      }
      vtGameObjPtr=vtGameObjPtr+1;
      vtGameObjCounter=vtGameObjCounter+1;
   }
   debugArmony();
   vtGameObjPtr=0;      //no tenemos sitio para meter a más gente, asi que lo pongo a 0 para que el que lo ha llamado sepa que no es posible meter más
   return;
}*/



void vtGetFreeGameObjPtr() __naked {
   __asm

	   ld	hl,#GAME_OBJECTS_PTR                      //;src/armony.h:4056: vtGameObjPtr=GAME_OBJECTS_PTR;
	   ld	(_vtGameObjPtr),hl

	   //ld	hl,#_vtGameObjCounter + 0           //;src/armony.h:4057: vtGameObjCounter=0;
	   //ld	(hl), #0x00
      xor a
      ld (#vtGetFreeGameObjPuntero),a

   vtGetFreeGameObjPtrBucle:    
      ld a,(#vtGetFreeGameObjPuntero)
	   sub #0x10         //16
	   jr	NC,vtGetFreeGameObjPtrBucleFin

	   ld	hl,(_vtGameObjPtr)              //;src/armony.h:4060: if(vtGameObjPtr->activeType==0)
	   ld	a,(hl)
	   or	a

	   jp	Z,_vtCleanObject                 //;src/armony.h:4063: vtCleanObject();
                                       //;src/armony.h:4064: return;

	   ld	hl,#_vtGameObjPtr               //;src/armony.h:4066: vtGameObjPtr=vtGameObjPtr+1;
	   ld	a,(hl)
	   add a,#0x30
	   ld	(hl),a
	   inc hl
	   ld	a,(hl)
	   adc a,#0x00
	   ld	(hl),a

	   ld	hl,#vtGetFreeGameObjPuntero            //;src/armony.h:4067: vtGameObjCounter=vtGameObjCounter+1;
	   inc (hl)
	   jr	vtGetFreeGameObjPtrBucle

   vtGetFreeGameObjPtrBucleFin:

	   

      //parece que es más seguro devolver el ultimo objeto aunque sea, mejor que un 0 que la lia más parda

	   //ld	hl,#0x0000                         //;src/armony.h:4070: vtGameObjPtr=0;      //no tenemos sitio para meter a más gente, asi que lo pongo a 0 para que el que lo ha llamado sepa que no es posible meter más
      ld	hl,#GAME_OBJECTS_PTR+0x02D0		//nos vamos al ultimo objeto, lo limpiamos y este es el que devolvemos, si habia uno antes aqui pues se fue a la mierda
	   ld	(_vtGameObjPtr), hl
		jp Z,_vtCleanObject 
	   ret                        

   vtGetFreeGameObjPuntero:
      .db #0

   __endasm;
}



void vtCleanObject() __naked {
   __asm
      ld hl,(#_vtGameObjPtr)
      ld d,h
      ld e,l
      inc de            //ponemos DE al segundo byte
      ld (hl),#0        //ponemos el primer byte a 0
      ld bc,#47         //vamos a copiar 47 bytes  (porque como son 48 y el primero ya lo hemos seteado)
      ldir
      ret
   __endasm;
}

//devuelve en A el numero de instancias que estan activas (osea el OBJ_ACTIVE_TYPE > 0)
void vtObjectsCounter() __naked {
   __asm
      ld hl,#GAME_OBJECTS_PTR
      ld de,#48
      ld b,#16    //miramos los 16 objetos
      ld c,#0     //aqui vamos a ir contando los que llevamos activos
   vtObjectsCounterBucle:
      ld a,(hl)
      or a
      jr Z,vtObjectsCounterBucle2
      inc c    //no es cero, contamos uno más

   vtObjectsCounterBucle2:
      add hl,de      //pasamos al siguiente
      djnz vtObjectsCounterBucle    //b=b-1 y si no es cero vuelve al bucle

      ld a,c         //devolvemos el resultado en A

      ret
   __endasm;
}


/*
//usa el sprite del objeto seleccionado actual
void vtPushSpriteToDrawOld()
{
   if(vtZoneCalc!=0)
   {   
      *vtSpriteListToDrawPtr=vtZoneCalc;
      vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

  
      *vtSpriteListToDrawPtr=(u16)vtPointerAux%256;     //lo agrego a la lista
      vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      *vtSpriteListToDrawPtr=(u16)vtPointerAux/256;
      vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

      vtPointerAux2=vtGameObjPtr->animationArrayPtr[vtGameObjPtr->frameIndex/256];

	   *vtSpriteListToDrawPtr=((u16)vtPointerAux2)%256;     //y ahora la funcion que voy a usar para dibujar
      vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      *vtSpriteListToDrawPtr=((u16)vtPointerAux2)/256;
      vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

      if( (vtGameObjPtr->flags & FLAG_FLASH_SPRITE) != 0)
      {
         if(vtGameObjPtr->life<10)
         {
            *vtSpriteListToDrawPtr=CUSTOM_A_PAL_9|CUSTOM_B_PAL_9;      //hacemos flash en este frame PERO DE COLOR ROJO DE POCA VIDA y quitamos el flash
         }else{
            *vtSpriteListToDrawPtr=0xFF;      //hacemos flash en este frame y quitamos el flash
         }
      }else{
         *vtSpriteListToDrawPtr=vtGameObjPtr->customColor;      //metemos los custom colors
      }
      
      vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

      *vtSpriteListToDrawPtr=vtDespWidth;                //y ahora si hay que dibujarlo hacia la derecha (0) o hacia la izq (width en bytes)
      vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

      //ahora miro si tiene sprite secundario o no
      if(vtGameObjPtr->animationArrayPtr2!=0)
      {
         *vtSpriteListToDrawPtr=vtZoneCalc;
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

   
         *vtSpriteListToDrawPtr=(u16)vtPointerAux%256;     //lo agrego a la lista
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
         *vtSpriteListToDrawPtr=(u16)vtPointerAux/256;
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

         if(vtGameObjPtr->iaState3==0)
         {
            vtPointerAux2=vtGameObjPtr->animationArrayPtr2[vtGameObjPtr->frameIndex/256];
         }else{
            vtPointerAux2=vtGameObjPtr->animationArrayPtr2[0];
         }
         *vtSpriteListToDrawPtr=((u16)vtPointerAux2)%256;     //y ahora la funcion que voy a usar para dibujar
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
         *vtSpriteListToDrawPtr=((u16)vtPointerAux2)/256;
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

         if( (vtGameObjPtr->flags & FLAG_FLASH_SPRITE) != 0)
         {
         	if(vtGameObjPtr->life<10)
            {
               *vtSpriteListToDrawPtr=CUSTOM_A_PAL_9|CUSTOM_B_PAL_9;      //hacemos flash en este frame PERO DE COLOR ROJO DE POCA VIDA y quitamos el flash
            }else{
                  *vtSpriteListToDrawPtr=0xFF;      //hacemos flash en este frame y quitamos el flash
            }
         }else{
            *vtSpriteListToDrawPtr=vtGameObjPtr->customColor2;      //metemos los custom colors
         }
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

         *vtSpriteListToDrawPtr=vtDespWidth;                //y ahora si hay que dibujarlo hacia la derecha (0) o hacia la izq (width en bytes)
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      }

      if( (vtGameObjPtr->flags & FLAG_FLASH_SPRITE) != 0)
      {
         vtGameObjPtr->flags= vtGameObjPtr->flags & 0b11110111;   //le quito el flag del flash sprite porque ya lo voy a dibujar en este frame
      }

      *vtSpriteListToDrawPtr=0;
  }

}
*/


void vtPushSpriteToDraw() __naked {
   __asm

      ld a,(#_vtZoneCalc)     //if(vtZoneCalc!=0)
      or a
      ret Z       //si es cero pa fuera, no hay que dibujar nada ni hacer nada

      
      // *vtSpriteListToDrawPtr=vtZoneCalc;
      // vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      ld de,(#_vtSpriteListToDrawPtr)
      ld (de),a
      inc de


      /* *vtSpriteListToDrawPtr=(u16)vtPointerAux%256;     //lo agrego a la lista
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
         *vtSpriteListToDrawPtr=(u16)vtPointerAux/256;
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;     */

      ld hl,(#_vtPointerAux)
      ld a,l
      ld (de),a
      inc de
      ld a,h
      ld (de),a
      inc de
      

      //vtPointerAux2=vtGameObjPtr->animationArrayPtr[vtGameObjPtr->frameIndex/256];
      ld ix,(#_vtGameObjPtr)
      ld a,OBJ_FRAME_INDEX+1(ix)    // A=vtGameObjPtr->frameIndex/256
      ld l,OBJ_ANIMATION_LIST(ix)
      ld h,OBJ_ANIMATION_LIST+1(ix)    // HL=vtGameObjPtr->animationArrayPtr
      add a
      add l
      jr NC,vtPushSpriteToDraws2
      inc h
   vtPushSpriteToDraws2:
      ld l,a                           // HL=vtGameObjPtr->animationArrayPtr[vtGameObjPtr->frameIndex/256]

      ld c,(hl)                  //y ahora leo el puntero al sprite
      inc hl
      ld b,(hl)

      //ld (#_vtPointerAux2),hl          //vtPointerAux2=vtGameObjPtr->animationArrayPtr[vtGameObjPtr->frameIndex/256];




      /*    *vtSpriteListToDrawPtr=((u16)vtPointerAux2)%256;     //y ahora la funcion que voy a usar para dibujar
            vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
            *vtSpriteListToDrawPtr=((u16)vtPointerAux2)/256;
            vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;     */

      ld a,c
      ld (de),a      //*vtSpriteListToDrawPtr=((u16)vtPointerAux2)%256;
      inc de         //vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      ld a,b
      ld (de),a      //*vtSpriteListToDrawPtr=((u16)vtPointerAux2)/256;
      inc de         //vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1; 



      /*    if( (vtGameObjPtr->flags & FLAG_FLASH_SPRITE) != 0)
            {
               if(vtGameObjPtr->life<10)
               {
                  *vtSpriteListToDrawPtr=CUSTOM_A_PAL_9|CUSTOM_B_PAL_9;      //hacemos flash en este frame PERO DE COLOR ROJO DE POCA VIDA y quitamos el flash
               }else{
                  *vtSpriteListToDrawPtr=0xFF;      //hacemos flash en este frame y quitamos el flash
               }
            }else{
               *vtSpriteListToDrawPtr=vtGameObjPtr->customColor;      //metemos los custom colors
            }           */


      bit 3,OBJ_FLAGS(ix)
      jr Z,vtPushSpriteToDraws5

      ld a,#10
      cp OBJ_LIFE(ix)
      jr C,vtPushSpriteToDraws4

      ld a,#CUSTOM_A_PAL_9|CUSTOM_B_PAL_9
      jr vtPushSpriteToDraws6

   vtPushSpriteToDraws4:
      ld a,#0xFF
      jr vtPushSpriteToDraws6

   vtPushSpriteToDraws5:
      ld a,OBJ_CUSTOM_COLOR(ix)
   
   vtPushSpriteToDraws6:
      ld (de),a


      /* vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

         *vtSpriteListToDrawPtr=vtDespWidth;                //y ahora si hay que dibujarlo hacia la derecha (0) o hacia la izq (width en bytes)
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;     */

      inc de         //vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      ld a,(#_vtDespWidth)
      ld (de),a         //*vtSpriteListToDrawPtr=vtDespWidth;    
      inc de         //vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

      

      xor a
      or OBJ_ANIMATION_LIST_2+1(ix)
      jp Z,vtPushSpriteToDrawFinish


      /*    *vtSpriteListToDrawPtr=vtZoneCalc;
            vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;     */
      ld a,(#_vtZoneCalc)
      ld (de),a
      inc de

   
      /*    *vtSpriteListToDrawPtr=(u16)vtPointerAux%256;     //lo agrego a la lista
            vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
            *vtSpriteListToDrawPtr=(u16)vtPointerAux/256;
            vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;        */

      ld hl,(#_vtPointerAux)
      ld a,l
      ld (de),a         // *vtSpriteListToDrawPtr=(u16)vtPointerAux%256;
      inc de            // vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      ld a,h
      ld (de),a         // *vtSpriteListToDrawPtr=(u16)vtPointerAux/256;
      inc de            // vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;


      /* if(vtGameObjPtr->iaState3==0)
         {
            vtPointerAux2=vtGameObjPtr->animationArrayPtr2[vtGameObjPtr->frameIndex/256];
         }else{
            vtPointerAux2=vtGameObjPtr->animationArrayPtr2[0];
         }     */

      ld l,OBJ_ANIMATION_LIST_2(ix)
      ld h,OBJ_ANIMATION_LIST_2+1(ix)

      ld a,OBJ_IA_AUX_3(ix)
      or a
      jr NZ,vtPushSpriteToDraws10

      ld a,OBJ_FRAME_INDEX+1(ix)
      add a
      add l
      jr NC,vtPushSpriteToDraws8
      inc h

   vtPushSpriteToDraws8:
      ld l,a

   vtPushSpriteToDraws10:
      ld c,(hl)                  //y ahora leo el puntero al sprite
      inc hl
      ld b,(hl)


      //ld (#_vtPointerAux2),hl  no hace falta


      /*    *vtSpriteListToDrawPtr=((u16)vtPointerAux2)%256;     //y ahora la funcion que voy a usar para dibujar
            vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
            *vtSpriteListToDrawPtr=((u16)vtPointerAux2)/256;
            vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;     */

      ld a,c
      ld (de),a      // *vtSpriteListToDrawPtr=((u16)vtPointerAux2)%256;
      inc de         // vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      ld a,b
      ld (de),a      // *vtSpriteListToDrawPtr=((u16)vtPointerAux2)/256;
      inc de         // vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;




      /*    if( (vtGameObjPtr->flags & FLAG_FLASH_SPRITE) != 0)
            {
         	   if(vtGameObjPtr->life<10)
               {
                  *vtSpriteListToDrawPtr=CUSTOM_A_PAL_9|CUSTOM_B_PAL_9;      //hacemos flash en este frame PERO DE COLOR ROJO DE POCA VIDA y quitamos el flash
               }else{
                  *vtSpriteListToDrawPtr=0xFF;      //hacemos flash en este frame y quitamos el flash
               }
            }else{
               *vtSpriteListToDrawPtr=vtGameObjPtr->customColor2;      //metemos los custom colors
            }        */

      bit 3,OBJ_FLAGS(ix)
      jr Z,vtPushSpriteToDraws15

      ld a,#10
      cp OBJ_LIFE(ix)
      jr C,vtPushSpriteToDraws14

      ld a,#CUSTOM_A_PAL_9|CUSTOM_B_PAL_9
      jr vtPushSpriteToDraws16

   vtPushSpriteToDraws14:
      ld a,#0xFF
      jr vtPushSpriteToDraws16

   vtPushSpriteToDraws15:
      ld a,OBJ_CUSTOM_COLOR_2(ix)

   vtPushSpriteToDraws16:
      ld (de),a


      /*    vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;

         *vtSpriteListToDrawPtr=vtDespWidth;                //y ahora si hay que dibujarlo hacia la derecha (0) o hacia la izq (width en bytes)
         vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;     */

      inc de                  // vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;
      ld a,(#_vtDespWidth)    
      ld (de),a               // *vtSpriteListToDrawPtr=vtDespWidth;   
      inc de                  // vtSpriteListToDrawPtr=vtSpriteListToDrawPtr+1;


   vtPushSpriteToDrawFinish:

      /*    if( (vtGameObjPtr->flags & FLAG_FLASH_SPRITE) != 0)
            {
               vtGameObjPtr->flags= vtGameObjPtr->flags & 0b11110111;   //le quito el flag del flash sprite porque ya lo voy a dibujar en este frame
            }
            *vtSpriteListToDrawPtr=0;     */

      //bit 3,OBJ_FLAGS(ix)
      //jr Z,vtPushSpriteToDrawFinishs2
      res 3,OBJ_FLAGS(ix)



      //ahora voy a ver si en la proxima restore background puedo ahorrarme el dibujar unos cuantos de tiles
      //hay 2 formas de ahorrarmelos, en el horizontal si el bit 7 del byte bajo está a 0, ya que en ese caso el sprite esta alineado 
      //horizontalmente y no tengo que dibujar un tile de más por la derecha
      res 0,OBJ_FLAGS_2(ix)      //en principio no puedo optimizar
      bit 7,OBJ_POSX(ix)
      jr NZ,vtPushSpriteToDrawFinishs2
      //si es cero, puedo aplicar esta optimizacion
      set 0,OBJ_FLAGS_2(ix) 

   vtPushSpriteToDrawFinishs2:
      //y ahora voy a hacer lo mismo en vertical, aunque en vertical no vale solo mirar el bit 7, ya que en vertical voy al pixel, tengo 
      //que mirar los 3 bits más altos, y si es 0 puedo optimizar sino no

      

      res 1,OBJ_FLAGS_2(ix)      //en principio no puedo optimizar
      ld a,OBJ_POSY(ix)
      and #0b11000000
      jr NZ,vtPushSpriteToDrawFinishs3
      set 1,OBJ_FLAGS_2(ix)      //son 0, puedo optimizar el restore background

   vtPushSpriteToDrawFinishs3:

      xor a
      ld (de),a
      ld (#_vtSpriteListToDrawPtr),de  
      ret

   __endasm;
}




u8 vtIsGameObjInScreen() __naked {
   __asm
      //primero comprobamos el ejeX que es el lado más largo y por ende más facil que este fuera por el ejeX que por el Y
      /*if(  ((vtGameObjPtr->posx/256)-vtSceneScrollX)>40  )
      {
         return 0;   //nos hemos salido por la derecha
      }
      if(  (  ((i16)(vtGameObjPtr->posx/256))  -   ((i16)vtSceneScrollX)  -  ((i16)vtGameObjPtr->widthTiles) )<0  )
      {
         return 0;   //nos hemos salido por la izq
      }

         //comprobacion simple de si es negativo >127 como es un u8 eso es como si fuese negativo
      if(  ((vtGameObjPtr->posy/256)-vtSceneScrollY)>127 )
      {
         return 0;      //nos hemos salido por arriba
      }

      if(  ((vtGameObjPtr->posy/256)-vtSceneScrollY+vtGameObjPtr->heightTiles)>25)
      {
         return 0;      //nos hemos salido por abajo
      }
      return 1;   //estamos dentro*/




      ld l,#0     //por defecto voy a dar por hecho que esta fuera L=0

      ld ix,(#_vtGameObjPtr)
      ld a,(#_vtSceneScrollX)
      ld b,a      //B=vtSceneScrollX
      inc b       //incremente en 1 B para que salga un poco antes por la izq


      /*if(  ((vtGameObjPtr->posx/256)-vtSceneScrollX)>40  )
      {
         return 0;   //nos hemos salido por la derecha
      }*/

      ld a,OBJ_POSX+1(ix)  //leo el byte alto de posx
      sub b
      ret C    //si hay carry se ha salido por la izq

      //jr NC,vtIsGameObjInScreens2
      //xor a    //ld a,#0
   vtIsGameObjInScreens2:
      add OBJ_WIDTH(ix)
      cp #39      //y ahora le resto 40, si no hay carry es que A-vtSceneScrollX>40
      ret NC    //si A-vtSceneScrollX > +40 pa fuera

      //sub OBJ_WIDTH(ix)    //A = (vtGameObjPtr->posx/256) - vtSceneScrollX - vtGameObjPtr->widthTiles
      //ret C    //si hay carry es que A < 0 




      ld a,(#_vtSceneScrollY)
      ld b,a      //B=vtSceneScrollY
      inc b       //incremento B para que salta antes por arriba

      //;src/main.c:1525: if(  ((vtGameObjPtr->posy/256)-vtSceneScrollY)>127 )
      ld a,OBJ_POSY+1(ix)  //leo el byte alto de posx
      sub b
      bit 7,a
      ret NZ

      //if(  ((vtGameObjPtr->posy/256)-vtSceneScrollY+vtGameObjPtr->heightTiles)>25)
      add OBJ_HEIGHT(ix)
      cp #24
      ret NC

      //y ya está, si llego aqui es que esta dentro, devuelvo L=1
      ld l,#1
      ret

   __endasm;
}




void vtUsePaletteBlack() __naked {
__asm
	//ld b, #0x7F   ;; [2] BC = Gate Array Port (0x7F), to send commands using OUT
	//ld e,#0
   //ld    a, e              ;; ;[1] A = E, A has index of the next PEN to be established
   //OR   #PAL_PENR          ;; ;[2] A = (CCCnnnnn) Mix 3 bits for PENR command (C) and 5 for PEN number (n). 
   //                         ;; .... As PENR command is 000, nothing to be done here.
   	//out (c), e               ;; [4] GA Command: Select PENR. E = Command + Parameter (PENR + PEN number to select
//   	ld a, (hl)            ;; [2] Get Color value (INK) for the selected PEN from array
//   and   #0x1F              ;; [2] Leave out only the 5 Least significant bits (3 MSB can cause problems)
//   or    #PAL_INKR          ;; [2] (CCCnnnnn) Mix 3 bits for INKR command (C) and 5 for PEN number (n). 
//   	out (c), a               ;; [4] GA Command: Set INKR. A = Command + Parameter 
   	
   	
   	
   	//por velocidad hacemos el cambio sin bucles y cargando valores directos (sin sacarlos de arrays ni nada)
   	ld b,#0x7F		//Preparamos los outs el gate_array
   	ld a,#PAL_HARD_BLACK   	//preparamos el color que vamos a usar NEGRO+PAL_INKR
   	
   	ld e,#0		//0
   	out (c),e
   	out (c),a
   	
   	inc e		//1
   	out (c),e
   	out (c),a
   	
   	inc e		//2
   	out (c),e
   	out (c),a
   	
   	inc e		//3
   	out (c),e
   	out (c),a
   	
   	inc e		//4
   	out (c),e
   	out (c),a
   	
   	inc e		//5
   	out (c),e
   	out (c),a
   	
   	inc e		//6
   	out (c),e
   	out (c),a
   	
   	inc e		//7
   	out (c),e
   	out (c),a
   	
   	inc e		//8
   	out (c),e
   	out (c),a
   	
   	inc e		//9
   	out (c),e
   	out (c),a
   	
   	inc e		//10
   	out (c),e
   	out (c),a
   	
   	inc e		//11
   	out (c),e
   	out (c),a
   	
   	inc e		//12
   	out (c),e
   	out (c),a
   	
   	inc e		//13
   	out (c),e
   	out (c),a
   	
   	inc e		//14
   	out (c),e
   	out (c),a
   	
   	inc e		//15
   	out (c),e
   	out (c),a   	
   	
   	
	ret		//y listo, toda la paleta a negro, nos piramos
   __endasm;   
}



void vtUsePaletteGame() __naked {
__asm
	//ld b, #0x7F   ;; [2] BC = Gate Array Port (0x7F), to send commands using OUT
	//ld e,#0
   //ld    a, e              ;; ;[1] A = E, A has index of the next PEN to be established
   //OR   #PAL_PENR          ;; ;[2] A = (CCCnnnnn) Mix 3 bits for PENR command (C) and 5 for PEN number (n). 
   //                         ;; .... As PENR command is 000, nothing to be done here.
   	//out (c), e               ;; [4] GA Command: Select PENR. E = Command + Parameter (PENR + PEN number to select
//   	ld a, (hl)            ;; [2] Get Color value (INK) for the selected PEN from array
//   and   #0x1F              ;; [2] Leave out only the 5 Least significant bits (3 MSB can cause problems)
//   or    #PAL_INKR          ;; [2] (CCCnnnnn) Mix 3 bits for INKR command (C) and 5 for PEN number (n). 
//   	out (c), a               ;; [4] GA Command: Set INKR. A = Command + Parameter 
   	
      push af
   	
      //pequeño retard para que coincida con el sitio exacto para disimular la entrada de tiles
      ld b,#255
   vtUsePaletteGameRetard:
      djnz vtUsePaletteGameRetard
   	
   	//por velocidad hacemos el cambio sin bucles y cargando valores directos (sin sacarlos de arrays ni nada)
   	ld b,#0x7F		//Preparamos los outs el gate_array
   	
   	ld e,#0		//0
   vtUsePaletteGameChange0:
   	ld a,#0   	//preparamos el color que vamos a usar NEGRO+PAL_INKR
   	out (c),e
   	out (c),a
   	
   	inc e		//1
   vtUsePaletteGameChange1:
   	ld a,#0
   	out (c),e
   	out (c),a
   	
   	inc e		//2
   vtUsePaletteGameChange2:
   	ld a,#0
   	out (c),e
   	out (c),a
   	
   	inc e		//3
   vtUsePaletteGameChange3:
   	ld a,#0   	
   	out (c),e
   	out (c),a
   	
   	inc e		//4
   vtUsePaletteGameChange4:
   	ld a,#0   	
   	out (c),e
   	out (c),a
   	
   	inc e		//5
   vtUsePaletteGameChange5:
  	   ld a,#0
   	out (c),e
   	out (c),a
   	
   	inc e		//6
   vtUsePaletteGameChange6:
   	ld a,#0   	
   	out (c),e
   	out (c),a
   	
   	inc e		//7
   vtUsePaletteGameChange7:
   	ld a,#0
   	out (c),e
   	out (c),a
   	
   	inc e		//8
   vtUsePaletteGameChange8:
   	ld a,#0  	
   	out (c),e
   	out (c),a
   	
   	inc e		//9
   vtUsePaletteGameChange9:
   	ld a,#0  	
   	out (c),e
   	out (c),a
   	
   	inc e		//10
   vtUsePaletteGameChange10:
   	ld a,#0   	
   	out (c),e
   	out (c),a
   	
   	inc e		//11
   vtUsePaletteGameChange11:
   	ld a,#0   	
   	out (c),e
   	out (c),a
   	
   	inc e		//12
   vtUsePaletteGameChange12:
   	ld a,#0
   	out (c),e
   	out (c),a
   	
   	inc e		//13
   vtUsePaletteGameChange13:
   	ld a,#0
   	out (c),e
   	out (c),a
   	
   	inc e		//14
   vtUsePaletteGameChange14:
   	ld a,#0
   	out (c),e
   	out (c),a
   	
   	inc e		//15
   vtUsePaletteGameChange15:
   	ld a,#0
   	out (c),e
   	out (c),a   	
   	
   	pop af
	ret		//y listo, toda la paleta recuperada del juego, nos piramos
   __endasm;   
}



//configura la funcion vtUsePaletteGame para que use los colores indicados en un array pasado en vtPointerAux
void vtConfigurePaletteGame() __naked {
   __asm      
      ld hl,(#_vtPointerAux)
      ld de,#vtUsePaletteGameChange0+1
      ld bc,#7
      ex de,hl
      ld a,#16
      
   vtConfigurePaletteGameBucle:
      ex af,af' 
      //'

      ld a,(de)      
      ld (hl),a
      add hl,bc
      inc de

      ex af,af' 
      //'
      dec a 
      jr NZ,vtConfigurePaletteGameBucle


      ret		//y listo, toda la paleta recuperada del juego, nos piramos
   __endasm;   
}


//carga un escenario a partir del puntero al ultimo byte del comprimido
/*
void vtLoadSceneCompress(u16 endCompressSceneBytesPtr)
{
   cpct_zx7b_decrunch_s(SCENE_END_MEM, endCompressSceneBytesPtr);
}
*/
/*
//carga un escenario a partir del puntero al ultimo byte del comprimido
void vtLoadScene(u16 noCompressScenePtr)
{
   //cpct_memcpy(SCENE_START_MEM, noCompressScenePtr, 1024);
   //cpct_zx7b_decrunch_s(SCENE_END_MEM, endCompressSceneBytesPtr);
}
*/






/*
//devuelve el tile que se encuentre en esa posicion (ojo, posicion en tiles)
u8 vtCheckTile(u8 x, u8 y){
	//nos movemos por la scena 
	return *(u8*)(
				(vtMetaTileSetPtr   + 
					 
					 *(u8*)(SCENE_START_MEM +
					 (     
							// ( (y/8) * 64)    +    (x/8)  
                     // ( (y/8) * 32)    +    (x/8) 
					 		( (y&0xF8) * 4)    +    (x/8)  
					  ))
					    * 32)      //antes 64
					  
					  + (  ((u8)((y%8)<<3))   +   (x%8)  ) 
		  );
}
*/



void debugArmony() __naked {
__asm
exx
exx
ret
__endasm;
}


//esta funcion se llama desde el step de un objeto y lo que hace es ver que tiles se tienen que restaurar antes de dibujar el nuevo sprite
//basicamente rellena vtPushTilesIniX,vtPushTilesEndX,vtPushTilesIniY,vtPushTilesEndY
void vtPrepareRestoreBackground() __naked {
__asm
      ld ix,(#_vtGameObjPtr)

      ld a,OBJ_REDRAWY(ix)
      or a
      ret Z    //si es cero no vamos a restaurar ná

   //OJO AUTO SELF-MODIFIED CODE, el numero se cambiara entre 40 y 39 en funcion de si estamos haciendo scroll a la izq o no, 
   //    es para que no la lie el redibujado de tiles cuando scrolea
   vtPrepareRestoreBackgroundTopeHor:        
      ld b,#39       //KABESA, revisa esta mierda    

      ld a,(#_vtSceneScrollX)
      ld c,a
      ld a,OBJ_REDRAWX(ix)       //le resto el scroll porque OBJ_REDRAWX es absoluto
      sub c

   //vtPrepareRestoreBackgroundREAJUSTESCROLLX:
      //nop

      cp #38      //OJO! no quitar esta comprobacion porque sino puede petar el juego (supongo que porke dibuja tiles donde no debe)
      jr C,vtPrepareRestoreBackgrounds1
      ld a,#38       
   vtPrepareRestoreBackgrounds1:
      or a 
      jr NZ,vtPrepareRestoreBackgrounds1b

   vtPrepareRestoreBackgrounds1a:
      //OJO AUTO SELF-MODIFIED CODE, si estamos haciendo scroll hacia la derecha, este NOP sera un INC A para que sea 1 en vez de 0
      nop            //KABESON     aqui hay que mirar si estamos scroleando hacia la derecha, ya que en ese caso el minimo es 1 y no 0


   vtPrepareRestoreBackgrounds1b:
      ld (#_vtPushTilesIniX),a

      add OBJ_WIDTH(ix)

      
      bit 0,OBJ_FLAGS_2(ix)
      jr NZ,vtPrepareRestoreBackgrounds1c     //si el bit alto del byte bajo de POSX es 0, es que esta alineado al tile, y no es necesario añadirle un tile más de dibujado
      inc a       //le agregamos 1 tile más por si se mueve un byte en vez de un tile
   vtPrepareRestoreBackgrounds1c:

      cp b
      jr C,vtPrepareRestoreBackgrounds2
      ld a,b             //maximo 38 de endX
   vtPrepareRestoreBackgrounds2:
      ld (#_vtPushTilesEndX),a

      //ld OBJ_REDRAWX(ix),#0         //lo pongo a 0 para que si no se pinta el siguiente frame se quede a 0 y con esto ya se que en el ultimo frame no se dibujo el sprite


   //OJO AUTO SELF-MODIFIED CODE, el numero se cambiara entre 25 y 24 en funcion de si estamos haciendo scroll arriba o no, 
   //    es para que no la lie el redibujado de tiles cuando scrolea
   vtPrepareRestoreBackgroundTopeVer:
      ld b,#24    

      ld a,(#_vtSceneScrollY)
      ld l,a
      ld a,OBJ_REDRAWY(ix)

   //vtPrepareRestoreBackgroundREAJUSTESCROLLY:
      //nop

      sub l
      cp #23      //antes 25    OJO! no quitar esta comprobacion porque sino puede petar el juego (supongo que porke dibuja tiles donde no debe)
      jr C,vtPrepareRestoreBackgrounds3
      ld a,#23       //maximo 23 de initY
   vtPrepareRestoreBackgrounds3:
      //ld a,29(ix)
   

      ld (#_vtPushTilesIniY),a
      add OBJ_HEIGHT(ix)

      bit 1,OBJ_FLAGS_2(ix)
      jr NZ,vtPrepareRestoreBackgrounds3b
      inc a         //le agregamos 1 tile más por si se mueve un byte en vez de un tile

   vtPrepareRestoreBackgrounds3b:

      cp b
      jr C,vtPrepareRestoreBackgrounds4
      //si no hay carry es que nos hemos salido por abajo de la pantalla, lo pongo a 25 como tope y a juir
      ld a,b       //maximo 24 de endY
   vtPrepareRestoreBackgrounds4:
      ld (#_vtPushTilesEndY),a

      //ld OBJ_REDRAWY(ix),#0

      ret
__endasm;
}


/*    esta funcion ajusta los flags para saber si se tiene que redibujar el fondo y si se tiene que redibujar el sprite
      el algoritmo es más o menos el siguiente

si ahora esta dentro de la pantalla

	si flag(2)=0	//si acaba de entrar
		flag(0)=0		//no dibujamos el fondo
		flag(1)=1		//si dibujamos el sprite
      flag(2)=1  
	sino			//si ya estaba dentro
		flag(0)=flag(1)		//redibujamos el fondo si vamos a redibujar el sprite, sino no
	
	
	
sino

	flag(0)=flag(2)			//solo redibujamos el fondo, si antes estabamos dentro, para limpiar al salir, sino no
	flag(1)=0				//si esta fuera de la pantalla no podemos dibujar el sprite en ningun caso, kaka, aunque se mueva
	flag(2)=0  				//actualizamos que ahora estamos fuera de la pantalla
*/
void vtStepObjectFunc() __naked {
   __asm
   
   	//miro el auto move
      ld ix,(#_vtGameObjPtr)   		
   //vtDrawFlagsAutoMove:
      //bit 6,OBJ_FLAGS(ix)                 //miramos si hay que forzar el dibujado siempre  FLAG_FORCE_DRAW
      //jr Z,vtDrawFlagsAutoMove2
      //set 1,OBJ_FLAGS(ix)        //si tenemos FLAG_FORCE_DRAW es como si se moviese siempre, osea se dibuja siempre que se pueda y este dentro de la pantalla
      

   vtDrawFlagsAutoMove2:
      bit 4,OBJ_FLAGS(ix)
      jr Z,vtDrawFlagsAutoAnim
      //si entro aqui tengo que hacer posX=posX+speedX and posY=posY+speedY
      ld l,OBJ_POSX(ix)				//posX=posX+speedX
      ld h,OBJ_POSX+1(ix)
      ld e,OBJ_SPEEDX(ix)
      ld d,OBJ_SPEEDX+1(ix)
      add hl,de
      ld OBJ_POSX(ix),l
      ld OBJ_POSX+1(ix),h
      
      ld l,OBJ_POSY(ix)				//posY=posY+speedY
      ld h,OBJ_POSY+1(ix)
      ld e,OBJ_SPEEDY(ix)
      ld d,OBJ_SPEEDY+1(ix)
      add hl,de
      ld OBJ_POSY(ix),l
      ld OBJ_POSY+1(ix),h

      //set 1,OBJ_FLAGS(ix)     //como hemos movido el objeto tenemos que dibujarlo
      

   
   vtDrawFlagsAutoAnim:
      //miro el auto anim
      bit 5,OBJ_FLAGS(ix)
      jr Z,vtDrawFlagsCheckInScreen
      ld l,OBJ_FRAME_INDEX(ix)				//frameIndex=frameIndex+frameSpeed
      ld h,OBJ_FRAME_INDEX+1(ix)
      ld a,OBJ_FRAME_SPEED(ix)
      add l
      jr NC,vtDrawFlagsAutoAnimS2
      inc h
      //set 1,OBJ_FLAGS(ix)           //como ha cambiado de animacion hay que dibujarlo
      
   vtDrawFlagsAutoAnimS2:
      ld l,a
      
      ld a,OBJ_ANIMATION_MAX(ix)
      cp h
      jr NZ,vtDrawFlagsAutoAnimS3
      ld h,#0		//si es igual que el max reseteo la anim (la parte alta solo)
      
   vtDrawFlagsAutoAnimS3:
      ld OBJ_FRAME_INDEX(ix),l				//frameIndex=frameIndex+frameSpeed
      ld OBJ_FRAME_INDEX+1(ix),h
   		
   		
   vtDrawFlagsCheckInScreen:


   vtDrawFlagsCheckInScreens2:
      call _vtIsGameObjInScreen     //primero dejamos en L si ahora estamos dentro o fuera de la pantalla
      //call _trapIX


      ld a,OBJ_FLAGS(ix)   //cargo todos los flags en A para toketear más rapido
      bit 0,l              //ahora si L=1 estamos dentro de la pantalla
      jr Z,vtDrawFlagsCheckFueraPantalla

   vtDrawFlagsCheckDentroPantalla:
      //dentro de la pantalla
      ld OBJ_NEED_REDRAW(ix),#1
      bit 2,a     //chequeo si en el frame anterior estaba en la pantalla o no
      jr NZ,vtDrawFlagsCheckDentroPantallas2     //si no es cero es que ya estaba dentro de la pantalla

      //ACABO DE ENTRAR EN LA PANTALLA -------------------------------------------------------
      res 0,a     //flag(0)=0  no vamos a redibujar el fondo
      set 1,a     //flag(1)=1  si vamos a dibujar el sprite (aunque no haya cambiado porque acaba de entrar)
      set 2,a     //flag(2)=1  en pantalla
      jp vtDrawFlagsCheckEnd


   vtDrawFlagsCheckDentroPantallas2:
      //CONTINUO DENTRO DE LA PANTALLA ------------------------------------------------------
      //bit 1,a           //flags(0)=flags(1)     //en funcion de si el frame anterior dibujamos el sprite o no, en este tenemos que borrar el fondo o no
      //res 0,a
      //jr Z,vtDrawFlagsCheckEnd
      //set 0,a
      set 0,a     //como continuo dentro de la pantalla, tengo que borrar el fondo
      jp vtDrawFlagsCheckEnd
   



   vtDrawFlagsCheckFueraPantalla:
      //AHORA ESTOY FUERA DE LA PANTALLA ------------------------------------------------------------------

      //flag(0)=flag(2)			//solo redibujamos el fondo, si antes estabamos dentro, para limpiar al salir, sino no
      res 0,a     //por defecto lo pongo flag(0)=0 para no redibujar el fondo
      bit 2,a        //ahora miro si en el frame anterior estaba dentro de la pantalla o no
      jr Z,vtDrawFlagsCheckFueraPantallas1      //si es cero salto al bloque siguiente porque en el frame anterior tampoco estaba en pantalla
      set 0,a     //si no salto lo pongo a flag(0)=1 para redibujar el fondo


   vtDrawFlagsCheckFueraPantallas1:
      res 1,a           //no voy a dibujar el sprite
      res 2,a           //ya no estoy dentro de la pantalla


   vtDrawFlagsCheckEnd:
      ld OBJ_FLAGS(ix),a      //ajusto de nuevo los flags del objeto
      and #1      // si el bit 0 es 1 tengo que seguir para redibujar el fondo
      ret Z       //si es cero no tengo que pushear los tiles de fondo y puedo pirarme


      //call _trapIX
      //si llego aqui es que tengo que restaurar el fondo
      call _vtPrepareRestoreBackground    //preparo los parametros para ver que tengo que restaurar, y luego llamo al push para que lo haga
      //call _trapIX
      jp _vtPushTilesToDraw      //si es 1 si pusheo los tiles, voy con jump para que el ret de pushtiles me devuelva atras
   
   
   __endasm;
}


//funcion que calcula el centro de los dos objetos IX e IY y la diferencia entre ellos
//una vez calculada la diferencia se aplica aceleración en el sentido opuesto para que
// los personajes se separen entre ellos
//OJO, esta funcion solo mueve IX, el IY lo tiene que mover su funcion de colision que puede ser diferente
//RECUERDA si entra aqui es que ya hay colision seguro y viene IX e IY cargados (ix es el que tiene que hacer algo, iy es el otro)
void vtColisionRepulseFunc() __naked {
   __asm
      //call _vtBorderRed
      //calculo la diferencia de (IX.POSX+((IX.WIDTH*4)*2)) - (IY.POSX+((IY.WIDTH*4)*2))
      //voy a segunda parte en DE
      //DE=(IY.POSX+((IY.WIDTH*4)*2))
      ld a,OBJ_WIDTH(iy)
      //add a,a
      ld e,OBJ_POSX(iy)
      ld d,OBJ_POSX+1(iy)
      add d
      ld d,a
      //add e
      //jr NC,vtColisionRepulseFuncs2
      //inc d
   //vtColisionRepulseFuncs2:
      //ld e,a            //DE=(IY.POSX+((IY.WIDTH*4)*2))



      ld a,OBJ_WIDTH(ix)
      //add a,a
      ld l,OBJ_POSX(ix)
      ld h,OBJ_POSX+1(ix)
      //add l
      //jr NC,vtColisionRepulseFuncs4
      //inc h
   //vtColisionRepulseFuncs4:
      //ld l,a            //HL=(IX.POSX+((IX.WIDTH*4)*2))
      add h
      ld h,a


      xor a
      sbc hl,de

      bit 7,h
      ld hl,#0xFF80        //lo voy a empujar por defecto a la izquierda y segun la diferencia veo si pa un lao u otro
      jr NZ,vtColisionRepulseFuncs6
      ld hl,#128

   vtColisionRepulseFuncs6:


      ld e,OBJ_POSX(ix)
      ld d,OBJ_POSX+1(ix)

      add hl,de      //se lo sumamos a la velocidad actual para que vaya modificandose

      ld OBJ_POSX(ix),l
      ld OBJ_POSX+1(ix),h

      //call _vtBorderBlack

      ret
   __endasm;
}

/*
//esta funcion equivale al draw pero lo que hace es seguir (copia x e y y velocidad del objeto original y el frameindex y prepara para dibujar)
void vtFollowAndDrawObjectFunc()  __naked {
   __asm
      ld ix,(#_vtGameObjPtr)
      ld l,OBJ_PARENT_PTR(ix)
      ld h,OBJ_PARENT_PTR+1(ix)
      push hl
      pop iy

      ld a,OBJ_ACTIVE_TYPE(ix)
      or a
      jr Z,vtFollowAndDrawObjectFuncEndAndDestroy

      //ld a,OBJ_FLAGS(ix)
      //bit 1,a        //compruebo si hay que dibujar el sprite o no
      //jr Z,vtFollowAndDrawObjectFuncEnd      //no hay que dibujar el sprite, asi que nos piramos

      //copiamos propiedades necesarias para dibujar
      ld a,OBJ_FRAME_INDEX+1(iy)    //meto el indice que se va a renderizar namas, el low byte me la pela en verdad
      ld OBJ_FRAME_INDEX+1(ix),a

      ld a,OBJ_POSX(iy)
      ld OBJ_POSX(ix),a
      ld a,OBJ_POSX+1(iy)
      ld OBJ_POSX+1(ix),a

      ld a,OBJ_POSY(iy)
      ld OBJ_POSY(ix),a
      ld a,OBJ_POSY+1(iy)
      ld OBJ_POSY+1(ix),a

      ld a,OBJ_SPEEDX(iy)
      ld OBJ_SPEEDX(ix),a
      ld a,OBJ_SPEEDX+1(iy)
      ld OBJ_SPEEDX+1(ix),a

      ld a,OBJ_SPEEDY(iy)
      ld OBJ_SPEEDY(ix),a
      ld a,OBJ_SPEEDY+1(iy)
      ld OBJ_SPEEDY+1(ix),a
      


      //calcula las variables donde se tiene que dibujar el sprite y de paso para restaurar el fondo en el proximo frame
      //call _vtGetGameObjScreenPtr
      //agrega a la lista de sprites para dibujar
      call _vtPushSpriteToDraw


   vtFollowAndDrawObjectFuncEnd:
      ret

   vtFollowAndDrawObjectFuncEndAndDestroy:
      ld OBJ_ACTIVE_TYPE(ix),a      //le pongo el tipo a 0 y no lo pinto
      ret

   __endasm;
}
*/
void vtDrawObjectFunc()  __naked {
   __asm

      ld ix,(#_vtGameObjPtr)
      ld a,OBJ_FLAGS(ix)
      bit 1,a        //compruebo si hay que dibujar el sprite o no
      jr Z,vtDrawObjectFuncEnd      //no hay que dibujar el sprite, asi que nos piramos

      //calcula las variables donde se tiene que dibujar el sprite y de paso para restaurar el fondo en el proximo frame
      call _vtGetGameObjScreenPtr
      //agrega a la lista de sprites para dibujar
      call _vtPushSpriteToDraw

   vtDrawObjectFuncEnd:
      //ld a,OBJ_FLAGS(ix)
      //and #0b11111100
      //ld OBJ_FLAGS(ix),a
      ret

   __endasm;
}













//render turbo sprite (sprites pequeños con byte code sin zone restore)
void vtRenderTS() __naked {
	__asm
         
#ifdef DEBUG_DRAW_SPRITES
         ld	hl, #0x0A10
	      push	hl
	      call	_cpct_setPALColour
#endif


		   ld hl,(#_vtScreenPtr)       //leo el puntero a la pantalla y el puntero al sprite
		   ld de,#NEXT_LINE_ADD_VIDEO_MEM
		   ld bc,#MEMOUT_JUMP_VIDEO_MEM
		   exx


         ld de,(#_vtScreenPtr)       //leo el puntero a la pantalla y el puntero al sprite
         //call _vtTrapDE
         ld hl,(#_vtSpritePtr)
         //push de

         //preparo ixl y ixh con los custom colors
         ld a,(#_vtDrawSpriteCustomColor1)
         .dw 0x6fdd    //ld ixl,a
         and #0b10101010
         .dw 0x6ffd    //ld iyl,a      //en IYL meto solo el pixel izq??

         ld a,(#_vtDrawSpriteCustomColor2)
         .dw 0x67dd    //ld ixh,a
         and #0b10101010
         .dw 0x67fd    //ld iyh,a      //en IYH meto solo el pixel izq??
         
         //dejamos IY para el array de invertidos
         jp vtRTSReadOP    //este salto no hace falta ahora mismo pero hara falta luego



     


      vtRTSOpColorLeft:            //------------------------------------ OP COLOR PIXEL LEFT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         ld b,(hl)
         inc hl
         //and #0b10101010      //limpio el pixel derecho del color
         //ld b,a
         ld a,(vtRenderTSPrepare)
         and #0b01010101      //limpio el pixel izquierdo del prepare
         or b                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSReadOP
         nop
         nop      //esto por kitar el and y el ld b,a
         nop
         nop

      vtRTSOpColorRight:            //------------------------------------ OP COLOR PIXEL RIGHT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         ld b,(hl)
         inc hl
         //and #0b01010101      //limpio el pixel izquierdo del color
         //ld b,a
         ld a,(vtRenderTSPrepare)
         and #0b10101010      //limpio el pixel derecho del prepare
         or b                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSReadOP
         nop
         nop 
         nop 
         nop 




      vtRTSOpCusALeft:            //------------------------------------ OP CUSTOM A PIXEL LEFT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7ddd           //ld a,ixl
         //and #0b10101010      //limpio el pixel derecho del color
         //ld b,a

         .dw 0x45FD             //ld b,iyl     //cargo directamente en B el pixel izq
         ld a,(vtRenderTSPrepare)
         and #0b01010101      //limpio el pixel izquierdo del prepare
         or b                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSReadOP
         nop 
         nop 
         nop 

      vtRTSOpCusARight:            //------------------------------------ OP CUSTOM A PIXEL RIGHT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7ddd           //ld a,ixl
         //and #0b01010101      //limpio el pixel izquierdo del color
         //ld b,a

         .dw 0x45FD             //ld b,iyh     //cargo directamente en B el pixel izq
         rrc b

         ld a,(vtRenderTSPrepare)
         and #0b10101010      //limpio el pixel derecho del prepare
         or b                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSReadOP
         nop 






      vtRTSOpCusBLeft:            //------------------------------------ OP CUSTOM B PIXEL LEFT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7cdd           //ld a,ixh
         //and #0b10101010      //limpio el pixel derecho del color
         //ld b,a

         .dw 0x44FD             //ld b,iyh     //cargo directamente en B el pixel izq
         ld a,(vtRenderTSPrepare)
         and #0b01010101      //limpio el pixel izquierdo del prepare
         or b                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSReadOP
         nop 
         nop 
         nop 


      vtRTSOpCusBRight:            //------------------------------------ OP CUSTOM B PIXEL RIGHT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7cdd           //ld a,ixh
         //and #0b01010101      //limpio el pixel izquierdo del color
         //ld b,a

         .dw 0x44FD             //ld b,iyh     //cargo directamente en B el pixel izq
         rrc b

         ld a,(vtRenderTSPrepare)
         and #0b10101010      //limpio el pixel derecho del prepare
         or b                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSReadOP
         nop 




      vtRTSOpDrawPrepare:            //------------------------------------ OP DRAW BYTE PREPARE ------------------------------
         ld a,(vtRenderTSPrepare)
         ld (de),a
         inc de
         jr vtRTSReadOP

         




      vtRTSReadOP:
         ld a,(hl)      //leo instruccion
         ld (#vtRTSReadOPjtag+1),a     //preparo el salto
         inc hl
      vtRTSReadOPjtag:
         jr #vtRTSOpNextLine                          //ejecuto el salto relativo hacia la instruccion






      /*vtRTSOpNextLine:            //------------------------------------ OP NEXT LINE ------------------------------
         ex de,hl       //ponemos el puntero a la pantalla en HL					//1
         pop hl      //recupero lo que tenia HL para pasar a la siguiente linea		//3
         

         ld a,#8																	//1
         add h																		//1
         ld h,a																		//1

         jr NC,vtRTSOpNextLines2													//3
	      ld bc,#MEMOUT_JUMP_VIDEO_MEM	//ajuste siguiente caracter					//3
	      add hl,bc																	//3
      vtRTSOpNextLines2:
         push hl																	//3
         ex de,hl          //volvemos a poner el puntero a la pantalla en DE		//1			//total 20       
	      jr vtRTSReadOP*/
	      
	      
      vtRTSOpNextLine:
      	exx								//1
      	add hl,de						//3
      	jr NC,vtRTSOpNextLine2		//3
      	
      	add hl,bc						//3
      	
         res 3,h        //pongo el bit 3 a 0 por si al sumarle C050 nos vamos al C8xx ya que si eso ocurre es que nos hemos saltado una linea by the face y no quiero
                        //la forma rapida de corregirlo es que si el bit 3 es 1, lo ponemos a 0 (osea si es C8 lo pasamos a C0) de esta forma nunca nos saltamos la linea

      vtRTSOpNextLine2:
      	push hl							//3
      	exx								//1
      	pop de							//3
		   jr vtRTSReadOP
         nop 
         nop 
         nop 
         nop 
         



      vtRTSOp1skip:            //------------------------------------ OP SKIP 1 BYTE ------------------------------
         inc de
         jr vtRTSReadOP


      vtRTSOp2skip:            //------------------------------------ OP SKIP 2 BYTE ------------------------------
         inc de
         inc de
         jr vtRTSReadOP
      
      vtRTSOp3skip:            //------------------------------------ OP SKIP 3 BYTE ------------------------------
         inc de
         inc de
         inc de
         jr vtRTSReadOP






      vtRTSOp1color:            //------------------------------------ OP COLOR 1 BYTE ------------------------------
         ldi                  //leo un byte de HL y pinto en DE y ademas avanzo los 2, de fasi, tambien baja BC pero me la igual
         jr vtRTSReadOP
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         



      vtRTSOp2color:            //------------------------------------ OP COLOR 2 BYTE ------------------------------
         ldi                  //leo un byte de HL y pinto en DE y ademas avanzo los 2, de fasi, tambien baja BC pero me la igual
         ldi
         jr vtRTSReadOP
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop
         nop 
         nop
      
      vtRTSOp3color:            //------------------------------------ OP COLOR 3 BYTE ------------------------------
         ldi
         ldi
         ldi
         jr vtRTSReadOP
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 



      vtRTSOp1customA:            //------------------------------------ OP CUSTOM A 1 BYTE ------------------------------
         .dw 0x7ddd  //ld a,ixl
         ld (de),a      //pintamos y aumentamos un byte
         inc de
         jr vtRTSReadOP


      vtRTSOp2customA:            //------------------------------------ OP CUSTOM A 2 BYTE ------------------------------
         .dw 0x7ddd  //ld a,ixl
         ld (de),a      //pintamos y aumentamos un byte
         inc de
         ld (de),a      //pintamos y aumentamos un byte
         inc de
         jr vtRTSReadOP

   

      


      vtRTSOp1customB:            //------------------------------------ OP CUSTOM B 1 BYTE ------------------------------
         .dw 0x7cdd  //ld a,ixh
         ld (de),a      //pintamos y aumentamos un byte
         inc de
         jr vtRTSReadOP


      vtRTSOp2customB:            //------------------------------------ OP CUSTOM B 2 BYTE ------------------------------
         .dw 0x7cdd  //ld a,ixh
         ld (de),a      //pintamos y aumentamos un byte
         inc de
         ld (de),a      //pintamos y aumentamos un byte
         inc de
         jr vtRTSReadOP

 



      vtRTSOpReadScreenByte:        //------------------------------------ OP READ SCREEN BYTE ------------------------------
         ld a,(de)
         ld (#vtRenderTSPrepare),a
         jr vtRTSReadOP


      vtRTSOpEnd:       //------------------------------------ OP END SECUENCE GO OUT ------------------------------
         //pop de


#ifdef DEBUG_DRAW_SPRITES
         ld	hl, #0x1410
	      push	hl
	      call	_cpct_setPALColour
#endif

         ret        


      vtRenderTSPrepare:
         .db 0



   __endasm;
}






//igual que arriba pero en modo inverso (OJO!, el puntero a la pantalla debe apuntar al lado derecho en este caso)
void vtRenderTSi() __naked {
	__asm
         
#ifdef DEBUG_DRAW_SPRITES
         ld	hl, #0x1310
	      push	hl
	      call	_cpct_setPALColour
#endif

		   ld hl,(#_vtScreenPtr)       //leo el puntero a la pantalla y el puntero al sprite
		   ld de,#NEXT_LINE_ADD_VIDEO_MEM
		   //ld bc,#MEMOUT_JUMP_VIDEO_MEM      aqui no lo meto porke en B tengo el flip table
         ld bc,#MEMOUT_JUMP_VIDEO_MEM	//ajuste siguiente caracter      	
         
         exx         //vuelvo a la luz y empiezo el mamoneao
         ld b,#FLIP_TABLE_PAGE


         ld de,(#_vtScreenPtr)       //leo el puntero a la pantalla y el puntero al sprite

         //call _vtTrapDE

         ld hl,(#_vtSpritePtr)
         //push de

         //preparo ixl y ixh con los custom colors
         ld a,(#_vtDrawSpriteCustomColor1)
         .dw 0x6fdd    //ld ixl,a
         and #0b10101010
         .dw 0x6ffd    //ld iyl,a      //en IYL meto solo el pixel izq??

         ld a,(#_vtDrawSpriteCustomColor2)
         .dw 0x67dd    //ld ixh,a
         and #0b10101010
         .dw 0x67fd    //ld iyh,a      //en IYH meto solo el pixel izq??

         
         //dejamos IY para el array de invertidos
         jp vtRTSiReadOP    //este salto no hace falta ahora mismo pero hara falta luego





      vtRTSiOpColorLeft:            //------------------------------------ OP COLOR PIXEL LEFT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         ld c,(hl)
         rrc c  //rlc c
         inc hl
         //and #0b01010101      //limpio el pixel derecho del color
         //ld b,a
         ld a,(vtRenderTSPrepare)
         and #0b10101010      //limpio el pixel izquierdo del prepare
         or c                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSiReadOP
         nop 
         nop 
         



      vtRTSiOpColorRight:            //------------------------------------ OP COLOR PIXEL RIGHT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         ld c,(hl)
         rlc c
         inc hl
         //and #0b10101010      //limpio el pixel izquierdo del color
         //ld b,a
         ld a,(vtRenderTSPrepare)
         and #0b01010101      //limpio el pixel derecho del prepare
         or c                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSiReadOP
         nop 
         nop 




      vtRTSiOpCusALeft:            //------------------------------------ OP CUSTOM A PIXEL LEFT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7ddd           //ld a,ixl
         //and #0b01010101      //limpio el pixel derecho del color
         //ld b,a

         .dw 0x4Dfd           //ld c,iyl
         rrc c

         ld a,(vtRenderTSPrepare)
         and #0b10101010      //limpio el pixel izquierdo del prepare
         or c                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSiReadOP
         nop 

      vtRTSiOpCusARight:            //------------------------------------ OP CUSTOM A PIXEL RIGHT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7ddd           //ld a,ixl
         //and #0b10101010      //limpio el pixel izquierdo del color
         //ld b,a

         .dw 0x4Dfd           //ld c,iyl

         ld a,(vtRenderTSPrepare)
         and #0b01010101      //limpio el pixel derecho del prepare
         or c                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSiReadOP
         nop 
         nop 
         nop 





      vtRTSiOpCusBLeft:            //------------------------------------ OP CUSTOM B PIXEL LEFT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7cdd           //ld a,ixh
         //and #0b01010101      //limpio el pixel derecho del color
         //ld b,a

         .dw 0x4Cfd           //ld c,iyh
         rrc c

         ld a,(vtRenderTSPrepare)
         and #0b10101010      //limpio el pixel izquierdo del prepare
         or c                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSiReadOP
         nop 



      vtRTSiOpCusBRight:            //------------------------------------ OP CUSTOM B PIXEL RIGHT ------------------------------
         //ojo, aqui se pilla el pixel izquierdo del valor que toque y aplicamos la mascara del pixel izquierdo y aplicamos al preparado
         //.dw 0x7cdd           //ld a,ixh
         //and #0b10101010      //limpio el pixel izquierdo del color
         //ld b,a

         .dw 0x4Cfd           //ld c,iyh

         ld a,(vtRenderTSPrepare)
         and #0b01010101      //limpio el pixel derecho del prepare
         or c                 //uno los dos
         ld (vtRenderTSPrepare),a      //y guardo
         jr vtRTSiReadOP
         nop 
         nop 
         nop 



      vtRTSiOpDrawPrepare:            //------------------------------------ OP DRAW BYTE PREPARE ------------------------------
         ld a,(vtRenderTSPrepare)
         ld (de),a
         dec de
         jr vtRTSiReadOP

         




      vtRTSiReadOP:
         ld a,(hl)      //leo instruccion
         ld (#vtRTSiReadOPjtag+1),a     //preparo el salto
         inc hl
      vtRTSiReadOPjtag:
         jr #vtRTSiOpNextLine                          //ejecuto el salto relativo hacia la instruccion






      


	   vtRTSiOpNextLine:
      	exx								//1
      	add hl,de						//3
      	jr NC,vtRTSiOpNextLine2			//3
      	//ld bc,#MEMOUT_JUMP_VIDEO_MEM	//ajuste siguiente caracter      	
      	add hl,bc						//3
      	//ld b,#FLIP_TABLE_PAGE			//hay que volver a poner el flip table en BC
         res 3,h        //pongo el bit 3 a 0 por si al sumarle C050 nos vamos al C8xx ya que si eso ocurre es que nos hemos saltado una linea by the face y no quiero
                        //la forma rapida de corregirlo es que si el bit 3 es 1, lo ponemos a 0 (osea si es C8 lo pasamos a C0) de esta forma nunca nos saltamos la linea


      vtRTSiOpNextLine2:
      	push hl							//3
      	exx								//1
      	pop de							//3
		   jr vtRTSiReadOP
         nop
         nop 
         nop 
         nop 






      vtRTSiOp1skip:            //------------------------------------ OP SKIP 1 BYTE ------------------------------
         dec de
         jr vtRTSiReadOP


      vtRTSiOp2skip:            //------------------------------------ OP SKIP 2 BYTE ------------------------------
         dec de
         dec de
         jr vtRTSiReadOP
      
      vtRTSiOp3skip:            //------------------------------------ OP SKIP 3 BYTE ------------------------------
         dec de
         dec de
         dec de
         jr vtRTSiReadOP






      vtRTSiOp1color:            //------------------------------------ OP COLOR 1 BYTE ------------------------------
         ld a,(hl)
         //exx
         ld c,a
         ld a,(bc)      //leo el flipped
         //exx
         ld (de),a
         dec de
         inc hl
         jr vtRTSiReadOP
         nop 
         nop 


      vtRTSiOp2color:            //------------------------------------ OP COLOR 2 BYTE ------------------------------
         ld a,(hl)
         //exx
         ld c,a
         ld a,(bc)      //leo el flipped
         //exx
         ld (de),a
         dec de
         inc hl
         ld a,(hl)
         //exx
         ld c,a
         ld a,(bc)      //leo el flipped
         //exx
         ld (de),a
         dec de
         inc hl
         jr vtRTSiReadOP
         nop 
         nop 
         nop 
         nop 
      
      vtRTSiOp3color:            //------------------------------------ OP COLOR 3 BYTE ------------------------------
         ld a,(hl)
         //exx
         ld c,a
         ld a,(bc)      //leo el flipped
         //exx
         ld (de),a
         dec de
         inc hl
         ld a,(hl)
         //exx
         ld c,a
         ld a,(bc)      //leo el flipped
         //exx
         ld (de),a
         dec de
         inc hl
         ld a,(hl)
         //exx
         ld c,a
         ld a,(bc)      //leo el flipped
         //exx
         ld (de),a
         dec de
         inc hl
         jr vtRTSiReadOP
         nop 
         nop 
         nop 
         nop 
         nop 
         nop 


      vtRTSiOp1customA:            //------------------------------------ OP CUSTOM A 1 BYTE ------------------------------
         .dw 0x7ddd  //ld a,ixl
         ld (de),a      //pintamos y aumentamos un byte
         dec de
         jr vtRTSiReadOP


      vtRTSiOp2customA:            //------------------------------------ OP CUSTOM A 2 BYTE ------------------------------
         .dw 0x7ddd  //ld a,ixl
         ld (de),a      //pintamos y aumentamos un byte
         dec de
         ld (de),a      //pintamos y aumentamos un byte
         dec de
         jr vtRTSiReadOP

      


      vtRTSiOp1customB:            //------------------------------------ OP CUSTOM B 1 BYTE ------------------------------
         .dw 0x7cdd  //ld a,ixh
         ld (de),a      //pintamos y aumentamos un byte
         dec de
         jr vtRTSiReadOP


      vtRTSiOp2customB:            //------------------------------------ OP CUSTOM B 2 BYTE ------------------------------
         .dw 0x7cdd  //ld a,ixh
         ld (de),a      //pintamos y aumentamos un byte
         dec de
         ld (de),a      //pintamos y aumentamos un byte
         dec de
         jr vtRTSiReadOP


      vtRTSiOpReadScreenByte:        //------------------------------------ OP READ SCREEN BYTE ------------------------------
         ld a,(de)
         ld (#vtRenderTSPrepare),a
         jr vtRTSiReadOP


      vtRTSiOpEnd:       //------------------------------------ OP END SECUENCE GO OUT ------------------------------
         //pop de



#ifdef DEBUG_DRAW_SPRITES
         ld	hl, #0x1410
	      push	hl
	      call	_cpct_setPALColour
#endif


         ret       

   __endasm;
}





void vtMoveScrollHorizontalIzq() __naked {
	__asm
      //este primer bloque ajusta el limite para el vtPrepareRestoreBackground para el limite derecho (ya que cuando hace scroll es 39 y cuando no lo hace es 40) sino se quedan glitches
      ld hl,#vtPrepareRestoreBackgroundTopeHor+1
      ld (hl),#39

      ld	a, (#_vtSceneScrollXto)
      ld b,a
      ld	a, (#_vtSceneScrollX)
      sub b
      jr NZ,vtMoveScrollHorizontalIzqs1      //se va a mover el scroll horizontal con lo cual dejamos el limite a 39

      ld	a, (#_vtSceneScrollYto)
      ld b,a
      ld	a, (#_vtSceneScrollY)
      sub b
      jr NZ,vtMoveScrollHorizontalIzqs1      //se va a mover el scroll vertical con lo cual dejamos el limite a 40      

      ld (hl),#40       //si no vamos a mover el scroll ni vertical ni horizontal podemos ampliar a 40 el limite para que no se queden cosillas en el borde



      //y ya seguimos comprobando si hay que hacer scrolling
   vtMoveScrollHorizontalIzqs1:
      //;src/armony.h:5055: vtScrollHorizontalMoving=0;	//a priori consideramos que el scroll horizontal no se ha movido
      xor a
      ld	(#_vtScrollHorizontalMoving),a
      

      //;src/armony.h:5060: if(vtSceneScrollXto<vtSceneScrollX)
      ld	hl, #_vtSceneScrollX
      ld	a,(#_vtSceneScrollXto)
      sub a, (hl)
      ret NC      //si no vtSceneScrollXto<vtSceneScrollX entonces no hay que hacer scroll ni ná, asi que pa fuera


   


      //;src/armony.h:5062: if(vtScrollTurbo!=0)
      ld	a,(#_vtScrollTurbo)
      or	a, a
      jr	Z,vtMoveScrollHorizontalIzqLento  //00113$


      
               
            

      //;src/armony.h:5064: vtPushTilesIniX=0;         //SCROLADA RAPIDA-----------------------
      xor a
      ld	hl,#_vtPushTilesIniX
      ld	(hl), a

      //;src/armony.h:5065: vtPushTilesEndX=1;
      ld	hl,#_vtPushTilesEndX
      inc a
      ld	(hl), a


      //;src/armony.h:5067: vtScrollCRTC3=245;
      ld	hl,#_vtScrollCRTC3
      ld	(hl), #0xf5


      //;src/armony.h:5068: vtVidMemStart=(u8*)(((u16)(vtVidMemStart-2))%2048);
      ld	hl,(#_vtVidMemStart)
      dec hl 
      dec hl
      ld	a, #0x07
      and h
      ld	h,a
      ld	(_vtVidMemStart), hl

      
      //;src/armony.h:5069: if(vtScrollOffset==0)
      ld	a,(#_vtScrollOffset)
      or	a, a
      jr	NZ,vtMoveScrollHorizontalIzqs2         //00102$
      

      //;src/armony.h:5071: vtScrollPage=(vtScrollPage-1);
      ld	hl,#_vtScrollPage
      dec (hl)


   vtMoveScrollHorizontalIzqs2:      //00102$:
      //;src/armony.h:5073: vtScrollOffset=vtScrollOffset-1;
      dec a
      ld	(#_vtScrollOffset),a
      

      //;src/armony.h:5074: vtSceneScrollX=vtSceneScrollX-1;
      ld	hl,#_vtSceneScrollX
      dec (hl)
      


      jp	vtMoveScrollHorizontalIzqs10     //00114$



               
               

   vtMoveScrollHorizontalIzqLento:     //00113$:
      //;src/armony.h:5076: if((vtSceneScrollXto + FAST_SCROLL_DISTANCE_X) < vtSceneScrollX  && vtSceneScrollYto==vtSceneScrollY )
      //primero miro vtSceneScrollYto==vtSceneScrollY
      ld	hl, #_vtScrollCRTC3

      ld a,(#_vtSceneScrollYto)
      ld b,a
      ld a,(#_vtSceneScrollY)
      sub b
      jp NZ,vtMoveScrollHorizontalIzqLentos4    //00104$

      ld a,(#_vtSceneScrollX)
      ld b,a

      ld a,(#_vtSceneScrollXto)
      
      add #FAST_SCROLL_DISTANCE_X
      sub b
      
      jr NC,vtMoveScrollHorizontalIzqLentos4    //00104$

      //;src/armony.h:5079: vtScrollCRTC3=vtScrollCRTC3-2;      //solo muevo rapido si no tiene que hacer scroll vertical
      dec (hl)
      dec (hl)
      jr	vtMoveScrollHorizontalIzqLentos6    //00105$

   vtMoveScrollHorizontalIzqLentos4:      //00104$:
      //;src/armony.h:5081: vtScrollCRTC3=vtScrollCRTC3-1;      //si esta cerca o hay scroll vertical vamos despacio
      dec	(hl)


   vtMoveScrollHorizontalIzqLentos6:      //00105$:
      //;src/armony.h:5084: if(vtScrollCRTC3<245)
      ld a,#244
      sub (hl)
      jr C,vtMoveScrollHorizontalIzqLentos8    //00110$
      
      //;src/armony.h:5086: vtScrollCRTC3=vtScrollCRTC3+2;
      inc (hl)
      inc (hl)
      
      //;src/armony.h:5087: vtVidMemStart=(u8*)(((u16)(vtVidMemStart-2))%2048);
      ld	hl,(#_vtVidMemStart)
      dec hl 
      dec hl
      ld	a, #0x07
      and h
      ld	h,a
      ld	(_vtVidMemStart), hl

      //;src/armony.h:5089: if(vtScrollOffset==0)
      ld	a,(#_vtScrollOffset)
      or	a, a
      jr	NZ,vtMoveScrollHorizontalIzqLentos7      //00108$

      //;src/armony.h:5091: vtScrollPage=(vtScrollPage-1);
      ld	hl,#_vtScrollPage
      dec (hl)

   vtMoveScrollHorizontalIzqLentos7:      //00108$:
      //;src/armony.h:5093: vtScrollOffset=vtScrollOffset-1;
      ld	hl,#_vtScrollOffset
      dec (hl)
      //;src/armony.h:5094: vtSceneScrollX=vtSceneScrollX-1;
      ld hl,#_vtSceneScrollX
      dec (hl)
      
      //;src/armony.h:5095: vtPushTilesIniX=0;
      xor a
      ld	hl,#_vtPushTilesIniX
      ld	(hl), a

      //;src/armony.h:5096: vtPushTilesEndX=2;
      inc a
      inc a
      ld	hl,#_vtPushTilesEndX
      ld	(hl), a

      //;src/armony.h:5097: vtScrollHorizontalMoving=2;	//se ha movido con cambio de video
      ld	hl,#_vtScrollHorizontalMoving
      ld	(hl),a
      jr	vtMoveScrollHorizontalIzqs10        //00114$

      


   vtMoveScrollHorizontalIzqLentos8:         //00110$:
      //;src/armony.h:5099: vtPushTilesIniX=0;
      xor a
      ld	hl,#_vtPushTilesIniX
      ld	(hl), a
      //;src/armony.h:5100: vtPushTilesEndX=1;
      inc a
      ld	hl,#_vtPushTilesEndX
      ld	(hl), a
      //;src/armony.h:5101: vtScrollHorizontalMoving=1;	//se ha movido sin cambio de video
      ld	hl,#_vtScrollHorizontalMoving
      ld	(hl), a




   vtMoveScrollHorizontalIzqs10:       //00114$:
      //;src/armony.h:5104: vtPushTilesIniY=0;
      xor a
      ld	hl,#_vtPushTilesIniY
      ld	(hl), a
      
      //;src/armony.h:5105: vtPushTilesEndY=25;
      ld	hl,#_vtPushTilesEndY
      ld	(hl), #0x19
      
      //;src/armony.h:5106: vtPushTilesToDraw();
      call	_vtPushTilesToDrawColumn

      //antes de pirarnos, ajustamos la funcion para restaurar el background ya que los OBJ_REDRAWX y OBJ_REDRAWY estan con las coordenadas antiguas del scroll
      //con estos pekeños ajustes metemos un inc o un dec para hacer el reajuste si es que hemos movido el scroll
      //ld a,#0x3C //esto es un INC A
      //ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLX),a       //pongo un NOP aqui
      //ld (#_vtPrepareRestoreBackgroundREAJUSTESCROLLY),a       //pongo un NOP aqui

      ret


   __endasm;
}



void vtMoveScrollHorizontalDer() __naked {
	__asm
   
      //;src/armony.h:5322: if(vtSceneScrollXto>vtSceneScrollX)
      xor a
      ld (#vtPrepareRestoreBackgrounds1a),a    //aplico el NOP

      ld a,(#_vtSceneScrollXto)
      ld b,a
      ld	a, (#_vtSceneScrollX)
      sub b
      ret NC
      
      //ahora que se que voy a scrolear a la izq, no restauro a partir del 0 sino del 1 en el pushtilestodraw
      ld a,#0x3C   //INC A
      ld (#vtPrepareRestoreBackgrounds1a),a    //aplico el INC A

      
      //;src/armony.h:5324: if(vtScrollTurbo!=0)
      ld	a,(#_vtScrollTurbo)
      or	a, a
      jr	Z,vtMoveScrollHorizontalDerNoTurbo        //00113$




      //;src/armony.h:5326: vtPushTilesIniX=39;        //SCROLADA RAPIDA-----------------------
      ld a,#39
      ld	hl,#_vtPushTilesIniX
      ld	(hl), a
      //;src/armony.h:5327: vtPushTilesEndX=40;
      inc a
      ld	hl,#_vtPushTilesEndX
      ld	(hl), a
      //;src/armony.h:5328: vtScrollHorizontalMoving=1;	//se ha movido sin cambio de video
      ld	hl,#_vtScrollHorizontalMoving
      ld	(hl), #0x01
      //;src/armony.h:5329: vtScrollCRTC3=245;
      ld	hl,#_vtScrollCRTC3
      ld	(hl), #0xf5


      //;src/armony.h:5330: vtVidMemStart=(u8*)(((u16)(vtVidMemStart+2))%2048);
      ld hl,(#_vtVidMemStart)
      inc hl
      inc hl
      ld a,#7
      and h
      ld h,a
      ld	(_vtVidMemStart), hl
      

      //;src/armony.h:5331: if(vtScrollOffset==255)
      ld	a,(#_vtScrollOffset)
      cp #255
      jr	NZ,vtMoveScrollHorizontalDers4    //00102$

      //;src/armony.h:5333: vtScrollPage=(vtScrollPage+1);
      ld	hl,#_vtScrollPage
      inc (hl)

   vtMoveScrollHorizontalDers4:        //00102$:
      //;src/armony.h:5335: vtScrollOffset=vtScrollOffset+1;
      ld hl,#_vtScrollOffset
      inc (hl)
      
      //;src/armony.h:5336: vtSceneScrollX=vtSceneScrollX+1; 
      ld	hl,#_vtSceneScrollX
      inc (hl)
      jp	vtMoveScrollHorizontalDers12        //00114$



               


                                 //SCROLADA NORMAL-----------------------
   vtMoveScrollHorizontalDerNoTurbo:         //00113$:

      //;src/armony.h:5338: if(vtSceneScrollXto > vtSceneScrollX  + FAST_SCROLL_DISTANCE_X   && vtSceneScrollYto==vtSceneScrollY)
      ld a,(#_vtSceneScrollYto)
      ld hl,#_vtSceneScrollY
      sub (hl)
      jr NZ,vtMoveScrollHorizontalDers6         //00104$

      ld a,(#_vtSceneScrollX)
      add #FAST_SCROLL_DISTANCE_X
      ld hl,#_vtSceneScrollXto
      sub (hl)
      jr NC,vtMoveScrollHorizontalDers6         //00104$

      //;src/armony.h:5341: vtScrollCRTC3=vtScrollCRTC3+2;
      ld	hl, #_vtScrollCRTC3
      inc (hl)
      inc (hl)
      jr	vtMoveScrollHorizontalDers8         //00105$

   vtMoveScrollHorizontalDers6:            //00104$:
      //;src/armony.h:5343: vtScrollCRTC3=vtScrollCRTC3+1;
      ld	hl, #_vtScrollCRTC3
      inc (hl)



   vtMoveScrollHorizontalDers8:           //00105$:
      //;src/armony.h:5347: if(vtScrollCRTC3>246)
      ld	a, #0xf6
      ld	hl, #_vtScrollCRTC3
      sub (hl)
      jr	NC,vtMoveScrollHorizontalDers11        //00110$
      //;src/armony.h:5349: vtScrollCRTC3=vtScrollCRTC3-2;
      dec (hl)
      dec (hl)

      //;src/armony.h:5350: vtVidMemStart=(u8*)(((u16)(vtVidMemStart+2))%2048);
      ld hl,(#_vtVidMemStart)
      inc hl
      inc hl
      ld a,#7
      and h
      ld h,a
      ld	(_vtVidMemStart), hl


      //;src/armony.h:5351: if(vtScrollOffset==255)
      ld	a, (#_vtScrollOffset)
      cp #255
      jr	NZ,vtMoveScrollHorizontalDers10        //00108$

      //;src/armony.h:5353: vtScrollPage=(vtScrollPage+1);
      ld	hl,#_vtScrollPage
      inc (hl)


   vtMoveScrollHorizontalDers10:             //00108$:
      //;src/armony.h:5355: vtScrollOffset=vtScrollOffset+1;
      ld	hl,#_vtScrollOffset
      inc (hl)

      //;src/armony.h:5356: vtSceneScrollX=vtSceneScrollX+1; 
      ld	hl,#_vtSceneScrollX
      inc (hl)

      //;src/armony.h:5357: vtPushTilesIniX=38;
      ld a,#38
      ld	(#_vtPushTilesIniX),a
      
      //;src/armony.h:5358: vtPushTilesEndX=40;
      inc a 
      inc a
      ld	(#_vtPushTilesEndX),a
      

      //;src/armony.h:5359: vtScrollHorizontalMoving=2;	//se ha movido con cambio de video
      ld	hl,#_vtScrollHorizontalMoving
      ld	(hl), #0x02
      jr	vtMoveScrollHorizontalDers12           //00114$

   vtMoveScrollHorizontalDers11:                //00110$:
      //;src/armony.h:5361: vtPushTilesIniX=39;
      ld a,#39
      ld	(#_vtPushTilesIniX),a
      
      //;src/armony.h:5362: vtPushTilesEndX=40;
      inc a
      ld	(#_vtPushTilesEndX),a
      
      //;src/armony.h:5363: vtScrollHorizontalMoving=1;	//se ha movido sin cambio de video
      ld	hl,#_vtScrollHorizontalMoving
      ld	(hl), #0x01


   vtMoveScrollHorizontalDers12:              //00114$:
      
      //;src/armony.h:5366: vtPushTilesIniY=0;
      xor a
      ld	(#_vtPushTilesIniY),a
      
      //;src/armony.h:5367: vtPushTilesEndY=24;
      ld	hl,#_vtPushTilesEndY
      ld	(hl), #0x18
      //;src/armony.h:5368: dibujaEsquina=1;
      inc a
      ld	(#_dibujaEsquina),a     //1
      

      //;src/armony.h:5369: if(vtSceneScrollX==27)
      //ld	a,(#_vtSceneScrollX + 0)
      //sub a, #0x1b
      //ret NZ
      //jr	NZ,00116$

      //;src/armony.h:5371: debug2();
      //call	_debug2
      //00116$:
      //;src/armony.h:5373: vtPushTilesToDraw();
      call	_vtPushTilesToDrawColumn   

      //antes de pirarnos, ajustamos la funcion para restaurar el background ya que los OBJ_REDRAWX y OBJ_REDRAWY estan con las coordenadas antiguas del scroll
      //con estos pekeños ajustes metemos un inc o un dec para hacer el reajuste si es que hemos movido el scroll
      //ld a,#0x3D //esto es un DEC A
      //ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLX),a       //pongo un NOP aqui
      //ld (#_vtPrepareRestoreBackgroundREAJUSTESCROLLY),a       //pongo un NOP aqui

      ret
   __endasm;
}




void vtMoveScrollVerticalAba() __naked {
	__asm
   
      //;src/armony.h:5582: if(vtSceneScrollYto>vtSceneScrollY)
      ld	a, (#_vtSceneScrollY)
      ld	hl, #_vtSceneScrollYto
      sub (hl)
      ret NC

      //;src/armony.h:5584: vtScrollCRTC5old=vtScrollCRTC5;
      ld	a,(#_vtScrollCRTC5)
      ld	(#_vtScrollCRTC5old),a


      //;src/armony.h:5586: if(vtSceneScrollYto > (vtSceneScrollY + FAST_SCROLL_DISTANCE_Y) && vtScrollHorizontalMoving==0)
      ld a,(#_vtScrollHorizontalMoving)
      or a
      jr NZ,vtMoveScrollVerticalAbas2        //00102$

      ld	a,(#_vtSceneScrollY)
      add #FAST_SCROLL_DISTANCE_Y
      ld	hl, #_vtSceneScrollYto
      sub (hl)
      jr NC,vtMoveScrollVerticalAbas2        //00102$

      //;src/armony.h:5588: vtScrollCRTC5=vtScrollCRTC5-8;	//scroll rapido
      ld	hl, #_vtScrollCRTC5
      ld	a, (hl)
      add a, #0xf8
      ld	(hl), a
      jr	vtMoveScrollVerticalAbas4           //00103$

   vtMoveScrollVerticalAbas2:          //00102$:
      //;src/armony.h:5590: vtScrollCRTC5=vtScrollCRTC5-4;	//scroll normal
      ld	hl, #_vtScrollCRTC5
      ld	a, (hl)
      add a, #0xfc
      ld	(hl), a

   vtMoveScrollVerticalAbas4:             //00103$:
      //;src/armony.h:5593: if(vtScrollCRTC5>247)
      ld	a, #0xf7
      ld	hl, #_vtScrollCRTC5
      sub (hl)
      ret NC

      //;src/armony.h:5595: if(vtScrollHorizontalMoving==2)
      ld	a,(#_vtScrollHorizontalMoving)
      sub #0x02
      jr	NZ,vtMoveScrollVerticalAbas6           //00108$

      //;src/armony.h:5597: vtScrollCRTC5=vtScrollCRTC5old;  //bloqueo el scroll porque ya se movio horizontalmente un tile asi que no quiero moverlo tambien en vertical porque es mucha carga
      ld	a,(#_vtScrollCRTC5old)
      ld	(#_vtScrollCRTC5),a
      ret


   vtMoveScrollVerticalAbas6:                //00108$:
      //;src/armony.h:5599: vtScrollCRTC5=vtScrollCRTC5+8;
      ld	hl, #_vtScrollCRTC5
      ld	a, (hl)
      add #0x08
      ld	(hl), a

      //;src/armony.h:5600: vtVidMemStart=(u8*)(((u16)(vtVidMemStart+80))%2048);
      ld hl,(_vtVidMemStart)
      ld	de,#0x0050
      add hl,de
      ld a,#7
      and h
      ld h,a
      ld	(_vtVidMemStart), hl

      //;src/armony.h:5601: if(vtScrollOffset>215)
      ld	a, #0xd7
      ld	hl, #_vtScrollOffset
      sub (hl)
      jr	NC,vtMoveScrollVerticalAbas8                 //00106$
      
      //;src/armony.h:5603: vtScrollPage=(vtScrollPage+1);
      ld	hl, #_vtScrollPage
      inc (hl)


   vtMoveScrollVerticalAbas8:                //00106$:
      //;src/armony.h:5606: vtScrollOffset=vtScrollOffset+40;
      ld	hl, #_vtScrollOffset
      ld	a,(hl)
      add #0x28
      ld	(hl), a

      //;src/armony.h:5607: vtSceneScrollY=vtSceneScrollY+1;
      ld	hl, #_vtSceneScrollY
      inc (hl)

      //;src/armony.h:5608: vtPushTilesIniX=0;
      xor a
      ld	(#_vtPushTilesIniX),a

      //;src/armony.h:5609: vtPushTilesIniY=24;
      ld a,#24
      ld	(#_vtPushTilesIniY),a
      //;src/armony.h:5611: vtPushTilesEndY=25;
      inc a
      ld	(#_vtPushTilesEndY),a

      //;src/armony.h:5610: vtPushTilesEndX=40;
      ld	hl,#_vtPushTilesEndX
      ld	(hl),#0x28

      //;src/armony.h:5612: vtPushTilesToDraw();
      call  _vtPushTilesToDraw

      //antes de pirarnos, ajustamos la funcion para restaurar el background ya que los OBJ_REDRAWX y OBJ_REDRAWY estan con las coordenadas antiguas del scroll
      //con estos pekeños ajustes metemos un inc o un dec para hacer el reajuste si es que hemos movido el scroll
      //ld a,#0x3D //esto es un DEC A
      //ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLX),a       //pongo un NOP aqui
      //ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLY),a       //pongo un NOP aqui

      ret

   __endasm;
}





void vtMoveScrollVerticalArr() __naked {
	__asm
      //;src/armony.h:5622: if(vtSceneScrollYto<vtSceneScrollY)
      ld	hl, #_vtSceneScrollY
      ld	a,(#_vtSceneScrollYto)
      sub (hl)
      jp NC,vtMoveScrollVerticalArrs10
      

      //;src/armony.h:5624: vtScrollCRTC5old=vtScrollCRTC5;
      ld	a,(#_vtScrollCRTC5)
      ld	(#_vtScrollCRTC5old),a

      //;src/armony.h:5626: if( (vtSceneScrollYto + FAST_SCROLL_DISTANCE_Y) < vtSceneScrollY  && vtScrollHorizontalMoving==0) 
      ld a,(#_vtScrollHorizontalMoving)
      or a
      jr NZ,vtMoveScrollVerticalArrs2        //00102$

      ld	a,(#_vtSceneScrollYto)
      add #FAST_SCROLL_DISTANCE_Y
      ld	hl, #_vtSceneScrollY
      sub (hl)
      jr nc,vtMoveScrollVerticalArrs2        //00102$

      //;src/armony.h:5628: vtScrollCRTC5=vtScrollCRTC5+8;	//scroll rapido
      ld	hl, #_vtScrollCRTC5
      ld	a, (hl)
      add #0x08
      ld	(hl), a
      jr	vtMoveScrollVerticalArrs4        //00103$

   vtMoveScrollVerticalArrs2:       //00102$:
      //;src/armony.h:5630: vtScrollCRTC5=vtScrollCRTC5+4;	//scroll lento
      ld	hl, #_vtScrollCRTC5
      inc (hl)
      inc (hl)
      inc (hl)
      inc (hl)



   vtMoveScrollVerticalArrs4:       //00103$:
      //;src/armony.h:5633: if(vtScrollCRTC5>7)
      ld	a, #0x07
      ld	hl, #_vtScrollCRTC5
      sub (hl)
      jr	NC,vtMoveScrollVerticalArrs10          //00113$

      //;src/armony.h:5635: if(vtScrollHorizontalMoving==2)
      ld	a,(#_vtScrollHorizontalMoving + 0)
      sub #0x02
      jr	NZ,vtMoveScrollVerticalArrs6        //00108$

      //;src/armony.h:5637: vtScrollCRTC5=vtScrollCRTC5old;  //bloqueo el scroll porque ya se movio horizontalmente un tile asi que no quiero moverlo tambien en vertical porque es mucha carga
      ld	a,(#_vtScrollCRTC5old)
      ld	(#_vtScrollCRTC5),a
      jr	vtMoveScrollVerticalArrs10       //00113$

   vtMoveScrollVerticalArrs6:          //00108$:
      //;src/armony.h:5640: vtScrollCRTC5=vtScrollCRTC5-8;
      ld	hl, #_vtScrollCRTC5
      ld	a, (hl)
      add #0xf8
      ld	(hl), a


      //;src/armony.h:5642: vtVidMemStart=(u8*)(((u16)(vtVidMemStart-80))%2048);
      ld	hl, (#_vtVidMemStart)
      ld de,#0xFFB0        //-80
      add hl,de
      ld a,#7
      and h
      ld h,a
      ld	(#_vtVidMemStart), hl

      //;src/armony.h:5644: if(vtScrollOffset<40)
      ld	a,(#_vtScrollOffset)
      sub #40
      jr	NC,vtMoveScrollVerticalArrs8           //00106$

      //;src/armony.h:5646: vtScrollPage=(vtScrollPage-1);
      ld	hl,#_vtScrollPage
      dec (hl)


   vtMoveScrollVerticalArrs8:       //00106$:
      //;src/armony.h:5648: vtScrollOffset=vtScrollOffset-40;
      ld	hl, #_vtScrollOffset
      ld	a, (hl)
      add a, #0xd8         //-40
      ld	(hl), a

      //;src/armony.h:5649: vtSceneScrollY=vtSceneScrollY-1;
      ld	hl, #_vtSceneScrollY
      dec (hl)


      //;src/armony.h:5650: vtPushTilesIniX=0;
      xor a
      ld	(#_vtPushTilesIniX),a
      
      //;src/armony.h:5651: vtPushTilesIniY=0;
      ld	(#_vtPushTilesIniY),a
      
      //;src/armony.h:5653: vtPushTilesEndY=1;
      inc a
      ld	(#_vtPushTilesEndY),a

      //;src/armony.h:5652: vtPushTilesEndX=40;
      ld	hl,#_vtPushTilesEndX
      ld	(hl), #0x28

      //;src/armony.h:5656: vtPushTilesToDraw();
      call	_vtPushTilesToDraw

      
      //;src/armony.h:5657: dibujaEsquina=0;
      xor a
      ld	(#_dibujaEsquina),a



   vtMoveScrollVerticalArrs10:      //00113$:
      //;src/armony.h:5662: if(dibujaEsquina!=0)
      ld	a,(#_dibujaEsquina)
      or	a, a
      ret Z
      
      //;src/armony.h:5664: vtPushTilesIniX=38;
      ld	hl,#_vtPushTilesIniX + 0
      ld	(hl), #0x26
      //;src/armony.h:5665: vtPushTilesEndX=40;
      ld	hl,#_vtPushTilesEndX + 0
      ld	(hl), #0x28

      //;src/armony.h:5666: vtPushTilesIniY=24;
      ld a,#24
      ld	(#_vtPushTilesIniY),a
      
      //;src/armony.h:5667: vtPushTilesEndY=25;
      inc a
      ld	(#_vtPushTilesEndY),a

      //;src/armony.h:5668: vtPushTilesToDraw();
      call	_vtPushTilesToDraw

      //;src/armony.h:5669: dibujaEsquina=0;
      xor a
      ld	(#_dibujaEsquina),a

      //antes de pirarnos, ajustamos la funcion para restaurar el background ya que los OBJ_REDRAWX y OBJ_REDRAWY estan con las coordenadas antiguas del scroll
      //con estos pekeños ajustes metemos un inc o un dec para hacer el reajuste si es que hemos movido el scroll
      //ld a,#0x3C //esto es un INC A
      //ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLX),a       //pongo un NOP aqui
      //ld (#vtPrepareRestoreBackgroundREAJUSTESCROLLY),a       //pongo un NOP aqui

      ret
   __endasm;
}







//entrada: BC diferencia horizontal, 
//         DE diferencia vertical
//salida:  HL distancia entre punto 0,0 y punto BC,DE
//OJO!!! esta funcion va a hacer los calculos como si fuera i16
void vtDistance16() __naked {
	__asm
         //lo primero hay que poner los dos numeros en positivo
         bit 7,b
         jr Z,vtFastDistance16bs1

         //si entra aqui BC es negativo, lo paso a positivo
         ld hl,#0
         xor a
         sbc hl,bc
         ld b,h
         ld c,l

      vtFastDistance16bs1:
         bit 7,d
         jr Z,vtFastDistance16bs2

         //si entra aqui BC es negativo, lo paso a positivo
         ld hl,#0
         xor a
         sbc hl,de
         ld d,h
         ld e,l

      vtFastDistance16bs2:
         //aqui ya tengo BC y DE en positivo, ahora quiero ver cual es mayor de los dos por si los tengo que intercambiar o no
         ld h,b
         ld l,c
         xor a
         sbc hl,de
         jr NC,vtFastDistance16bs3     //si no hay carry HL es > DE
         ld h,b            // si no DE > HL, vuelvo a cargar HL e intercambio
         ld l,c
         ex de,hl       
         jp vtFastDistance16bs4

      vtFastDistance16bs3:
         ld h,b      //vuelvo a cargar HL
         ld l,c

      vtFastDistance16bs4:
         //ahora tengo en DE y en HL los dos y en positivo  (HL es más grande)
         //dx = abs(x1 - x0)   <--- DE   despues de pasarlo a positivo
         //dy = abs(y1 - y0)   <--- HL   despues de pasarlo a positivo

         //ahora hago esta operacion HL es max(dx, dy)
         //dist = 0.5 * (dx + dy + max(dx, dy))
         add hl,hl      //dy + max(dx, dy)
         add hl,de      //dx + dy + max(dx, dy)
         sra h          //divido entre 2 que es lo mismo que multiplicar por 0.5
         rr l           //0.5 * (dx + dy + max(dx, dy))

         ret
   __endasm;
}



/*
//en C tenemos horizontal, y E vertical y devuelve en HL la distancia (normalmente con L valdrá para la distancia pero si se pasa está H)
void vtDistance8() __naked {
	__asm
         //dx = abs(x1 - x0)   <--- DE   despues de pasarlo a positivo
         //dy = abs(y1 - y0)   <--- HL   despues de pasarlo a positivo

         //ahora hago esta operacion HL es max(dx, dy)
         //dist = 0.5 * (dx + dy + max(dx, dy))
         bit 7,c
         jr Z,vtDistance8s1
         xor a
         sub c
         ld c,a
      
      vtDistance8s1:
         bit 7,e
         jr Z,vtDistance8s2
         xor a
         sub e
         ld e,a

      vtDistance8s2:
         ld a,c
         cp e
         jr NC,vtDistance8s3     //si no hay carry C > E
         
         //sino C > B y los intercambiamos
         ld e,c      //intercambiamos los valores
         ld c,a
      
      vtDistance8s3:
         ld hl,#0
         ld d,#0
         ld b,#0
         add hl,bc
         add hl,bc
         add hl,de

         sra h
         rr l

         ret
   __endasm;
}
*/



//esta funcion es la misma que vtAtan2 pero usando dos valores de 16 bits en vez de 2 de 8 bits
//la entrada es X=BC e Y=DE, y en A devuelve el angulo (256 based)
void vtAtan2_16()  __naked {
   __asm
         //necesito reducir a 7 bits los dos valores ya sean negativos o positivos no quiero que pasen de -127 a 127 para despues llamar al atan2
         //lo que vamos a hacer es rotaciones a la derecha hasta que tengan un valor aceptable

         
   xor a                   //este cachito de codigo es para que no haga un bucle infinito, basicamente lo que intento es que la diferencia no sea 0 ni en hor ni ver porke se lia parda
   or c
   jr NZ,vtAtan2_16a
   inc c
vtAtan2_16a:
   xor a
   or e
   jr NZ,vtAtan2_16b
   inc e
vtAtan2_16b:


      ld (vtAtan2_16saveX),bc
      ld (vtAtan2_16saveY),de

      bit 7,b
      jr Z,vtAtan2_16s2
      //si es negativo, lo pasamos a positivo
      xor a       //limpio el carry
      ld hl,#0
      sbc hl,bc
      ld b,h
      ld c,l         //BC a positivo

   vtAtan2_16s2:
      bit 7,d
      jr Z,vtAtan2_16s3
      //si es negativo, lo pasamos a positivo
      xor a       //limpio el carry
      ld hl,#0
      sbc hl,de
      ex de,hl       //DE a positivo

   vtAtan2_16s3:
      //aqui ya tengo tanto BC como DE en positivo, puedo hacer las rotaciones necesarias más rapido


   vtAtan2_16s4:
      ld a,b
      or d          //sigo dando vueltas hasta que B+D=0
      jr Z,vtAtan2_16s6     //si B xor D es cero ya tenemos lo que queremos, nos vamos
      
      //si tengo un numero muy alto o muy bajo hago una division entre 2 de BC y DE hasta que tenga lo que quiero para poder calcular el angulo
      sra b    //divido entre 2 (positivo y negativo, da igual)
      rr c
      sra d
      rr e
      jr vtAtan2_16s4


   vtAtan2_16s6:
      //cuando llegue aqui ya B y D son cero, asi que me puedo centrar en C y E
      bit 7,c
      jr Z,vtAtan2_16s8
      //si el bit 7 de C no es cero, tengo que rotar C y E
      srl c
      srl e
      jr vtAtan2_16s10

   vtAtan2_16s8:
      bit 7,e
      jr Z,vtAtan2_16s10
      //si el bit 7 de E no es cero, tengo que rotar C y E
      srl c
      srl e

   vtAtan2_16s10:
      //cuando llegue aqui estoy 100% seguro que C y E son menores de 128, ya solo tengo que ajustar su signo y llamar a atan2
      ld a,(vtAtan2_16saveX+1)
      bit 7,a
      jr Z,vtAtan2_16s12
      ld a,c
      neg
      ld c,a

   vtAtan2_16s12:
      ld a,(vtAtan2_16saveY+1)
      bit 7,a
      jr Z,vtAtan2_16s14
      ld a,e
      neg
      ld e,a

   vtAtan2_16s14:
      ld b,c
      ld c,e
      jp _vtAtan2

   vtAtan2_16saveX:
      .dw 0
   vtAtan2_16saveY:
      .dw 0

   __endasm;
}



//entra en BC x e y (en i8) y devuelve en A la dirección (256 based)
//B = x, C = y
void vtAtan2() __naked {
   __asm
// 8-bit atan2
// Calculate the angle, in a 256-degree circle.
// The trick is to use logarithmic division to get the y/x ratio and
// integrate the power function into the atan table. 

//	input
// 	B = x, C = y	in -128,127

//  output
//	A = angle		in 0-255

//      |
//  q1  |  q0
//------+-------
//  q3  |  q2
//      |
		
   

	atan2init:	
		ld de,#0x8000		//inicia variables
		
		ld a,c
		add a,d
		rl e				// y-	//calcula -y? no se
		
		ld	a,b
		add	a,d
		rl	e				// x-	//calcula -x? ni puta idea
		
		dec	e				//detecta en que cuarto de angulos está
		jp z,atan2q1
		dec	e
		jp z,atan2q2
		dec	e
		jp z,atan2q3
		
	atan2q0:
		//ld h,#_log2_tab / 256       //la tabla log2_tab está en 0x0200
		ld h,#LOG2_TAB_TABLE_PAGE
		ld l,b
		
		ld a,(hl)			// 32*log2(x)
		ld l,c
		
		sub	a,(hl)			// 32*log2(x/y)
		
		jr nc,atan2q01			// |x|>|y|
		neg				// |x|<|y|	A = 32*log2(y/x)
		
	atan2q01:		
		ld l,a

		//ld h,#_atan_tab / 256       //la tabla atan_tab está en 0x0300
		ld h,#ATAN_TAB_TABLE_PAGE
		ld a,(hl)
		ret	c			// |x|<|y|
		
		neg
		and	#0x3F			// |x|>|y|
		ret
				
	atan2q1:		
		ld a,b
		neg
		ld b,a
		call atan2q0
		neg
		and	#0x7F
		ret
		
	atan2q2:
		ld a,c
		neg
		ld c,a
		call atan2q0
		neg
		ret		
		
	atan2q3:		
		ld a,b
		neg
		ld b,a
		ld a,c
		neg
		ld c,a
		call atan2q0
		add	a,#128
		ret


		; align to byte
		
		//align 0x100
/*		
;		z=0:255; sprintf('%d,',fix(atan(2.^(z/32))*128/pi))

		;;;;;;;; atan(2^(x/32))*128/pi ;;;;;;;;
atan_tab:	
		db 020h,020h,020h,021h,021h,022h,022h,023h,023h,023h,024h,024h,025h,025h,026h,026h
		db 026h,027h,027h,028h,028h,028h,029h,029h,02Ah,02Ah,02Ah,02Bh,02Bh,02Ch,02Ch,02Ch
		db 02Dh,02Dh,02Dh,02Eh,02Eh,02Eh,02Fh,02Fh,02Fh,030h,030h,030h,031h,031h,031h,031h
		db 032h,032h,032h,032h,033h,033h,033h,033h,034h,034h,034h,034h,035h,035h,035h,035h
		db 036h,036h,036h,036h,036h,037h,037h,037h,037h,037h,037h,038h,038h,038h,038h,038h
		db 038h,039h,039h,039h,039h,039h,039h,039h,039h,03Ah,03Ah,03Ah,03Ah,03Ah,03Ah,03Ah
		db 03Ah,03Bh,03Bh,03Bh,03Bh,03Bh,03Bh,03Bh,03Bh,03Bh,03Bh,03Bh,03Ch,03Ch,03Ch,03Ch
		db 03Ch,03Ch,03Ch,03Ch,03Ch,03Ch,03Ch,03Ch,03Ch,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh
		db 03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Dh,03Eh,03Eh,03Eh,03Eh
		db 03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh
		db 03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Eh,03Fh,03Fh,03Fh,03Fh
		db 03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh
		db 03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh
		db 03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh
		db 03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh
		db 03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh,03Fh
 
 ;		x=0:255;x(1)=1; sprintf('%d,',fix(32*log2(x)))
 
		;;;;;;;; log2(x)*32 ;;;;;;;; 
log2_tab:  
		db 000h,000h,020h,032h,040h,04Ah,052h,059h,060h,065h,06Ah,06Eh,072h,076h,079h,07Dh
		db 080h,082h,085h,087h,08Ah,08Ch,08Eh,090h,092h,094h,096h,098h,099h,09Bh,09Dh,09Eh
		db 0A0h,0A1h,0A2h,0A4h,0A5h,0A6h,0A7h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh,0B0h,0B1h
		db 0B2h,0B3h,0B4h,0B5h,0B6h,0B7h,0B8h,0B9h,0B9h,0BAh,0BBh,0BCh,0BDh,0BDh,0BEh,0BFh
		db 0C0h,0C0h,0C1h,0C2h,0C2h,0C3h,0C4h,0C4h,0C5h,0C6h,0C6h,0C7h,0C7h,0C8h,0C9h,0C9h
		db 0CAh,0CAh,0CBh,0CCh,0CCh,0CDh,0CDh,0CEh,0CEh,0CFh,0CFh,0D0h,0D0h,0D1h,0D1h,0D2h
		db 0D2h,0D3h,0D3h,0D4h,0D4h,0D5h,0D5h,0D5h,0D6h,0D6h,0D7h,0D7h,0D8h,0D8h,0D9h,0D9h
		db 0D9h,0DAh,0DAh,0DBh,0DBh,0DBh,0DCh,0DCh,0DDh,0DDh,0DDh,0DEh,0DEh,0DEh,0DFh,0DFh
		db 0DFh,0E0h,0E0h,0E1h,0E1h,0E1h,0E2h,0E2h,0E2h,0E3h,0E3h,0E3h,0E4h,0E4h,0E4h,0E5h
		db 0E5h,0E5h,0E6h,0E6h,0E6h,0E7h,0E7h,0E7h,0E7h,0E8h,0E8h,0E8h,0E9h,0E9h,0E9h,0EAh
		db 0EAh,0EAh,0EAh,0EBh,0EBh,0EBh,0ECh,0ECh,0ECh,0ECh,0EDh,0EDh,0EDh,0EDh,0EEh,0EEh
		db 0EEh,0EEh,0EFh,0EFh,0EFh,0EFh,0F0h,0F0h,0F0h,0F1h,0F1h,0F1h,0F1h,0F1h,0F2h,0F2h
		db 0F2h,0F2h,0F3h,0F3h,0F3h,0F3h,0F4h,0F4h,0F4h,0F4h,0F5h,0F5h,0F5h,0F5h,0F5h,0F6h
		db 0F6h,0F6h,0F6h,0F7h,0F7h,0F7h,0F7h,0F7h,0F8h,0F8h,0F8h,0F8h,0F9h,0F9h,0F9h,0F9h
		db 0F9h,0FAh,0FAh,0FAh,0FAh,0FAh,0FBh,0FBh,0FBh,0FBh,0FBh,0FCh,0FCh,0FCh,0FCh,0FCh
		db 0FDh,0FDh,0FDh,0FDh,0FDh,0FDh,0FEh,0FEh,0FEh,0FEh,0FEh,0FFh,0FFh,0FFh,0FFh,0FFh
*/
	__endasm;
}



//calcula el angulo entre IX y IY (no contempla el tamaño de las entidades) (destruye todos los registros)
void vtAngleIXtoIY() __naked {
   __asm
      //hago una comprobacion rapida de que la diferencia entre OBJ_POSX+1 de uno y otro no sea mayor de 128 porke entonces cagaste


      ld h,OBJ_POSX+1(iy)
      ld l,OBJ_POSX(iy)
      srl h
      rr l
      srl h
      rr l
      ld d,OBJ_POSX+1(ix)
      ld e,OBJ_POSX(ix)
      srl d
      rr e
      srl d
      rr e
      xor a
      sbc hl,de
      ld b,h
      ld c,l         //diferencia X=BC

      ld h,OBJ_POSY+1(iy)
      ld l,OBJ_POSY(iy)
      srl h
      rr l
      srl h
      rr l
      ld d,OBJ_POSY+1(ix)
      ld e,OBJ_POSY(ix)
      srl d
      rr e
      srl d
      rr e
      xor a
      sbc hl,de
      ex de,hl       //diferencia Y=DE

      
      //la entrada es X=BC e Y=DE, y en A devuelve el angulo (256 based)
      call _vtAtan2_16     //pillo angulo en A

      ret
   __endasm;
}




//A pasamos el angulo (256 based), en B pasamos la velocidad, y devuelve en DE=cos(A)*B
void vtCosAdvance() __naked {
   __asm
      

      and #0b11111000      //nos quedamos con la parte alta del angulo

      ld d,a         //me guardo el angulo en D pa el final ponerlo todo en negativo o positivo  

      ld h,#COS_PARTIAL_TABLE_PAGE
      ld l,a
      xor a
      rl b                    //bit 7
      jr NC,vtCosAdvances2
      add (hl)
   vtCosAdvances2:
      inc l
      rl b                    //bit 6
      jr NC,vtCosAdvances3
      add (hl)
   vtCosAdvances3:
      inc l
      rl b                    //bit 5
      jr NC,vtCosAdvances4
      add (hl)
   vtCosAdvances4:
      inc l
      rl b                    //bit 4
      jr NC,vtCosAdvances5
      add (hl)
   vtCosAdvances5:
      inc l
      rl b                    //bit 3
      jr NC,vtCosAdvances6
      add (hl)
   vtCosAdvances6:
      inc l
      rl b                    //bit 2
      jr NC,vtCosAdvances7
      add (hl)
   vtCosAdvances7:
      inc l
      rl b                    //bit 1
      jr NC,vtCosAdvances8
      add (hl)
   vtCosAdvances8:
      inc l
      rl b                    //bit 0
      jr NC,vtCosAdvances9
      //ret NC                  //devuelvo en A la velocidad del coseno ajustada
      add (hl)

   vtCosAdvances9:
      ld e,a
      ld a,d         //recupero el angulo
      ld d,#0        //pongo D = 0 y E = al valor de la suma de los cosenos
      
      //y ahora lo que tengo que ver es si A>64 y A<192 entonces hago DE=0-DE para pasarlo a negativo
      add #64     //si le sumo 64 entonces tengo que ver si A>128 y A<256 o lo que es lo mismo, le puedo mirar el bit 7
      bit 7,a
      ret Z    //si es cero no tengo que negar nada y ya tengo el resultado en DE asi que pa fuera

      ld hl,#0    //si no es cero voy a hacer DE=0-DE
      xor a
      sbc hl,de
      ex de,hl

      ret                     //devuelvo en A la velocidad del coseno ajustada
   __endasm;
}


void vtSinAdvance() __naked {
   __asm
      sub #64        //le sumo 64 al angulo, y eso da lo mismo que si fuera el seno
      jp _vtCosAdvance
      //ret                     //devuelvo en A la velocidad del coseno ajustada
   __endasm;
}

/*
//A pasamos el angulo (256 based), en B pasamos la velocidad, y devuelve en A=sin(A)*B
void vtSinAdvance() __naked {
   __asm
      and #0b11111000      //nos quedamos con la parte alta del angulo
      ld h,#SIN_PARTIAL_TABLE_PAGE
      ld l,a
      xor a
      rl b                    //bit 7
      jr NC,vtSinAdvances2
      add (hl)
   vtSinAdvances2:
      inc l
      rl b                    //bit 6
      jr NC,vtSinAdvances3
      add (hl)
   vtSinAdvances3:
      inc l
      rl b                    //bit 5
      jr NC,vtSinAdvances4
      add (hl)
   vtSinAdvances4:
      inc l
      rl b                    //bit 4
      jr NC,vtSinAdvances5
      add (hl)
   vtSinAdvances5:
      inc l
      rl b                    //bit 3
      jr NC,vtSinAdvances6
      add (hl)
   vtSinAdvances6:
      inc l
      rl b                    //bit 2
      jr NC,vtSinAdvances7
      add (hl)
   vtSinAdvances7:
      inc l
      rl b                    //bit 1
      jr NC,vtSinAdvances8
      add (hl)
   vtSinAdvances8:
      inc l
      rl b                    //bit 0
      ret NC                  //devuelvo en A la velocidad del coseno ajustada
      add (hl)
      ret                     //devuelvo en A la velocidad del coseno ajustada
   __endasm;
}
*/
//HL pasamos la velocidad maxima, IX la entidad a ajustar, 
//si va más lento no hace nada, 
//si va rapido ajusta la velocidad speedX e speedY
void vtLimitSpeed() __naked {
   __asm
      push hl     //me lo guardo
      //entrada: BC diferencia horizontal, DE diferencia vertical
      //salida: BC distancia entre punto 0,0 y punto BC,DE
      ld c,OBJ_SPEEDX(ix)
      ld b,OBJ_SPEEDX+1(ix)
      ld e,OBJ_SPEEDY(ix)
      ld d,OBJ_SPEEDY+1(ix)
      call _vtDistance16

      xor a
      pop de
      ex de,hl
      sbc hl,de
      //              SALIDA RAPIDA VOY MÁS LENTO QUE EL MAXIMO CON LO QUE NO TENGO QUE AJUSTAR!!!!     -------------------------------------------------------------
      ret NC      //si a la velocidad maxima le resto la velocidad actual y no hay carry, es que estamos en el rango, no tenemos que hacer ná 



      //si llego aqui hay que ajustar la velocidad con HL que es la maxima
      add hl,de      //vuelvo a poner HL como estaba sumandole lo que le he restado


      //ahora tengo que saber en que angulo voy (voy a calcular el ATAN2)
      ld c,OBJ_SPEEDX(ix)
      ld b,OBJ_SPEEDX+1(ix)
      ld e,OBJ_SPEEDY(ix)
      ld d,OBJ_SPEEDY+1(ix)

   
      push hl        //no quiero perder hl
      //X=BC, Y=DE, devuelve en A el angulo (256 based)
      call _vtAtan2_16     //calculo el angulo en A
      pop hl      //recupero hl velocidad maxima

      //y ahora que ya tengo el angulo en A, calculo con la velocidad maxima y el angulo la velocidad X e Y que deberia tener

      //de momento vamos a dar por hecho que H no lo vamos a usar... de momento
      push hl
      push af
      ld b,l
      //A pasamos el angulo (256 based), en B pasamos la velocidad, y devuelve en DE=sin(A)*B
      call _vtCosAdvance

      ld OBJ_SPEEDX(ix),e
      ld OBJ_SPEEDX+1(ix),d

   vtLimitSpeedAjustaVelParaAngulo5:
      pop af
      pop hl

      ld b,l
      //A pasamos el angulo (256 based), en B pasamos la velocidad, y devuelve en DE=sin(A)*B
      call _vtSinAdvance
      ld OBJ_SPEEDY(ix),e
      ld OBJ_SPEEDY+1(ix),d

   vtLimitSpeedAjustaVelParaAngulo7:
      ret
   __endasm;
}



//A pasamos el angulo, B pasamos la velocidad, IX la entidad a ajustar (la velocidad puede ser de 0 a 255)
//se realizara una interpolacion entre la velocidad que queremos y la que llevamos usando C (valor de 1 a 15) siendo 1 
//la interpolacion más rapida, y 15 la más lenta (se puede usar para hacer derrapar el coche o resbalar)
//ejemplo: A=64 angulo hacia arriba, B=128 pixeles, C=4 interpolacion rapidita (se sumara 4 veces la velocidad que llevas y 12 la velocidad deseada y se dividirá entre 16)
void vtAccelToSpeedAng() __naked {
   __asm
      //como ya tengo en A el angulo y en B la velocidad, simplemente me los guardo para no petarlos y llamo al vtCosAdvance
      ld (#vtatsaAngle),a        //GUARDAMOS LOS VALORES EN VARIABLES PARA RECUPERARLOS DESPUES

      //pequeño check rapido, si la velocidad es 0 tal cual, pillamos la velocidad actual y la dividimos entre 2 para que tienda a 0, 
      //sino sera muy complicado que tienda a 0
      xor a    //A=0
      or b     //B or 0 = 0 ?  es velocidad = 0 ?
      jr NZ,vtAccelToSpeedAngs4

      ld l,OBJ_SPEEDX(ix)           //si la velocidad es 0, no me complico la vida, divido entre 2 la velocidad actual y esta ira tendiendo a 0 poco a poco
      ld h,OBJ_SPEEDX+1(ix)
      sra h    //divido entre 2 la velocidad  (division con negativos tambien)
      rr l
      ld OBJ_SPEEDX(ix),l
      ld OBJ_SPEEDX+1(ix),h

      ld l,OBJ_SPEEDY(ix)           //si la velocidad es 0, no me complico la vida, divido entre 2 la velocidad actual y esta ira tendiendo a 0 poco a poco
      ld h,OBJ_SPEEDY+1(ix)
      sra h    //divido entre 2 la velocidad  (division con negativos tambien)
      rr l
      ld OBJ_SPEEDY(ix),l
      ld OBJ_SPEEDY+1(ix),h

      
      ret



   vtAccelToSpeedAngs4:
      ld a,b
      ld (#vtatsaSpeed),a
      ld a,c
      ld (#vtatsaLERP),a
      ld a,(#vtatsaAngle)        //recupero en A el angulo para el vtCosAdvance

   
   
   
   
   
      //AJUSTAMOS LA VELOCIDAD HORIZONTAL
      call _vtCosAdvance   //tengo en DE el resultado
      ex de,hl          //multiplico por 2?
      add hl,hl
      ex de,hl       

      ld c,OBJ_SPEEDX(ix)        //cargo en BC la velocidad X actual
      ld b,OBJ_SPEEDX+1(ix)

      call vtAccelToSpeedAngLERP

      ld OBJ_SPEEDX(ix),l        //cargo en BC la velocidad X actual
      ld OBJ_SPEEDX+1(ix),h






      ld a,(#vtatsaSpeed)
      ld b,a
      ld a,(#vtatsaAngle)

      call _vtSinAdvance   //tengo en DE el resultado
      ex de,hl          //multiplico por 2?
      add hl,hl
      ex de,hl       

      ld c,OBJ_SPEEDY(ix)        //cargo en BC la velocidad X actual
      ld b,OBJ_SPEEDY+1(ix)

      call vtAccelToSpeedAngLERP

      ld OBJ_SPEEDY(ix),l        //cargo en BC la velocidad X actual
      ld OBJ_SPEEDY+1(ix),h

      ret







   vtAccelToSpeedAngLERP:
      ld hl,#0

      ld a,(#vtatsaLERP)

   vtAccelToSpeedAngbuc1:
      add hl,bc
      dec a
      jr NZ,vtAccelToSpeedAngbuc1

      ld a,(#vtatsaLERP)
      neg
      add #32

   vtAccelToSpeedAngbuc2:
      add hl,de
      dec a
      jr NZ,vtAccelToSpeedAngbuc2
      

      sra h    //divido entre 2 la velocidad  (division con negativos tambien)
      rr l
      sra h    //divido entre 4 la velocidad
      rr l
      sra h    //divido entre 8 la velocidad
      rr l
      sra h    //divido entre 16 la velocidad
      rr l
      sra h    //divido entre 32 la velocidad
      rr l

      ret








   vtatsaAngle:
      .db 0

   vtatsaSpeed:
      .db 0
   
   vtatsaLERP:
      .db 0

   
   __endasm;
}


//Devuelve en H el numero de metatile que esta en B eje X y C eje Y
u8 vtCheckMetaTileAsm() __naked {
   __asm
      //genero el desplazamiento del eje Y   HL=(B AND 0b11111000)*4
      ld a,#0b11111000
      and c
      ld l,a
      //ld h,#0
      ld h,#SCENE_START_MEM_HI_DIV4
      add hl,hl      //x2
      add hl,hl      //x4
      //inc h
		dec h				//le resto 1 a H para que en vez de ser AC sea AB osea SCENE_START_MEM

      
      //genero el desplazamiento del eje X   HL=HL + ( (C AND 0b11111000) / 8 )
      ld a,#0b11111000
      and b
      rrca
      rrca
      rrca     //entre 8
      or l           //como no se cruzan los bits podemos hacer un or de L y A y es lo mismo que la suma pero más rapido
      ld l,a
      


      //genero el desplazamiento del comienzo del escenario    HL=HL + SCENE_START_MEM
      //ld a,#SCENE_START_MEM_HI      //hago la suma de donde empieza el escenario y lo que ya tengo en H para calcular el metatile en el que estoy
      //add h
      //ld h,a
      
      //y ya tengo el HL apuntando al metatile, lo leo en A
      ld h,(hl)
      dec h

      ret
   __endasm;
}


//Devuelve en L el numero de tile que esta en B eje X y C eje Y
//si ya sabes el metatile, puedes llamar directamente a vtCheckTileAsm2 con el metatile en H
u8 vtCheckTileAsm() __naked {
   __asm
      call _vtCheckMetaTileAsm

   vtCheckTileAsm2:
      xor a
	   sra h       //entre 2
      rra
      sra h       //entre 4
      rra
      ld l,a
      

	   //ld de,(#_vtMetaTileSetPtr) 		//pregunto por el puntero a los metatiles
      ld de,#METATILE_START_MEM
      add hl,de



      //ahora tengo que sacar metatilelist [ A ] [  ((((vtSceneScrollY+rtaEjeY)%8)*8)+((vtSceneScrollX+rtaEjeX)%8))   ] 
      //o lo que es lo mismo DE [  (((( B )%8)*64)+(( C )%8))   ]
      //ld a,(#_rtaEjeYtemp)
      ld a,#7
      and c
      rlca
      rlca
      rlca
      ld d,a      //me lo guardo en D que no tengo nada ahora mismo

      //ld a,(#_rtaEjeXtemp)
      ld a,#7
      and b
      add d
      add l
      jr NC,checkTileBCXYs2
      inc h
   checkTileBCXYs2:
      ld l,a      //ya tengo HL apuntando al tile en el que estoy
      
      ld l,(hl)

      ret
   __endasm;
}





//ponemos los limites en BC y DE (x1 y1 x2 y2) incluidos, 
//y en H ponemos el maximo metatile, 
//y en L el maximo tile si el metatile es mayor de H
u8 vtCheckTileZoneAsm() __naked {
   __asm

      //hago bucle vertical
   vtCheckTileZoneAsmBucleVerticalStart:


      push bc     //+1
   vtCheckTileZoneAsmBucleHorizontalStart:
      
      //primero miro si el metatile es menor que H
      push de     //+2
      push bc     //+3
      push hl     //+4

      call _vtCheckMetaTileAsm    //llamo a esta que me va a colocar HL en el primer tile que tengo que mirar
      ld a,h   //meto el metatile en A      
      pop hl      //recupero HL     //+3
      cp H
      jr C,vtCheckTileZoneAsmBucleHorizontalSec2
      //si entro aqui es que el metatile podría tener colisiones, tengo que mirar ahora el tile concreto

      push hl     //+4
      push de     //+5
      push bc     //+6
      ld h,a      //pongo en H el metatile
      call vtCheckTileAsm2
      ld a,l
      pop bc      //+5
      pop de      //+4
      pop hl      //+3

      cp l
      jr C,vtCheckTileZoneAsmBucleHorizontalSec2

      ld a,b
      ld (#_vtColisionLastX),a      //indico que la colision ha sido en 0,0 (osea que no ha habido colision)
      ld a,c
      ld (#_vtColisionLastY),a

      //si llego aqui es que justo en este tile estoy colisionando con algo, salgo 
      //y ya tengo en L el tile con el que estoy colisionando y en BC donde estoy colisionando
      pop bc      //recupero la pila en su lugar y salgo    //+2
      pop de      //+1
      pop bc      //+0
      ret

   vtCheckTileZoneAsmBucleHorizontalSec2:

      pop bc      //+2
      pop de      //+1




   vtCheckTileZoneAsmBucleHorizontalEnd:
      inc b
      ld a,b
      cp d
      jr NZ,vtCheckTileZoneAsmBucleHorizontalStart


   vtCheckTileZoneAsmBucleVerticalEnd:
      pop bc      //+0
      inc c
      ld a,c
      cp e
      jr NZ,vtCheckTileZoneAsmBucleVerticalStart

      //he acabao y no ha habido coli
      
      xor a
      ld l,a
      ld (#_vtColisionLastX),a      //indico que la colision ha sido en 0,0 (osea que no ha habido colision)
      ld (#_vtColisionLastY),a
      ret

   __endasm;
}



//setea la fuente que se va a usar (hay que apuntar a la primera letra 32-espacio) las letras son de 2 bytes por 6 lineas (minimum font)
//mete el puntero en vtPointerAux y esta funcion prepara la fuente
void vtSetFont() __naked {
	__asm
      ld hl,(#_vtPointerAux)
      ld (#vtDrawStringSetFont+1),hl
      ret
   __endasm;
}


//devuelve en A el tamaño de la cadena a la que este apuntando HL
void vtGetLengthHL() __naked {
	__asm

      push hl
      ld b,#0

   vtGetLengthHLBucle:
      ld a,(hl)
      inc hl
      inc b
      or a
      jr NZ,vtGetLengthHLBucle

      pop hl

      ld a,b

      ret
   __endasm;
}

//vtStringPtr   que cadena vamos a pintar
//vtScreenPtr  puntero al lugar donde vamos a pintar
//vtDrawSpriteCustomColor1   color que se va a usar de foreground         //se hará un and con este valor (los 2 pixeles) antes de dibujar
void vtDrawString() __naked {
	__asm
		vtDrawStringStart:
			//;direccion de la cadena
			ld bc, (#_vtStringPtr)
			
			//;me guardo en la pila por donde vamos pintando
			ld de, (#_vtScreenPtr)
			push de
			
		vtDrawStringBucleCheckCaracter:
			ld a,(bc)
			or a
			jp Z,vtDrawStringBucleFin

			;pintamos el byte de este caracter de bc
			sub #32
			;tenemos en a el desplazamiento de gra_minifont
			
			
			//como solo hay 59 caracteres, puedo hacer la multiplicación (o el principio por lo menos con un solo byte)
			ld h,#0
			ld l,a   //meto L=A   (a debe estar entre 0 y 59)
			add a	//multiplico A por 2   (ahora A debe estar entre 0 y 118)
			add l	//le sumo L ahora A debe estar entre 0 y 177)  (ya eso hace el x3)
         ld l,a      //preparo ya HL
         add hl,hl      //multiplico x6
         add hl,hl      //multiplico x12			
			
      vtDrawStringSetFont:
			//ld de, #_spr_minifont_00      //apunto DE a la primera letra (al espacio en blanco)
         ld de,#0
			add hl,de
         
			;tengo en hl donde empiezan los bytes del caracter
			;ahora voy a situarme en la pantalla con de
			pop de
			inc de 
         inc de
			;meto en la pila el siguiente byte
			push de
			dec de
         dec de
			

         push bc     //me guardo BC y hago bucle
         

      vtDrawStringBucleWriteBytes:
			ld a,(#_vtDrawSpriteCustomColor1)
         ld c,a      //meto el mask del color en C
         //.dw 0x6FDD     //ld ixl,a        

         //meto en BC el puntero al sprite
         //ld b,h
         //ld c,l
         //meto en HL el puntero a la tabla de mascaras (0x6B00)
         //ld h,#0x6B
         //ld h,#MASK_TABLE
         //meto en DE el puntero a la pantalla (ya lo tengo de antes)


         ld b,#6
      vtDrawStringBucleWriteBytesBucle:
         ld a,c
         and (hl)    //hago C AND (HL sprite)
         ld (de),a      //y lo escribo en la pantalla
         inc hl 
         inc de
         ld a,c
         and (hl)
         ld (de),a
         inc hl 
         dec de

         ld a,#8     //paso a la siguiente linea y le resto 1 
         add d
         ld d,a 

         djnz vtDrawStringBucleWriteBytesBucle

     

			//paso al siguiente caracter y repito
         pop bc
			inc bc
			jp vtDrawStringBucleCheckCaracter

		vtDrawStringBucleFin:
			pop de      //libero la pila
			
		vtDrawStringExit:
			ret
	__endasm;
}











/*

const u8 g_flipTable[256]={
   0x00,0x02,0x01,0x03,0x08,0x0A,0x09,0x0B,0x04,0x06,0x05,0x07,0x0C,0x0E,0x0D,0x0F,0x20,0x22,0x21,0x23,0x28,0x2A,0x29,0x2B,0x24,0x26,0x25,0x27,0x2C,0x2E,0x2D,0x2F,0x10,0x12,0x11,0x13,0x18,0x1A,0x19,0x1B,0x14,0x16,0x15,0x17,0x1C,0x1E,0x1D,0x1F,0x30,0x32,0x31,0x33,0x38,0x3A,0x39,0x3B,0x34,0x36,0x35,0x37,0x3C,0x3E,0x3D,0x3F,0x80,0x82,0x81,0x83,0x88,0x8A,0x89,0x8B,0x84,0x86,0x85,0x87,0x8C,0x8E,0x8D,0x8F,0xA0,0xA2,0xA1,0xA3,0xA8,0xAA,0xA9,0xAB,0xA4,0xA6,0xA5,0xA7,0xAC,0xAE,0xAD,0xAF,0x90,0x92,0x91,0x93,0x98,0x9A,0x99,0x9B,0x94,0x96,0x95,0x97,0x9C,0x9E,0x9D,0x9F,0xB0,0xB2,0xB1,0xB3,0xB8,0xBA,0xB9,0xBB,0xB4,0xB6,0xB5,0xB7,0xBC,0xBE,0xBD,0xBF,0x40,0x42,0x41,0x43,0x48,0x4A,0x49,0x4B,0x44,0x46,0x45,0x47,0x4C,0x4E,0x4D,0x4F,0x60,0x62,0x61,0x63,0x68,0x6A,0x69,0x6B,0x64,0x66,0x65,0x67,0x6C,0x6E,0x6D,0x6F,0x50,0x52,0x51,0x53,0x58,0x5A,0x59,0x5B,0x54,0x56,0x55,0x57,0x5C,0x5E,0x5D,0x5F,0x70,0x72,0x71,0x73,0x78,0x7A,0x79,0x7B,0x74,0x76,0x75,0x77,0x7C,0x7E,0x7D,0x7F,0xC0,0xC2,0xC1,0xC3,0xC8,0xCA,0xC9,0xCB,0xC4,0xC6,0xC5,0xC7,0xCC,0xCE,0xCD,0xCF,0xE0,0xE2,0xE1,0xE3,0xE8,0xEA,0xE9,0xEB,0xE4,0xE6,0xE5,0xE7,0xEC,0xEE,0xED,0xEF,0xD0,0xD2,0xD1,0xD3,0xD8,0xDA,0xD9,0xDB,0xD4,0xD6,0xD5,0xD7,0xDC,0xDE,0xDD,0xDF,0xF0,0xF2,0xF1,0xF3,0xF8,0xFA,0xF9,0xFB,0xF4,0xF6,0xF5,0xF7,0xFC,0xFE,0xFD,0xFF
};
*/

void vtCreateOptimizationTables() __naked {
	__asm
      //vamos a crear el accelTileTable   ----------------------------------------------------------------------
      ld a,#254
      ld bc,#0x0010
      ld de,#0x8B00
      ld hl,#0xB200

      ld (hl),e      //los dos primeros valores son iguales 0x0100
      inc hl 
      ld (hl),d 
      inc hl

      ld (hl),e 
      inc hl 
      ld (hl),d 
      inc hl

      //los siguientes ya son sumandoles 0x0010 
   gtaCreateOptimizationTablesCreateAcelTableBucle:
      ex de,hl
      add hl,bc
      ex de,hl

      ld (hl),e      //los dos primeros valores son iguales 0x0100
      inc hl 
      ld (hl),d 
      inc hl

      dec a 
      jr NZ,gtaCreateOptimizationTablesCreateAcelTableBucle



      //vamos a crear la flip table   ----------------------------------------------------------------------
      
      ld b,#0
      ld hl,#0xB400
   gtaCreateOptimizationTablesCreateFlipTableBucle:
      xor a
      bit 0,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles1
      set 1,a

   gtaCreateOptimizationTablesCreateFlipTableBucles1:
      bit 1,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles2
      set 0,a

   gtaCreateOptimizationTablesCreateFlipTableBucles2:
      bit 2,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles3
      set 3,a

   gtaCreateOptimizationTablesCreateFlipTableBucles3:
      bit 3,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles4
      set 2,a

   gtaCreateOptimizationTablesCreateFlipTableBucles4:
      bit 4,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles5
      set 5,a

   gtaCreateOptimizationTablesCreateFlipTableBucles5:
      bit 5,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles6
      set 4,a

   gtaCreateOptimizationTablesCreateFlipTableBucles6:
      bit 6,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles7
      set 7,a

   gtaCreateOptimizationTablesCreateFlipTableBucles7:
      bit 7,b
      jr Z,gtaCreateOptimizationTablesCreateFlipTableBucles8
      set 6,a

   gtaCreateOptimizationTablesCreateFlipTableBucles8:
      ld (hl),a 
      inc hl 
      inc b
      jr NZ,gtaCreateOptimizationTablesCreateFlipTableBucle




      ret
	__endasm;
}

/*
void trapIX() __naked {
	__asm
      push af
      push hl
      push de
      ld a,#15
      .dw 0xA5DD     //and ixl
      jr NZ,trapIXerror
      
      
      ld hl,(#_vtGameObjPtr)
      push ix
      pop de
      xor a
      sbc hl,de
      jr NZ,trapIXerror
      
      pop de
      pop hl
      pop af
		ret

   trapIXerror:
      pop de
      pop hl
      pop af
      exx
      exx
      ret
	__endasm;
}
*/

/*
void trapSPinit() __naked {
	__asm
      ld (#trapSPsaveSP),sp
      ret

   trapSPsaveSP:
      .dw #0

   trapSPtemp:
      .dw #0
	__endasm;
}
void trapSPend() __naked {
	__asm
      ld (#trapSPtemp),sp

      push af
      push de
      push hl

      ld de,(#trapSPtemp)


      ld hl,(#trapSPsaveSP)        //leo que valor tenia la pila cuando la guarde
      xor a 
      sbc hl,de                     //resto
      jr NZ,trapSPendError          //y si no es cero es que no va correcto, he metio o sacado algo más de la cuenta

      

      
      pop hl
      pop de         //si entra aki todo correcto, recuperamos de y hl y pa fuera
      pop af

      ret

   trapSPendError:
      pop hl 
      pop de 
      pop af
      exx
      exx
      ret
	__endasm;
}
*/
#endif